/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Animable.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Animable'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _ANIMABLE_H
#define _ANIMABLE_H

//@START_USER1
#include "Evaluable.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_1422
class ...
*/

class AFX_EXT_CLASS Animable
    : public Evaluable
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: animation
//

public:
    virtual double getDureeAnim(std::string anim) = 0;
    virtual void setDureeAnim(std::string anim, double duree) = 0;
    virtual void startAnimation(std::string nom) = 0;
    virtual void stopAnimation(std::string nom) = 0;

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//

public:
    Animable(BD* pBD);
    virtual ~Animable();
};

#endif


#ifdef CB_INLINES
#ifndef _ANIMABLE_H_INLINES
#define _ANIMABLE_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
