/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          BD.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'BD'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "BD.h"
#include "Evaluable.h"
#include "ThreadSdl.h"
#include "MoteurJeuC.h"
#include "Texte.h"


namespace cooki3d{
//@END_USER2


// Static members
BD::listAdr BD::_bdList;


/*@NOTE_273
Constructor method.
*/
BD::BD(LoaderGeneric* loader) //@INIT_273
    : _loader(loader)
{//@CODE_273
  
  ConstructorInclude();  

  CINFOs<<"BD creation adr="<<this<<" int(adr)="<<int(this)<<endl;
    //<<" thread="<<SDL_ThreadID()<<endl;
  _bdList.push_back( this );
    
}//@CODE_273


/*@NOTE_268
Destructor method.
*/
BD::~BD()
{//@CODE_268
  
  //assertC(_pBD);
    
    
  //On oubli  DestructorInclude car l'on veut détruire les entitées
  //dans un certain ordre (surtout les librairies en dernier...)
  if (false) {
    DestructorInclude();
  }
  else {
    eraseAll();
    CINFOs<<"BD delete adr="<<this<<" int(adr)="<<int(this)<<endl;
      //<<" thread="<<SDL_ThreadID()<<endl;

    for (unsigned int i = 0; i< _bdList.size(); i++){
      if ( _bdList[i] ==  this){
	CINFOs<<"BD delete adr="<<this<<" from list!"<<endl;
	_bdList.erase( _bdList.begin()+i );
	return ;
      }
    }
  }
  
  
    
}//@CODE_268


bool BD::checkAdrBD(BD* pBD)
{//@CODE_5042
  
  for (BD::listAdr::iterator it = _bdList.begin();
       it != _bdList.end();
       it++){
    if ( *it ==  pBD){
      return true;
    }
  }
  return false;

}//@CODE_5042


bool BD::checkAllInstances()
{//@CODE_4313

  BD::EvaluableIterator itEval(this);
  
  Evaluable * evalu;

  bool resultOk = true;
   
  while (++itEval){
    
    evalu= itEval.Get();//dynamic_cast<Evaluable *>(itEval.Get());
    
    if (evalu && evalu->getName() != "staticLoader") {
      resultOk = resultOk && evalu->check();
    }

  }
   
  return resultOk;
}//@CODE_4313


void BD::eraseAll()
{//@CODE_769
  
  /*if (_pBD == NULL){
    return;
    }*/

  //TODO persistance??
  CTRACEs("BD::eraseAll")<<" Toutes les entitées Evaluables "
			 <<"vont êtres arretées et effacées!!"<<endl;
  CTRACEs("BD::eraseAll")<<"Cela engrendre l'effacement en cascade"
			 <<" de toutes les entitées pour "<</*_pBD*/this
			 <<" int(adr)="<<int(this)<<endl;
  EvaluableIterator iEvaluable(/*_pBD*/this);
  ThreadSdl * ts;
  MoteurJeuC * mjc;
  while (++iEvaluable) {
 
    //arrêt des threads
    //héritage Threadd à éventuellement amélioré
    ts=dynamic_cast<ThreadSdl*>(iEvaluable.Get());
    if (ts){
      ts->kill();
    }	  
      
    //effacement de l'evaluable s'il n'est pas un plugin ou un osg::Text
    mjc = dynamic_cast<MoteurJeuC*>(iEvaluable.Get());
    if ( mjc == NULL  &&   
	 dynamic_cast<Texte*>(iEvaluable.Get())==NULL ){    
      
      if ( ! iEvaluable.Get()->isNoDeleteFlag() ){
	delete iEvaluable.Get();      
      }
    }    
    
  }

  //maintenant on efface les MoteurJeuC (plugins)
  iEvaluable.Reset();
  while (++iEvaluable) {
    //sauf les cooki::Texte car osg::Text est référencé par osg (héritage)
    if (dynamic_cast<Texte*>(iEvaluable.Get()) == NULL ){ 
      
      if ( ! iEvaluable.Get()->isNoDeleteFlag() ){
	delete iEvaluable.Get();
      }
    }
  }

  //delete _pBD; //=>normalement pour CB
  //engrendre l'effacement en cascade de toutes les entitées
  //mais le comportement a été volontairement modifié...
  //car l'on veut détruire les entitées
  //dans un certain ordre (surtout les librairies en dernier...)
  //_pBD=NULL;
  
}//@CODE_769


Evaluable* BD::FindEvaluable(std::string name)
{//@CODE_384
    EvaluableIterator iEvaluable(this);
    while (++iEvaluable)
    {
        if (name == iEvaluable->getName())
        {
            return iEvaluable;
        }
    }
    CERR(this,"FindEvaluable")<<" la recherche de \""
			      <<name<<"\" a échouée "
			      <<"l' objet n'existe pas dans la base "
			      <<this<<endl;
    CERRnext<<"INFO: les entités disponibles sont : "<<endl;
    while (++iEvaluable)
    {      
      CERRnext<<iEvaluable->getName()<<endl<<flush;
    }
    std::string os;
    printStackTrace( os );
    CERRnext<< os;
    //assertC(0);
    return 0;
}//@CODE_384


EnvironnementOSG* BD::getEnv()
{//@CODE_4857
    return _loader->getEnv();
}//@CODE_4857


MainApp* BD::getMainApp()
{//@CODE_5129
    return _loader->getMainApp();
}//@CODE_5129


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_269
Method which must be called first in a constructor.
*/
void BD::ConstructorInclude()
{
    INIT_MULTI_OWNED_ACTIVE(BD, BD, Evaluable, Evaluable)
}


/*@NOTE_270
Method which must be called first in a destructor.
*/
void BD::DestructorInclude()
{
    EXIT_MULTI_OWNED_ACTIVE(BD, BD, Evaluable, Evaluable)
}


// Methods for the relation(s) of the class
METHODS_MULTI_OWNED_ACTIVE(BD, BD, Evaluable, Evaluable)
METHODS_ITERATOR_NOFILTER_MULTI_ACTIVE(BD, BD, Evaluable, Evaluable)

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
