/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          BD.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'BD'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _BD_H
#define _BD_H

//@START_USER1
#include <vector>
#include <SDL/SDL_thread.h>

#include "Evaluable.h"


using namespace std;


namespace cooki3d{
  class MainApp;
//@END_USER1


/*@NOTE_267
class...
*/

class AFX_EXT_CLASS BD
{
    RELATION_NOFILTER_MULTI_OWNED_ACTIVE(BD, BD, Evaluable, Evaluable)

//@START_USER2
public :
    //typedef map<Uint32,cooki3d::BD*,less<Uint32 > > mapThreadAdr;      
    typedef std::vector<cooki3d::BD*> listAdr;

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    static BD::listAdr _bdList;

protected:
    LoaderGeneric* _loader;

//
// Non-Grouped Methods
//

public:
    BD(LoaderGeneric* loader);
    virtual ~BD();
    static bool checkAdrBD(BD* pBD);
    bool checkAllInstances();
    void eraseAll();
    Evaluable* FindEvaluable(std::string name);
    EnvironnementOSG* getEnv();
    MainApp* getMainApp();
    LoaderGeneric* getLoader() const;
};

#endif


#ifdef CB_INLINES
#ifndef _BD_H_INLINES
#define _BD_H_INLINES

/*@NOTE_4837
Returns the value of member '_loader'.
*/
inline LoaderGeneric* BD::getLoader() const
{//@CODE_4837
    return _loader;
}//@CODE_4837



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
