/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Camera.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Camera'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "Evaluable.h"
#include "Camera.h"
#include "XMLUtil.h"
#include <osg/Transform>
#include <osg/PositionAttitudeTransform>


#include <osg/NodeVisitor>
#include <osg/Referenced>
#include <osg/Drawable>
#include <osg/Geode>


class CalculView {
  
public :
  osg::Matrix transfo;
  
  void apply(osg::Node * n){
    
    osg::PositionAttitudeTransform * pat=dynamic_cast<osg::PositionAttitudeTransform*>(n);

    //cerr<<"slt n "<<n->getName()<<endl;

    if (pat){      
    
      /*
	osg::PositionAttitudeTransform * localPat =new osg::PositionAttitudeTransform();    
	
	localPat->setPosition(pat->getPosition());
	localPat->setAttitude(pat->getAttitude());
	
    
	//on fait une correction du quaternion pour que ca marche
	osg::Quat p = const_cast<osg::Quat &>(localPat->getAttitude());
	p.z() = -p.z();
	p.y() = -p.y();
	p.x() = -p.x();
	
      */
      osg::Matrix localTransfo;
      /*localPat*/pat->computeLocalToWorldMatrix(localTransfo,NULL);
      
      
      transfo = osg::Matrix::inverse(localTransfo) * transfo;           
      
      //cerr<<"apply sur !!"<<endl;
      
    }

    if ( n->getNumParents()>0){
      //cerr<<"n->getNumParents()="<<n->getNumParents()<<endl;
      //cerr<<"n->getParent(0)->getName()="<<n->getParent(0)->getName()<<endl;
      apply(n->getParent(0));
    }
    
    // cerr<<"slt n "<<n->getName()<< " fin"<<endl;
  }
};





namespace cooki3d{
//@END_USER2


// Static members
MapRegister<Camera*> Camera::_register;


/*@NOTE_1215
Constructor method.
*/
Camera::Camera(BD* pBD) //@INIT_1215
    : Evaluable(pBD)
    , _nodeName("")
    , _tNode()
{//@CODE_1215
    ConstructorInclude();

    // Put in your own code
}//@CODE_1215


/*@NOTE_1210
Destructor method.
*/
Camera::~Camera()
{//@CODE_1210
    DestructorInclude();

    _register.getRegister( getBD() ).remove( getName() );

}//@CODE_1210


/*@NOTE_4083
Check the integritry of the object
*/
bool Camera::check()
{//@CODE_4083
    bool resultOk = _tNode != NULL;

    if (!resultOk){
      CERR(this,"check")<<getName()<<":"<<getNodeName()
			<<" is not linked !!"<<endl;
    }
    
    return resultOk;
}//@CODE_4083


bool Camera::checkAllInstances(LoaderGeneric* loader)
{//@CODE_4082

  Register<Camera*> & reg = _register.getRegister( loader->getBD() );
  Register<Camera*>::iterator it  = reg.begin();
  Camera * cam=NULL;
  bool resultOk = true;
  
  while ( it != reg.end() ){
    
    cam = it->second;

    if (cam && cam->getName() != "staticLoader") {
      resultOk = resultOk && cam->check();
    }
    it++;
  }
   
  return resultOk;
}//@CODE_4082


Camera* Camera::getCamera(BD* pBD, const std::string camName)
{//@CODE_1236

  return _register.getRegister( pBD )[ camName ];

}//@CODE_1236


Camera* Camera::getFirstCamera(BD* pBD)
{//@CODE_4364

  return _register.getRegister( pBD ).getFirstItem();

}//@CODE_4364


Camera* Camera::getLastCamera(BD* pBD)
{//@CODE_4365

  return _register.getRegister( pBD ).getLastItem();

}//@CODE_4365


Camera* Camera::getNextCamera(BD* pBD, std::string camName)
{//@CODE_4366

    return _register.getRegister( pBD ).getNextItem(camName);

}//@CODE_4366


osg::Matrix Camera::getViewMatrix()
{//@CODE_1895

  CalculView cv;
  cv.apply(getTNode());
  return cv.transfo;
  //osg::Matrix::inverse(cv.transfo);
  
}//@CODE_1895


bool Camera::linkCamera(osg::Node* n, const std::string& pickName,
                        LoaderGeneric* loader)
{//@CODE_1222

  //BD::EvaluableIterator itCam(loader->getBD());
  //Camera * cam;

  bool res=false;
  Register<Camera*> & reg = _register.getRegister( loader->getBD() );
  Register<Camera*>::iterator it = reg.begin();
  Camera * cam=NULL;
  
  while ( it != reg.end() ){
    
    cam = it->second;
    it++;

    if (cam && (cam->getNodeName() == pickName))
    {
      if ( ! cam->getTNode())
      {
          cam->setTNode(static_cast<osg::PositionAttitudeTransform*>(n));
	  //on fait une correction du quaternion pour que ca marche
	  osg::Quat & p = const_cast<osg::Quat &>(cam->getTNode()->getAttitude());
	  p.z() = -p.z();
	  p.y() = -p.y();
	  p.x() = -p.x();

	  ///CameraVisitor cv;
	  
	  //n->accept(cv);
	  CTRACEs("Camera::linkCamera")<<" typeid du noeud liée="<<typeid(*n).name()<<endl;

	  /*osg::Geode* geo=new osg::Geode();
	  geo->addDrawable(new DummyDrawable());
	  n->asGroup()->addChild(geo);*/

          res=true;
      }
    }
  }
  return res;

}//@CODE_1222


bool Camera::load()
{//@CODE_4363
    _register.getRegister( getBD() ).add( getName(), this );
    
    return true;
}//@CODE_4363


bool Camera::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_1216
  CTRACE(this,"loadCamera")<<"&&&&&&&&&&&&&&&& entrée"<<endl;


  XMLUtil xml(node);

  setName(xml.getFirstText("nom"));  

  setNodeName(xml.getFirstText("node"));  

  return load();
}//@CODE_1216


Evaluable* Camera::staticCreate(BD* pBD)
{//@CODE_3040
    return new Camera(pBD);
}//@CODE_3040


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1211
Method which must be called first in a constructor.
*/
void Camera::ConstructorInclude()
{
}


/*@NOTE_1212
Method which must be called first in a destructor.
*/
void Camera::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d


//"POUBELLE"

// class CameraVisitor : public osg::NodeVisitor
// {
// public:

//   osg::Matrix transfo;
  
//   CameraVisitor()
//   { 
//     init();
//   }
  
//   void init(){
//     setTraversalMode(osg::NodeVisitor::TRAVERSE_PARENTS);
    
//   }
  
  
//   ~CameraVisitor(){}

//   virtual void apply(osg::Transform & t){
//     cerr<<"slt t "<<t.getName()<<endl;

//   }
  
//   virtual void apply(osg::PositionAttitudeTransform& pat)
//   { 
   
//     cerr<<"slt pat "<<pat.getName()<<endl;
    
//     osg::PositionAttitudeTransform * localPat =new osg::PositionAttitudeTransform();
    
    
//     localPat->setPosition(pat.getPosition());
//     localPat->setAttitude(pat.getAttitude());

    
//     //on fait une correction du quaternion pour que ca marche
//     osg::Quat p = const_cast<osg::Quat &>(localPat->getAttitude());
//     p.z() = -p.z();
//     p.y() = -p.y();
//     p.x() = -p.x();


//     osg::Matrix localTransfo;
//     localPat->computeLocalToWorldMatrix(localTransfo,NULL);


//     transfo = localTransfo * transfo;


//     if ( pat.getNumParents()>0){
//       cerr<<"pat.getNumParents()="<<pat.getNumParents()<<endl;
//       cerr<<"pat.getParent(0)->getName()="<<pat.getParent(0)->getName()<<endl;
      
//        osg::NodeVisitor::apply(*(pat.getParent(0)));
//       //traverse(*(pat.getParent(0)));
//     }

    
//     cerr<<"slt pat "<<pat.getName()<< " fin"<<endl;
//   }  
// };


// class DummyDrawable : public osg::Drawable 
// {
// public:
//   DummyDrawable(){

//   }

//   //DummyDrawable(const DummyDrawable& drawimage,const CopyOp& copyop=CopyOp::SHALLOW_COPY){
//   //  }
  
//   virtual osg::Object* cloneType() const { return new DummyDrawable(); }
  
//   virtual osg::Object* clone(const osg::CopyOp& copyop) const { return new DummyDrawable();}
  
//   virtual bool isSameKindAs(const osg::Object* obj) const { return dynamic_cast<const DummyDrawable*>(obj)!=NULL; }
  
//   virtual const char* libraryName() const { return "osg"; }
//   virtual const char* className() const { return "DummyDrawable"; }
  
  
//   virtual void drawImplementation(osg::State& state) const{
//     cerr<<state.getModelViewMatrix().getTrans().x()<<endl;

//   }
  
// };
