/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Camera.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Camera'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _CAMERA_H
#define _CAMERA_H

//@START_USER1
#include <osg/PositionAttitudeTransform>

#include "Evaluable.h"
#include "XMLUtil.h"
#include "MapRegister.h"
#include "LoaderGeneric.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_1209
class ...
*/

class AFX_EXT_CLASS Camera
    : public Evaluable
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    std::string _nodeName;
    osg::PositionAttitudeTransform* _tNode;
    static MapRegister<Camera*> _register;

//
// Non-Grouped Methods
//

public:
    Camera(BD* pBD);
    virtual ~Camera();
    virtual bool check();
    static bool checkAllInstances(LoaderGeneric* loader);
    static Camera* getCamera(BD* pBD, const std::string camName);
    static Camera* getFirstCamera(BD* pBD);
    static Camera* getLastCamera(BD* pBD);
    static Camera* getNextCamera(BD* pBD, std::string camName);
    virtual osg::Matrix getViewMatrix();
    static bool linkCamera(osg::Node* n, const std::string& pickName,
                           LoaderGeneric* loader);
    bool load();
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    static Evaluable* staticCreate(BD* pBD);
    std::string getNodeName() const;
    void setNodeName(std::string nodeName);
    static MapRegister<Camera*> getRegister();
    void setTNode(osg::PositionAttitudeTransform* pTNode);
    osg::PositionAttitudeTransform* getTNode() const;
};

#endif


#ifdef CB_INLINES
#ifndef _CAMERA_H_INLINES
#define _CAMERA_H_INLINES

/*@NOTE_1224
Returns the value of member '_nodeName'.
*/
inline std::string Camera::getNodeName() const
{//@CODE_1224
    return _nodeName;
}//@CODE_1224



/*@NOTE_1225
Set the value of member '_nodeName' to 'nodeName'.
*/
inline void Camera::setNodeName(std::string nodeName)
{//@CODE_1225
    _nodeName = nodeName;
}//@CODE_1225



/*@NOTE_4362
Returns the value of member '_register'.
*/
inline MapRegister<Camera*> Camera::getRegister()
{//@CODE_4362
    return _register;
}//@CODE_4362



/*@NOTE_1229
Set the value of member '_tNode' to 'pTNode'.
*/
inline void Camera::setTNode(osg::PositionAttitudeTransform* pTNode)
{//@CODE_1229
    _tNode = pTNode;
}//@CODE_1229



/*@NOTE_1238
Returns the value of member '_tNode'.
*/
inline osg::PositionAttitudeTransform* Camera::getTNode() const
{//@CODE_1238
    return _tNode;
}//@CODE_1238



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
