/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          CharacterOsgCal.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'CharacterOsgCal'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _CHARACTEROSGCAL_H
#define _CHARACTEROSGCAL_H

//@START_USER1
#ifdef OSG_CAL_SUPPORT
//#include "MediaInterface.h"
//#include "Media.h"

#include <osgCal/Model>
#include <osgCal/CoreModel>
#include <osgCal/SubMeshHardware>
#include "XMLUtil.h"
#include "MapRW.h"
//#include "HeightMap/HeightMap.hpp"
//#include "Animable.h"
#include "TimeBar.h"
#include "Methode_1arg.h"
#include "Character.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_1505
class ...
*/

class AFX_EXT_CLASS CharacterOsgCal
    : public Character
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: data
//

private:
    osgCal::Model* _model;
    MapRW::mapStrStr _osgCalMap;

protected:
    MapRW::mapStrInt _mapAnim;
    osgCal::Model* getModel() const;

//
// Group: animation
//

public:
    virtual double getDureeAnim(std::string anim);
    virtual void setDureeAnim(std::string anim, double duree);
    virtual void startAnimation(std::string nom);
    virtual void stopAnimation(std::string nom);

//
// Group: A voir
//

public:
    void allerAOrigin(float x, float y, float z = 0);
    virtual double eval(std::string methode, double args[10], int nbParam);

//
// Group: load
//

public:
    bool loadCal3dFile(const std::string absFichierConf);
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    static Evaluable* staticCreate(BD* pBD);
    virtual bool check();
    CharacterOsgCal(BD* pBD);
    virtual ~CharacterOsgCal();

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//
};

#endif


#ifdef CB_INLINES
#ifndef _CHARACTEROSGCAL_H_INLINES
#define _CHARACTEROSGCAL_H_INLINES


//
// Group: data
//
/*@NOTE_1515
Returns the value of member '_model'.
*/
inline osgCal::Model* CharacterOsgCal::getModel() const
{//@CODE_1515
    return _model;
}//@CODE_1515



// End of Group: data

//@START_USER3
#endif
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
