/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          CharacterSeqAnim.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'CharacterSeqAnim'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _CHARACTERSEQANIM_H
#define _CHARACTERSEQANIM_H

//@START_USER1
//#include "MediaInterface.h"
//#include "Media.h"
//#include <osgCal/Model>
//#include <osgCal/CoreModel>
#include "XMLUtil.h"
#include "MapRW.h"
//#include "HeightMap/HeightMap.hpp"
//#include "Animable.h"
#include "TimeBar.h"
#include "Methode_1arg.h"
#include "Character.h"
#include "Animation.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_1544
class ...
*/

class AFX_EXT_CLASS CharacterSeqAnim
    : public Character
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: data
//

private:
    MediaEvaluable::mapStrMediaEval _mapMediaEval;
    std::string _osgNodeName;

public:
    MediaEvaluable::mapStrMediaEval getMapMediaEval() const;
    void setMapMediaEval(MediaEvaluable::mapStrMediaEval mapMediaEval);
    std::string getOsgNodeName() const;
    void setOsgNodeName(std::string osgNodeName);

//
// Group: animation
//

public:
    virtual double getDureeAnim(std::string anim);
    virtual void setDureeAnim(std::string anim, double duree);
    virtual void startAnimation(std::string nom);
    virtual void stopAnimation(std::string nom);

//
// Group: load
//

public:
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    static bool linkCharacterSeqAnim(osg::Node* n, const std::string& pickName,
                                     LoaderGeneric* loader);
    static Evaluable* staticCreate(BD* pBD);
    virtual bool check();
    CharacterSeqAnim(BD* pBD);
    virtual ~CharacterSeqAnim();

//
// Group: simple
//

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//
};

#endif


#ifdef CB_INLINES
#ifndef _CHARACTERSEQANIM_H_INLINES
#define _CHARACTERSEQANIM_H_INLINES


//
// Group: data
//
/*@NOTE_1875
Returns the value of member '_mapMediaEval'.
*/
inline MediaEvaluable::mapStrMediaEval CharacterSeqAnim::getMapMediaEval() const
{//@CODE_1875
    return _mapMediaEval;
}//@CODE_1875



/*@NOTE_1876
Set the value of member '_mapMediaEval' to 'mapMediaEval'.
*/
inline void CharacterSeqAnim::setMapMediaEval(MediaEvaluable::mapStrMediaEval mapMediaEval)
{//@CODE_1876
    _mapMediaEval = mapMediaEval;
}//@CODE_1876



/*@NOTE_1891
Returns the value of member '_osgNodeName'.
*/
inline std::string CharacterSeqAnim::getOsgNodeName() const
{//@CODE_1891
    return _osgNodeName;
}//@CODE_1891



/*@NOTE_1892
Set the value of member '_osgNodeName' to 'osgNodeName'.
*/
inline void CharacterSeqAnim::setOsgNodeName(std::string osgNodeName)
{//@CODE_1892
    _osgNodeName = osgNodeName;
}//@CODE_1892



// End of Group: data

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
