/** -*-c++-*- *************************************************************\
* File:          CookiMessage.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of assert macros
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/

#ifndef _COOKIMESSAGE_H_
#define _COOKIMESSAGE_H_

using namespace std;


extern "C" int setup_sigsegv();
extern "C" void printStackTrace(std::string & res);

namespace cooki3d {

  class BD;
  extern bool activationCTRACE;
  extern bool activationCTRACE2;
  extern bool activationCTRACEdebug;
  extern int lineNumber;
  extern bool assertStackMustBePrintNow;

  class AssertException{    
    std::string _stackTrace;
    BD * pBD;
  public:    
    AssertException(BD *);
    const std::string & getStackTrace();
    BD * getBD();
  };

  //extern std::ostream * out; 
}

using namespace cooki3d;

#define CINFOs cout<<lineNumber++<<" INFO :"
  
#define CTRACE(C,M) if (activationCTRACE) cout<<lineNumber++<<" TRACE "<<__PRETTY_FUNCTION__<<"("<<__FILE__<<":"<<__LINE__<<") "

//class :"<<typeid(*C).name()<<" méthode:"<<M<<" "

#define CTRACE2(C,M) if (activationCTRACE2) cout<<lineNumber++<<" TRACE 2"<<__PRETTY_FUNCTION__<<"("<<__FILE__<<":"<<__LINE__<<") "

//class:"<<typeid(*C).name()<<" méthode:"<<M<<" "
  
#define CTRACEs(F) if (activationCTRACE) cout<<lineNumber++<<" TRACE "<<__PRETTY_FUNCTION__<<"("<<__FILE__<<":"<<__LINE__<<") "

//fonction:"<<F<<" "

#define CTRACEnext if (activationCTRACE) cout<<lineNumber++<<"| "

#define CTRACEdebug if (activationCTRACEdebug) cout<<lineNumber++<<" "

#define CWARN(C,M) cout<<lineNumber++<<" WARNING "<<__PRETTY_FUNCTION__<<"("__FILE__<<":"<<__LINE__<<") "

//class:"<<typeid(*C).name()<<" fonction:"<<M<<" "

#define CWARNs(F) cout<<lineNumber++<<" WARNING "<<__PRETTY_FUNCTION__<<"("__FILE__<<":"<<__LINE__<<") "

//fonction:"<<F<<" "

#define CERR(C,M) cout<<lineNumber++<<" ERROR "<<__PRETTY_FUNCTION__<<"("__FILE__<<":"<<__LINE__<<") "
//class:"<<typeid(*C).name()<<" méthode:"<<M<<" "

#define CERRs(M) cout<<lineNumber++<<" ERROR "<<__PRETTY_FUNCTION__<<"("__FILE__<<":"<<__LINE__<<") "

//" méthode:"<<M<<" "

#define CERRnext cout<<"| "

#ifndef UNIX 

#define __STRING(expr) #expr
extern void sleep(unsigned int  useconds );

#endif


#define assertC( CONDITion ) if(!(CONDITion)) { cout<<lineNumber++<<" FATAL ERROR file:"<<__FILE__<<":"<<__LINE__<<" condition:"<<__STRING(CONDITion)<<endl; throw AssertException(getBD());  }

#define assertCMessage(CONDITion,CookiMESSAGE) if(!(CONDITion)) { cout<<lineNumber++<<" FATAL ERROR file:"<<__FILE__<<":"<<__LINE__<<" condition:"<<__STRING(CONDITion)<<endl<<CookiMESSAGE<<endl; throw AssertException(getBD());  }

#define assertC2( CONDITion , pBD) if(!(CONDITion)) { cout<<lineNumber++<<" FATAL ERROR file:"<<__FILE__<<":"<<__LINE__<<" condition:"<<__STRING(CONDITion)<<endl; throw AssertException( pBD);  }

#define assertC2Message(CONDITion,pBD,CookiMESSAGE) if(!(CONDITion)) { cout<<lineNumber++<<" FATAL ERROR file:"<<__FILE__<<":"<<__LINE__<<" condition:"<<__STRING(CONDITion)<<endl<<CookiMESSAGE<<endl; throw AssertException( pBD);  }

//#define assertCMessageCode(CONDITion,CookiMESSAGE,codeSiErreur) if(!(CONDITion)) { cout<<lineNumber++<<" ERREUR FATALE file:"<<__FILE__<<":"<<__LINE__<<" condition:"<<__STRING(CONDITion)<<endl; cout<<"             "<<CookiMESSAGE<<endl; printStackTrace(); /*BD::eraseAll();*//*EnvironnementOSG::instance()->stop();*/ codeSiErreur; throw  }


#endif
