#ifndef _COOKIMETIER_H
#define _COOKIMETIER_H

// Date, Time & Version defines
#define COOKIMETIER_DATE    20061114
#define COOKIMETIER_TIME    004046
#define COOKIMETIER_VERSION 2232

// Context define declarations

// Forward extern class declarations

//@START_USER1
#define SAUT_OPTIMAL_COOKIMETIER
//Cela permet de sauter tous ce qu'il y a en dessous
//et qui n'est pas optimis pour une compilation rapide 
#ifndef SAUT_OPTIMAL_COOKIMETIER
//@END_USER1

// Defines needed for relations between templated classes
#define _CBT_ARG1_ARG2	<Arg1,Arg2>
#define _CBT_ARG1_ARG2_ARG3	<Arg1,Arg2,Arg3>
#define _CBT_TCLASS_ARG1	<TClass,Arg1>
#define _CBT_TCLASS_ARG1_ARG2	<TClass,Arg1,Arg2>
#define _CBT_TCLASS_ARG1_ARG2_ARG3	<TClass,Arg1,Arg2,Arg3>
#define _CBT_RESULT_ARG1	<Result,Arg1>

// Forward class declarations
class Animable;
class Animation;
class AnimationGroup;
class BD;
class BoundingShape;
class Camera;
class Character;
class CharacterOsgCal;
class CharacterSeqAnim;
class Collision;
class Command;
class CommandThread;
class EnvironnementGeneric;
class EnvironnementJava;
class EnvironnementOSG;
class EnvironnementProducer;
class EnvironnementQT;
class EnvironnementSDL;
class Evaluable;
class Event;
class EvtAdapterJava;
class EvtAdapterQT;
class EvtBoundingShapeCollision;
class EvtCollision;
class EvtHandler;
class EvtKey;
class EvtKeyGroup;
class EvtMouse;
class File;
class Function_0arg;
template<class Result> class Function_0argWithResult;
template<class Arg1> class Function_1arg;
template<class Arg1,class Arg2> class Function_2args;
template<class Arg1,class Arg2,class Arg3> class Function_3args;
class GroupParams;
class HeightMap;
class LoaderGeneric;
class LoaderXML;
class MapRW;
class Media;
class MediaEvaluable;
template<class TClass> class Methode_0arg;
template<class TClass,class Arg1> class Methode_1arg;
template<class TClass,class Arg1,class Arg2> class Methode_2args;
template<class TClass,class Arg1,class Arg2,class Arg3> class Methode_3args;
class MoteurJeuC;
class NodeNameList;
class OsgNodeReference;
template<class OsgType> class OsgReference;
class QGLViewerOSG;
class QGLWidgetOSG;
template<typename Item> class Register;
class Sauvegarde;
class ScanSetGraph;
class Sequence;
class SolCollisions;
class SolGravitation;
class Sound;
class SoundMpeg;
class Texte;
class Threadd;
class ThreadSdl;
class TimeBar;
class TimeMod;
class Utilisateur;
class CommandThreadSdl;
template<class Result,class Arg1> class Function_1argWithResult;
template< typename Item>  class MapRegister;
class MainApp;
template<typename Item> class MapUserRegister;

// Needed ClassBuilder include files
#include "CB_MultiOwned.h"

// Make sure the inline implementations are skipped
#ifdef CB_INLINES
#undef CB_INLINES
#endif

// Include classes, for declarations
#include "Evaluable.h"
#include "Animable.h"
#include "Media.h"
#include "MediaEvaluable.h"
#include "Animation.h"
#include "NodeNameList.h"
#include "AnimationGroup.h"
#include "BD.h"
#include "BoundingShape.h"
#include "Camera.h"
#include "Character.h"
#include "CharacterOsgCal.h"
#include "CharacterSeqAnim.h"
#include "Collision.h"
#include "Command.h"
#include "CommandThread.h"
#include "EnvironnementOSG.h"
#include "EnvironnementGeneric.h"
#include "EnvironnementJava.h"
#include "EnvironnementProducer.h"
#include "EnvironnementQT.h"
#include "EnvironnementSDL.h"
#include "Event.h"
#include "EvtAdapterJava.h"
#include "EvtAdapterQT.h"
#include "EvtBoundingShapeCollision.h"
#include "EvtCollision.h"
#include "EvtHandler.h"
#include "EvtKey.h"
#include "EvtKeyGroup.h"
#include "EvtMouse.h"
#include "File.h"
#include "Function_0arg.h"
#include "Function_0argWithResult.h"
#include "Function_1arg.h"
#include "Function_2args.h"
#include "Function_3args.h"
#include "GroupParams.h"
#include "HeightMap.h"
#include "LoaderGeneric.h"
#include "LoaderXML.h"
#include "MapRW.h"
#include "Methode_0arg.h"
#include "Methode_1arg.h"
#include "Methode_2args.h"
#include "Methode_3args.h"
#include "MoteurJeuC.h"
#include "OsgNodeReference.h"
#include "OsgReference.h"
#include "QGLViewerOSG.h"
#include "QGLWidgetOSG.h"
#include "Register.h"
#include "Sauvegarde.h"
#include "ScanSetGraph.h"
#include "Sequence.h"
#include "SolGravitation.h"
#include "SolCollisions.h"
#include "Sound.h"
#include "SoundMpeg.h"
#include "Texte.h"
#include "Threadd.h"
#include "ThreadSdl.h"
#include "TimeBar.h"
#include "TimeMod.h"
#include "Utilisateur.h"
#include "CommandThreadSdl.h"
#include "Function_1argWithResult.h"
#include "MapRegister.h"
#include "MainApp.h"
#include "MapUserRegister.h"


// Include classes again, for inline implementation
#define CB_INLINES
#include "Animable.h"
#include "Animation.h"
#include "AnimationGroup.h"
#include "BD.h"
#include "BoundingShape.h"
#include "Camera.h"
#include "Character.h"
#include "CharacterOsgCal.h"
#include "CharacterSeqAnim.h"
#include "Collision.h"
#include "Command.h"
#include "CommandThread.h"
#include "EnvironnementGeneric.h"
#include "EnvironnementJava.h"
#include "EnvironnementOSG.h"
#include "EnvironnementProducer.h"
#include "EnvironnementQT.h"
#include "EnvironnementSDL.h"
#include "Evaluable.h"
#include "Event.h"
#include "EvtAdapterJava.h"
#include "EvtAdapterQT.h"
#include "EvtBoundingShapeCollision.h"
#include "EvtCollision.h"
#include "EvtHandler.h"
#include "EvtKey.h"
#include "EvtKeyGroup.h"
#include "EvtMouse.h"
#include "File.h"
#include "Function_0arg.h"
#include "Function_0argWithResult.h"
#include "Function_1arg.h"
#include "Function_2args.h"
#include "Function_3args.h"
#include "GroupParams.h"
#include "HeightMap.h"
#include "LoaderGeneric.h"
#include "LoaderXML.h"
#include "MapRW.h"
#include "Media.h"
#include "MediaEvaluable.h"
#include "Methode_0arg.h"
#include "Methode_1arg.h"
#include "Methode_2args.h"
#include "Methode_3args.h"
#include "MoteurJeuC.h"
#include "NodeNameList.h"
#include "OsgNodeReference.h"
#include "OsgReference.h"
#include "QGLViewerOSG.h"
#include "QGLWidgetOSG.h"
#include "Register.h"
#include "Sauvegarde.h"
#include "ScanSetGraph.h"
#include "Sequence.h"
#include "SolCollisions.h"
#include "SolGravitation.h"
#include "Sound.h"
#include "SoundMpeg.h"
#include "Texte.h"
#include "Threadd.h"
#include "ThreadSdl.h"
#include "TimeBar.h"
#include "TimeMod.h"
#include "Utilisateur.h"
#include "CommandThreadSdl.h"
#include "Function_1argWithResult.h"
#include "MapRegister.h"
#include "MainApp.h"
#include "MapUserRegister.h"

//@START_USER2
#endif //SAUT_OPTIMAL
 

#include "CB_SingleOwned.h" 
#include "CB_MultiOwned.h"
#define CB_INLINES

//#define __GXX_MERGED_TYPEINFO_NAMES 0

#include <iostream>
#include <string>
using namespace std;

/* #ifdef __GXX_MERGED_TYPEINFO_NAMES */

/* #if __GXX_MERGED_TYPEINFO_NAMES == 0 */
/* //#error "XXXX" */
/* #endif */

/* #if __GXX_MERGED_TYPEINFO_NAMES == 1 */
/* #error "OOOO" */
/* #endif */

/* #endif */ 

#undef AFX_EXT_CLASS
#ifndef UNIX
#  define AFX_EXT_CLASS 
//#  define AFX_EXT_CLASS __declspec(dllexport)
#  define C3D_EXPORT __declspec(dllexport)
#  define C3D_CALL __stdcall
#else
#  define AFX_EXT_CLASS 
#  define C3D_EXPORT 
#  define C3D_CALL 
#endif 

#include "EnvironnementOSG.h" //pour assertC
#include "BD.h"


//@END_USER2

#endif
