/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementGeneric.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementGeneric'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include <osg/Group>
#include <osgUtil/UpdateVisitor>
#include <osg/PositionAttitudeTransform>
#include <osgGA/GUIEventAdapter>

#include "EnvironnementGeneric.h"
#include "Camera.h"
#include "EvtAdapterJava.h"
#include "PickIntersectVisitor.h"
#include "MediaEvaluable.h"
#include <osg/Version>

// static float lastTime           = 0.0f;     // This will hold the time from the last frame
//     static char strFrameRate[50] = {0};         // We will store the string here for the window title

//     static float frameTime = 0.0f;              // This stores the last frame's time
//     static int framesPerSecond=0;

//     // Get the current time in seconds
//     float currentTime = SDL_GetTicks() * 0.001f;             

//     // Here we store the elapsed time between the current and last frame,
//     // then keep the current frame in our static variable for the next frame.
//     //g_FrameInterval = currentTime - frameTime;
//     frameTime = currentTime;

//     // Increase the frame counter
//     ++framesPerSecond;

//     // Now we want to subtract the current time by the last time that was stored
//     // to see if the time elapsed has been over a second, which means we found our FPS.
//     if( currentTime - lastTime > 1.0f )
//     {
//         // Here we set the lastTime to the currentTime
//         lastTime = currentTime;
        
//         // Copy the frames per second into a string to display in the window title bar
//         sprintf(strFrameRate, "SDL Render : cooki, fps: %d", int(framesPerSecond));

//         // Set the window title bar to our string
        
// 	texte0->setText( std::string (strFrameRate) );
// 	//SDL_WM_SetCaption(strFrameRate, strFrameRate);

//         // Reset the frames per second
//         framesPerSecond = 0;
//     }

#include "IntersectionRectangleUtil.h"


namespace cooki3d{


//@END_USER2





//
// Group: init
//
/*@NOTE_2593
Constructor method.
*/
EnvironnementGeneric::EnvironnementGeneric(int argc, char** argv,
                                           LoaderGeneric* loader) //@INIT_2593
    : EnvironnementOSG(argc, argv, loader)
    , _frameNumber(0)
    , _terminated(false)
{//@CODE_2593
    ConstructorInclude();

    init( argc, argv, new osgUtil::SceneView, new osgGA::TrackballManipulator );

   
}//@CODE_2593


/*@NOTE_2580
Destructor method.
*/
EnvironnementGeneric::~EnvironnementGeneric()
{//@CODE_2580
    DestructorInclude();

    if (isHaveBlockingRunMethod()){
      releaseAllGLObjects();
    }
        
}//@CODE_2580


/*@NOTE_4706
Constructor method.
*/
EnvironnementGeneric::EnvironnementGeneric(int argc, char** argv,
                                           LoaderGeneric* loader,
                                           osgUtil::SceneView* sv,
                                           osgGA::MatrixManipulator* matrixManip) //@INIT_4706
    :  EnvironnementOSG(argc, argv, loader)
    , _frameNumber(0)
    , _terminated(false)
{//@CODE_4706
    ConstructorInclude();

    // Put in your own code
    init( argc, argv, sv, matrixManip); 

}//@CODE_4706


/*@NOTE_4718
Constructor method.
*/
void EnvironnementGeneric::init(int argc, char** argv, osgUtil::SceneView* sv,
                                osgGA::MatrixManipulator* matrixManip)
{//@CODE_4718

  _frameNumber =0;
  
  _start_tick=0;	  
  _frameStamp = new osg::FrameStamp;
  _sv= sv;
  _sv->setFrameStamp(_frameStamp.get()); //060622
  
  _terminated = false;
  
  
  //création d'un manipulateur par défaut
  if ( matrixManip ){
    _matrixManip=matrixManip;
    _listEvtH.push_front(_matrixManip.get());
  }
  
  //_sv->setDefaults(osgUtil::SceneView::SKY_LIGHT);
  //_sv->setDefaults(osgUtil::SceneView::HEADLIGHT);
  _sv->setDefaults(osgUtil::SceneView::STANDARD_SETTINGS);
  
  //récupéré des preview osgexp, peut éventuellement servir...
  /*osgUtil::GLObjectsVisitor* glov = 
    dynamic_cast<osgUtil::GLObjectsVisitor*>(_sv->getInitVisitor());
    if(glov){
    cerr<<"SWITCH_OFF_DISPLAY_LISTS"<<endl;
    glov->setMode(osgUtil::GLObjectsVisitor::SWITCH_OFF_DISPLAY_LISTS);
    }*/
  
  
  _sv->setViewport(0,0,_loader->getWidth(),_loader->getHeight());
  
 
  
}//@CODE_4718


// End of Group: init

void EnvironnementGeneric::appIdle()
{//@CODE_2597

  assertCMessage( 0, "Methode example, not to be call");

  updateTimeAndFrameCount();
    
  //début code choix de camera
  if (getActiveCamera()== ""){
    if ( _matrixManip.get() ){
      _sv->getViewMatrix().set(_matrixManip->getInverseMatrix());
    }
  }
  else {
    /*osg::Matrix transfo;
   
    osg::PositionAttitudeTransform* pat = 
    Camera::getCamera(getActiveCamera())->getTNode();
    
    pat->computeLocalToWorldMatrix(transfo,NULL);
    
    _sv->getViewMatrix().set(osg::Matrix::inverse(transfo));*/
    
    _sv->getViewMatrix().set(Camera::getCamera(getBD(),getActiveCamera())->getViewMatrix());
     
  }
  //fin code choix de camera

  osg::ref_ptr<EvtAdapterJava> adapter=new EvtAdapterJava();
  adapter->setEventType(osgGA::GUIEventAdapter::FRAME);
  callHandlers(*adapter);
      
  //processUserEvent(USER_UPDATE_EVENT, 0, 0);
  
  
  /*osgDB::Registry::instance()->getDatabasePager()->updateSceneGraph(_frameStamp->getReferenceTime());    
    _sv->update();   */ 
  
  _sv->update();
  
  //start Cull back
  /*osgDB::DatabasePager* dp = osgDB::Registry::instance()->getDatabasePager();
    if (dp) dp->signalBeginFrame(_sv->getState()->getFrameStamp());*/
  _sv->cull();
  
  
  
  //compile call back
  _sv->draw();
  
  //postDraw(_sv->getState());
  
  //cout<<"_sv->getState()="<<_sv->getState()<<endl;
  
  
  
  /*if (dp) dp->signalEndFrame();*/
  
    
  
  /*double availableTime = 0.0025; //  2.5 ms    
  // flush deleted GL objects.
  _sv->flushDeletedGLObjects(availableTime);    
    // compile any GL objects that are required.
    if (dp) dp->compileGLObjects(*(_sv->getState()),availableTime);*/
  

 
}//@CODE_2597


bool EnvironnementGeneric::callHandlers(osgGA::GUIEventAdapter& adapter)
{//@CODE_2598

  //cout<<"EnvironnementJava::callHandlers(EvtAdapterJava& adapter)"<<endl;
  
  adapter.setTime(_frameStamp->getReferenceTime());
    
  ListEH::iterator i=_listEvtH.begin();
  bool handled=false;

  while ( i != _listEvtH.end() && !handled){
    
    handled= (*i)->handle(adapter, *this);
    i++;
  }    
  return handled;
 
}//@CODE_2598


bool EnvironnementGeneric::computeIntersections(float x, float y,
                                                osgUtil::IntersectVisitor::HitList& hitlist,
                                                osg::Node::NodeMask mask)
{//@CODE_2600
  
  CTRACE(this,"computeIntersections")<<"entrée x="<<x
				     <<" y="<<y
				     <<" mask="<<mask
				     <<endl;
  if ( OSG_VERSION_MAJOR*10+OSG_VERSION_MINOR >= 12){
    x = x * _sv->getViewport()->width();
    y = y * _sv->getViewport()->height();
  }

  //regle de traversée
  //(getTraversalMask() & (getNodeMaskOverride() | node.getNodeMask()))!=0;
  
  osg::Matrixd vum;
  if (_sv!=0) {
    vum.set( _sv->getViewMatrix() *
	     _sv->getProjectionMatrix());
    
    
    PickVisitor iv;
    //TODO Traiter plusieurs niveau de profondeur (intersection)
    //=> setTraversalMask différent pour les BoundingShapes ...
    iv.setTraversalMask( /*0xffffffff*/ mask);
  
    
  
    osgUtil::IntersectVisitor::HitList localHits;        
    
    //pointer displaySetting à null ??
    //_sv->getDisplaySettings()->getScreenWidth()
    //_sv->getDisplaySettings()->getScreenHeight()
    
    x= (x - _sv->getViewport()->width()/2)/
      (_sv->getViewport()->width()/2);
    y= -(y - _sv->getViewport()->height()/2)/
      (_sv->getViewport()->height()/2);
    
    //Desactivation cause erreur fatal gcc4.0.3
    localHits = iv.getHits(_sv->getSceneData(), vum, x, y);
    
    if (localHits.empty()) 
      return false;
    
    hitlist.insert(hitlist.begin(),localHits.begin(),localHits.end());
    
    return true;
    
    //     for (int i=0;i<4;i++){
    // 	osgUtil::Hit hit;
    // 	hit._vecIndexList.push_back(3);
    // 	hit._vecIndexList.push_back(3);
    // 	hit._vecIndexList.push_back(5);
    
    //       }
    
    //       return false;
    
  }
  return false;
}//@CODE_2600


bool EnvironnementGeneric::computeIntersectionsRectangle(int x1, int y1, int x2,
                                                         int y2,
                                                         std::vector<SimpleHit>& hitlist)
{//@CODE_2645

  

  cout<<"données x1,y2,x2,y1="<<x1<<","<<y1<<","<<x2<<","<<y2<<endl;
  
  double left, right, bottom, top, zNear, zFar;
  
  _sv->getProjectionMatrix().getFrustum( left, right, bottom, top, zNear, zFar);
  
  cout<<"frustrum = left="<< left<<", right="<< right
      <<",bottom="<< bottom<<", top="<< top
      <<", zNear"<< zNear<<", zFar"<< zFar<<endl;

  
  
  double minX, maxX, minY, maxY;
  if (x1 < x2){
    minX = x1;
    maxX = x2;
  }else {
    minX = x2;
    maxX = x1;
  }
  if (y1 < y2){
    minY = y1;
    maxY = y2;
  }else {
    minY = y2;
    maxY = y1;
  }

  //on inverse l'axe y
  assertC( _sv );
  assertC( _sv->getViewport() );
  minY = _sv->getViewport()->height() - minY;
  maxY = _sv->getViewport()->height() - maxY;
  swap(minY,maxY);

  cout<<"mins =  minX, maxX, minY, maxY ="
      << minX<<","<< maxX<<","<< minY<<","<< maxY<<endl;

  double n_left, n_right, n_bottom, n_top;

  cout<<"test ="<<(fabs(left)+right)<<"*"<< minX<<"  /"<< _sv->getViewport()->width()<<endl;

  n_left = (fabs(left)+right) * minX  / _sv->getViewport()->width();
  n_left = n_left + left;

  n_right = (fabs(left)+right) * maxX  / _sv->getViewport()->width();
  n_right = n_right + left;

  n_bottom = (fabs(bottom)+top) * minY / _sv->getViewport()->height();
  n_bottom = n_bottom + bottom;

  n_top = (fabs(bottom)+top) * maxY  / _sv->getViewport()->height();
  n_top = n_top + bottom;
  
  cout<<"données recadrées="<<n_left<<","<< n_right<<","<< n_bottom<<","<< n_top<<endl;

  
  _sv->getProjectionMatrix().makeFrustum(n_left, n_right, n_bottom, n_top, zNear, zFar);

  osgUtil::CullVisitor * cv = _sv->getCullVisitor();
  cv->ref();
  _sv->setCullVisitor(new SpecialCullVisitor());

  _sv->cull();
  
  

  //getHits( _sv->getCullVisitor()->getCurrentRenderGraph(), hitlist );
  getHits( _sv->getCullVisitor()->getCurrentStateGraph(), hitlist );
 
  //on rétabli le cullVisitor normal
  _sv->setCullVisitor(cv);
  cv->unref();
  //on rétablit la matrice
  _sv->getProjectionMatrix().makeFrustum(left, right, bottom, top, zNear, zFar);
  
  return hitlist.size()>0;

}//@CODE_2645


bool EnvironnementGeneric::computeIntersectionsVertical(float x, float y,
                                                        osgUtil::IntersectVisitor::HitList& hitlist,
                                                        osg::Node* data)
{//@CODE_2604
  
  //CTRACE(this,"computeIntersectionsVertical")<<"entrée x="<<x<<" y="<<y<<endl;
  
  //on essaye d'optimiser
  static osg::Matrixd vum;
  static osg::Matrixd camZ;
  static osg::PositionAttitudeTransform * pat=
    new osg::PositionAttitudeTransform();
  PickVisitor iv; //n'aime pas le static (osg::NodeVisitor??)
  //iv.init();
  static osg::Matrix proj= _sv->getProjectionMatrix(); //nécéssaire car elle bouge mal

  if (_sv!=0)
    {      
      pat->setPosition(osg::Vec3(x,y,1000));
      camZ.makeIdentity();
      pat->computeLocalToWorldMatrix(camZ,NULL);

      vum.set(osg::Matrix::inverse(camZ) * proj);
            
      
      iv.setTraversalMask(0xffffffff);
  
      osgUtil::IntersectVisitor::HitList localHits;        
      
      //pointer displaySetting à null ??
      //_sv->getDisplaySettings()->getScreenWidth()
      //_sv->getDisplaySettings()->getScreenHeight()

      //x= (x - 400.0)/400.0;
      //y= -(y - 300.0)/300.0;
      x=0;
      y=0;
      
      //cout<<"_sv->getSceneData()="<<data<<endl;
      if (data)
	localHits = iv.getHits(data, vum, x, y);
      
      if (localHits.empty()) 
	return false;
      
      hitlist.insert(hitlist.begin(),localHits.begin(),localHits.end());
      
      return true;
      
      }
  return false;
}//@CODE_2604


list<osg::ref_ptr<osgGA::GUIEventHandler> >& EnvironnementGeneric::getEHList()
{//@CODE_2609
  return _listEvtH ;
}//@CODE_2609


osg::FrameStamp* EnvironnementGeneric::getFrameStamp()
{//@CODE_3296
    return _frameStamp.get();
}//@CODE_3296


osg::Matrix EnvironnementGeneric::getViewMatrix()
{//@CODE_2610
  return _sv->getViewMatrix();
}//@CODE_2610


void EnvironnementGeneric::getViewport(int& x, int& y, int& w, int& h)
{//@CODE_4733
  _sv->getViewport(x,y,w,h);
}//@CODE_4733


bool EnvironnementGeneric::isStopped()
{//@CODE_4788

    return _terminated;
}//@CODE_4788


void EnvironnementGeneric::readCommandLine(std::vector<std::string>& cmdline)
{//@CODE_2611
 
}//@CODE_2611


void EnvironnementGeneric::releaseAllGLObjects()
{//@CODE_4772

  CTRACE(this, "releaseAllGLObjects")<<"pass"<<endl;

  // first relase all GL objects and switch on the flush of deleted objects
  // in the next frame.
  _sv->releaseAllGLObjects(); //fait planter java
  _sv->setRenderStage(0);
  _sv->flushAllDeletedGLObjects(); 
  
  // make sure that the registry all flushes all its texture objects.
  osgDB::Registry::instance()->releaseGLObjects();
  
  // then run the frame to do the actuall OpenGL clean up. ??
  //_sv->update();     
  //_sv->cull();
  //_sv->draw();
  
}//@CODE_4772


void EnvironnementGeneric::requestContinuousUpdate(bool needed)
{//@CODE_2613

}//@CODE_2613


void EnvironnementGeneric::requestRedraw()
{//@CODE_2615
  _sv->update(); 
  //appIdle();
}//@CODE_2615


void EnvironnementGeneric::requestWarpPointer(float x, float y)
{//@CODE_2616

  //SDL_WarpMouse(static_cast<int>(x), static_cast<int>(y));
 
}//@CODE_2616


void EnvironnementGeneric::run(osg::Node* n)
{//@CODE_2619
  
  // optimize the scene graph, remove rendundent nodes and state etc.
  //osgUtil::Optimizer optimizer;
  
  //provoque une segmentation fault (sans doute personnages)
  //optimizer.optimize(node);

  CTRACE(this,"run")<<"..."<<endl;

  //GetRootNode()->addChild(n);
  _matrixManip->setNode(n);
  _sv->setSceneData(n);


  
  /*// by default set up the DatabasePager.
    osgDB::DatabasePager* databasePager = osgDB::Registry::instance()->getOrCreateDatabasePager();
    databasePager->startThread();
    
    databasePager->registerPagedLODs(n);
    
    // pass the database pager to the cull visitor so node can send requests to the pager.
    _sv->getCullVisitor()->setDatabaseRequestHandler(databasePager);
    
       // tell the database pager which graphic context the compile of rendering objexts is needed.
       databasePager->setCompileGLObjectsForContexID(_sv->getState()->getContextID(),true);
       
       //...
       */


    run();
 
}//@CODE_2619


void EnvironnementGeneric::run()
{//@CODE_2621

  CTRACE(this,"run()")<<"..."<<endl;
  ///SDL_EnableUNICODE(1);
 
  
  _start_tick = _timer.tick();
  


  // send INIT event
  //processUserEvent(USER_INIT_EVENT, 0, 0);
  
  //initialisation de la vue
  osg::ref_ptr<EvtAdapterJava> adapter=new EvtAdapterJava();
  adapter->setEventType(static_cast<osgGA::GUIEventAdapter::EventType>(0xffff));//? pq pas...
  _matrixManip->init(*adapter, *this);
  _matrixManip->home(*adapter, *this);

  
  //while (!_terminated){
  //  runOnce();    
  //}

  
  
}//@CODE_2621


void EnvironnementGeneric::setViewport(int x, int y, int w, int h)
{//@CODE_2774
   _sv->setViewport(x,y,w,h);
}//@CODE_2774


void EnvironnementGeneric::stop()
{//@CODE_2622
  CTRACE(this,"stop")<<" application stop asked !"<<endl;
  //sleep(1);
  _terminated = true;
  //SDL_Quit();
  //sleep(5);
}//@CODE_2622


void EnvironnementGeneric::updateTimeAndFrameCount()
{//@CODE_2623
  
  // set the frame stamp for the new frame.
  
  
  double time_since_start = _timer.delta_s(_start_tick,_timer.tick());
  _frameStamp->setFrameNumber(_frameNumber++);
  _frameStamp->setReferenceTime(time_since_start);
  
    
 
}//@CODE_2623


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_2581
Method which must be called first in a constructor.
*/
void EnvironnementGeneric::ConstructorInclude()
{
}


/*@NOTE_2582
Method which must be called first in a destructor.
*/
void EnvironnementGeneric::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d



// DEPRECIE pour la version 1.0
// void getHits(osgUtil::RenderGraph * rg,
// 	     std::vector<SimpleHit> & hitlist){

  
//   cerr<<"rg->_leaves.size()="<<rg->_leaves.size()<<endl;
//   cerr<<"rg->_children.size()="<<rg->_children.size()<<endl;


//   for (osgUtil::RenderGraph::LeafList::iterator it =
// 	 rg->_leaves.begin();
//        it !=  rg->_leaves.end();
//        it++){

//     SimpleHit sh;
    
//     sh._drawable = (*it)->_drawable;
//     sh._geode = (osg::Geode*) (*it)->_drawable->getParent(0);
//     hitlist.push_back( sh);

//     cout<<" "<<(*it)->_depth<<" "<<sh._geode->getName()<<endl;

//   }

//   for (osgUtil::RenderGraph::ChildList::iterator it = 
// 	 rg->_children.begin();
//        it !=  rg->_children.end();
//        it++){
//     getHits( it->second.get(),hitlist );
//   }
// }

//POUBELLE
 /*test
    static float angle=0.0;
    float view_rotx = 20.0f, view_roty = 30.0f, view_rotz = 0.0f;
    
    angle+=2.0;
    
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    glPushMatrix();
    glRotatef(view_rotx, 1.0f, 0.0f, 0.0f);
    glRotatef(view_roty, 0.0f, 1.0f, 0.0f);
    glRotatef(view_rotz, 0.0f, 0.0f, 1.0f);
    
    glPushMatrix();
    glTranslatef(-3.0f, -2.0f, 0.0f);
    glRotatef(angle, 0.0f, 0.0f, 1.0f);
    glCallList(1);
    glPopMatrix();
    
    glPopMatrix();
    return;
  */
  // cout<<"drawing "<<endl;


// EnvironnementGeneric::EnvironnementGeneric(int argc, 
// 			     char** argv,
// 			     std::string desc, 
// 			     int width,
// 			     int height,
// 			     osgUtil::SceneView * sv)
//   : EnvironnementOSG(argc, argv, desc)
//   , _frameNumber(0)
//   , _terminated(false)
//   , _matrixManip(0)    
// {
//   ConstructorInclude();
  
//   init( argc, argv, desc, width, height, sv); 
  
// }

// void EnvironnementGeneric::init(int argc, 
// 			     char** argv,
// 			     std::string desc, 
// 			     int width,
// 			     int height,
// 			     osgUtil::SceneView * sv){
// }


