/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementGeneric.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementGeneric'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _ENVIRONNEMENTGENERIC_H
#define _ENVIRONNEMENTGENERIC_H

//@START_USER1
#include "SDLWindows.h"

#include <osg/Geode>
#include <osg/ref_ptr>
#include <osg/FrameStamp>
#include <osg/DisplaySettings>
#include <osg/State>
#include <osg/TexGen>
#include <osg/Texture2D>
#include <osg/Timer>

#include <osgDB/ReadFile>
#include <osgDB/WriteFile>

#include <osgGA/TrackballManipulator>
#include <osgGA/GUIActionAdapter>
#include <osgGA/GUIEventHandler>
#include <osgGA/MatrixManipulator>

#include <osgUtil/SceneView>
#include <osgUtil/DisplayRequirementsVisitor>

#include "EnvironnementOSG.h"
#include "EvtAdapterJava.h"


using namespace std;
namespace cooki3d{
//@END_USER1


/*@NOTE_2579
class ...
*/

class AFX_EXT_CLASS EnvironnementGeneric
    : public EnvironnementOSG
{

//@START_USER2
 public:
  typedef list<osg::ref_ptr<osgGA::GUIEventHandler> > ListEH;

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: init
//

public:
    EnvironnementGeneric(int argc, char** argv, LoaderGeneric* loader);
    virtual ~EnvironnementGeneric();
    EnvironnementGeneric(int argc, char** argv, LoaderGeneric* loader,
                         osgUtil::SceneView* sv,
                         osgGA::MatrixManipulator* matrixManip);
    void init(int argc, char** argv, osgUtil::SceneView* sv,
              osgGA::MatrixManipulator* matrixManip);

//
// Non-Grouped Members
//

protected:
    int _frameNumber;
    osg::Timer _timer;
    osg::Timer_t _start_tick;
    osg::ref_ptr<osg::FrameStamp> _frameStamp;
    osg::ref_ptr<osgUtil::SceneView> _sv;
    mutable bool _terminated;
    osg::ref_ptr<osgGA::MatrixManipulator> _matrixManip;
    list<osg::ref_ptr<osgGA::GUIEventHandler> > _listEvtH;

//
// Non-Grouped Methods
//

protected:
    virtual void releaseAllGLObjects();
    void run();
    virtual void updateTimeAndFrameCount();

public:
    virtual void appIdle();
    virtual bool callHandlers(osgGA::GUIEventAdapter& adapter);
    virtual bool computeIntersections(float x, float y,
                                      osgUtil::IntersectVisitor::HitList& hitlist,
                                      osg::Node::NodeMask mask = 0xffffffff);
    virtual bool computeIntersectionsRectangle(int x1, int y1, int x2, int y2,
                                               std::vector<SimpleHit>& hitlist);
    virtual bool computeIntersectionsVertical(float x, float y,
                                              osgUtil::IntersectVisitor::HitList& hitlist,
                                              osg::Node* data);
    virtual list<osg::ref_ptr<osgGA::GUIEventHandler> >& getEHList();
    virtual osg::FrameStamp* getFrameStamp();
    virtual osg::Matrix getViewMatrix();
    virtual void getViewport(int& x, int& y, int& w, int& h);
    virtual bool isStopped();
    virtual void readCommandLine(std::vector<std::string>& cmdline);
    virtual void requestContinuousUpdate(bool needed);
    virtual void requestRedraw();
    virtual void requestWarpPointer(float x, float y);
    virtual void run(osg::Node* n);
    virtual void setViewport(int x, int y, int w, int h);
    virtual void stop();
};

#endif


#ifdef CB_INLINES
#ifndef _ENVIRONNEMENTGENERIC_H_INLINES
#define _ENVIRONNEMENTGENERIC_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
