/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementJava.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementJava'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "EnvironnementJava.h"
#include <osg/Group>
#include <osgUtil/UpdateVisitor>
#include "Camera.h"
#include <osg/PositionAttitudeTransform>
#include "EvtAdapterJava.h"



#include "PickIntersectVisitor.h"
#include <osgGA/GUIEventAdapter>

namespace cooki3d{
//@END_USER2




/*@NOTE_1675
Constructor method.
*/
EnvironnementJava::EnvironnementJava(int argc, char** argv,
                                     LoaderGeneric* loader) //@INIT_1675
    : EnvironnementGeneric(argc, argv, loader)
    , _mutex(NULL)
    , _mustReleaseAllGLObjectsNextFrame(true)
{//@CODE_1675
    ConstructorInclude();
    setHaveBlockingRunMethod( false ); 
}//@CODE_1675


/*@NOTE_1662
Destructor method.
*/
EnvironnementJava::~EnvironnementJava()
{//@CODE_1662
    DestructorInclude();

    // Put in your own code
    // if (_mutex){
    //       SDL_DestroyMutex(_mutex);
    //}
}//@CODE_1662


void EnvironnementJava::appIdle()
{//@CODE_1679

  //cout<<"drawing "<<SDL_ThreadID()<<endl;
  
  //prise de possession d'un _mutex depuis le thread 
  //qui appel appIdle (càd l'objet jogl animator)
  //   //   if ( !_mutex ){
  //   //     _mutex = SDL_CreateMutex();
  //   //     int res = SDL_LockMutex(_mutex);
  //   //     CTRACE(this,"appIdle")<<" SDL_CreateMutex "<<_mutex
  //   // 			  <<" res="<<res<<endl;  
  //   //   }
  
  
  
    if ( _mustReleaseAllGLObjectsNextFrame ){
      
      CINFOs<<"final releaseAllGLObjects call"<<endl;
      releaseAllGLObjects();
      _mustReleaseAllGLObjectsNextFrame = false;
      //_terminated = true;
      
      //on relache le verrou pour dire que le l'environnement 
      //peut etre arrêter sans dommage par le thread concurrent
      ////SDL_UnlockMutex(_mutex);

    }

    if (!_terminated){
      updateTimeAndFrameCount();
      
      //début code choix de camera
      if (getActiveCamera()== "")
	_sv->getViewMatrix().set(_matrixManip->getInverseMatrix());
      else {
	
	_sv->getViewMatrix()
	  .set(Camera::getCamera(getBD(),getActiveCamera())->getViewMatrix());
      }
      //fin code choix de camera
      
      //send FRAME event
      osg::ref_ptr<EvtAdapterJava> adapter=new EvtAdapterJava();
      adapter->setEventType(osgGA::GUIEventAdapter::FRAME);
      callHandlers(*adapter);
      
      /*osgDB::Registry::instance()->getDatabasePager()->updateSceneGraph(_frameStamp->getReferenceTime());    
	_sv->update();   */ 
      
      _sv->update();
      
      //start Cull back
      /*osgDB::DatabasePager* dp = 
	osgDB::Registry::instance()->getDatabasePager();   
	if (dp) dp->signalBeginFrame(_sv->getState()->getFrameStamp());*/
      _sv->cull();
      
      
      //compile call back
      _sv->draw();
      
      
      /*double availableTime = 0.0025; //  2.5 ms    
      // flush deleted GL objects.
      _sv->flushDeletedGLObjects(availableTime);    
      // compile any GL objects that are required.
      if (dp) dp->compileGLObjects(*(_sv->getState()),availableTime);*/
      
    }
    else {
      CTRACE(this, "appIdle")<<"terminated..."<<endl;
    } 
  
}//@CODE_1679


void EnvironnementJava::requestWarpPointer(float x, float y)
{//@CODE_1703

  //SDL_WarpMouse(static_cast<int>(x), static_cast<int>(y));
 
}//@CODE_1703


void EnvironnementJava::run(osg::Node* n)
{//@CODE_1706
  
  //GetRootNode()->addChild(n);
  _matrixManip->setNode(n);
  _sv->setSceneData(n);
 
  run();
  
}//@CODE_1706


void EnvironnementJava::run()
{//@CODE_1708
  
  _start_tick = _timer.tick();
 
  //initialisation de la vue
  osg::ref_ptr<EvtAdapterJava> adapter=new EvtAdapterJava();
  // send INIT event ??
  adapter->setEventType
    (static_cast<osgGA::GUIEventAdapter::EventType>(0xffff));
  _matrixManip->init(*adapter, *this);
  _matrixManip->home(*adapter, *this);
  
  
}//@CODE_1708


void EnvironnementJava::stop()
{//@CODE_1714

  CTRACE(this,"stop")<<" arrêt de l'application demandé"<<endl;
  //on indique que la prochaine frame doit nettoyer les objets openGL
  _terminated = true;
  _mustReleaseAllGLObjectsNextFrame = true;
  

  //on prend le verrou (take the _mutex), 
  //il devra etre disponible et se débloquer
  //uniquement si les objets openGL sont effacer par appIdle (thead concurrent)
  //(NOTE : le verrou avait été pris par celui-ci au début)
  
//   // SDL_LockMutex(_mutex);//takeMutex();
// //   SDL_UnlockMutex(_mutex); //releaseMutex();

}//@CODE_1714


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1663
Method which must be called first in a constructor.
*/
void EnvironnementJava::ConstructorInclude()
{
}


/*@NOTE_1664
Method which must be called first in a destructor.
*/
void EnvironnementJava::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d


//POUBELLE
  /*osg::Matrix transfo;
     
    osg::PositionAttitudeTransform* pat = 
    Camera::getCamera(getActiveCamera())->getTNode();
    
    pat->computeLocalToWorldMatrix(transfo,NULL);
    
    _sv->getViewMatrix().set(osg::Matrix::inverse(transfo));*/


/* =>run(...)
  // by default set up the DatabasePager.
  osgDB::DatabasePager* databasePager = osgDB::Registry::instance()->getOrCreateDatabasePager();
  databasePager->startThread();
  
  databasePager->registerPagedLODs(n);
  
  // pass the database pager to the cull visitor so node can send requests to the pager.
  _sv->getCullVisitor()->setDatabaseRequestHandler(databasePager);
  
  // tell the database pager which graphic context the compile of rendering objexts is needed.
  databasePager->setCompileGLObjectsForContexID(_sv->getState()->getContextID(),true);
  
  //...
  */
