/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementOSG.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementOSG'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1

//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "EnvironnementOSG.h"
#include "EvtHandler.h"
#include "LoaderXML.h"
#include "MediaEvaluable.h"

//#include <Producer/KeyboardMouse>
//#include <Producer/Camera>


#ifndef UNIX
#include <windows.h>

void sleep(unsigned int  useconds )
{
    Sleep( useconds );
}

extern "C" void printStackTrace(std::string & res){
  std::cout<<"STACK TRACE printStackTrace IS NOT IMPLEMENTED FOR WINDOWS!"
	   <<endl;
}

#else

#include <execinfo.h>
#include <sstream>

extern "C" void printStackTrace(std::string & res){
  ostringstream os;
  void *bt[20];
  char **strings;
  size_t sz;
  unsigned int i = 0;
  
  os<<"+++ Stack trace simple +++\n";
  sz = backtrace(bt, 20);
  strings = backtrace_symbols(bt, sz);
  std::string s;
  std::string::size_type loc1, loc2;

  system( " rm -f /tmp/cookiStack "); //TODO revoir cela si deux user diff

  //on saute printStackTrace...
  for(i = 1; i < sz; ++i){
    
    //  fprintf(stderr, "%s\n", strings[i]);

    s = std::string( strings[i] );
    loc1 = s.find_first_of("(");
    loc2 = s.find_last_of("+");
    
    if (loc1 != std::string::npos
	&& loc2 != std::string::npos){
      
      
      //std::cerr<< s.substr( loc1+1, loc2-loc1-1)<<std::endl; 
      
      system( (std::string()+"c++filt "
	       +s.substr( loc1+1, loc2-loc1-1)+" >> /tmp/cookiStack").c_str());
      
    }else {
      system( ("echo "+s+" >> /tmp/cookiStack").c_str() );
     
    } 
  }

  std::ifstream file("/tmp/cookiStack");    
 

  while (getline( file, s ) &&  s != "main" ) {
    os<<"| "<<s<<std::endl;
  }
  os<<"| +++  end simple trace  +++\n";
  
  res  = os.str();
  
}


#endif



//#include <tr1/functional>

namespace cooki3d {
   
  bool activationCTRACE=false;
  bool activationCTRACE2=false;
  bool activationCTRACEdebug=false;
  int lineNumber = 0;
  //option pour QT qui lance ses slots dans un thread séparé...
  bool assertStackMustBePrintNow=false;
  //permet la redirection des sorties CTRACE CERR ...
  //std::ostream * out = &std::cout;


  AssertException::AssertException(BD * p){
    pBD = p;
    printStackTrace( _stackTrace );
    if (assertStackMustBePrintNow) {
      cerr<<_stackTrace<<endl;
    }
  }
  const std::string & AssertException::getStackTrace(){ return _stackTrace; }
  BD * AssertException::getBD(){return pBD;}

//@END_USER2




/*@NOTE_812
Constructor method.
*/
EnvironnementOSG::EnvironnementOSG(int argc, char** argv,
                                   LoaderGeneric* loader) //@INIT_812
    : _parser(&argc,argv)// manage the program arguments.
    , _activeCamera("")
    , _haveBlockingRunMethod(true)
    , _loader(loader)
{//@CODE_812
    ConstructorInclude();

        
  // set up the usage docu ment, in case we need to print out how to use this program.
  _parser.getApplicationUsage()->setApplicationName(_parser.getApplicationName());
  _parser.getApplicationUsage()->setDescription(_parser.getApplicationName()+loader->getDesc());
 
  setRootNode(new osg::Group);
  getRootNode()->setName("root");

  //on initialise le générateur de randoms
  srand ( time(NULL) ); 

}//@CODE_812


/*@NOTE_804
Destructor method.
*/
EnvironnementOSG::~EnvironnementOSG()
{//@CODE_804
  DestructorInclude();
  
  CTRACE(this,"~EnvironnementOSG")<<"destruction EnvironnementOSG "
				  <<this<<endl;
  
  //Toute les entités vont être effacées avant le déférencement
  //de l'environnement et du noeud principal.
  //getLoader()->getBD()->eraseAll();
  
  //if (_EnvOSG == this) {
  //  _EnvOSG = NULL;
  CINFOs<<"~EnvironnementOSG "<<this<<" has been deleted ("
    <<_rootNode->referenceCount()<<")"<<endl;
  //}
  
  
  //_rootNode->unref();
  //_rootNode = NULL;
  
    
    
}//@CODE_804


bool EnvironnementOSG::computeIntersections(float x, float y,
                                            osgUtil::IntersectVisitor::HitList& hitlist,
                                            osg::Node::NodeMask mask)
{//@CODE_846
  
  CERR(this,"computeIntersections")
    <<" NON IMPLEMENTE pour cet environnemet!!"<<endl;
  return false;
}//@CODE_846


bool EnvironnementOSG::computeIntersectionsRectangle(int x1, int y1, int x2,
                                                     int y2,
                                                     std::vector<SimpleHit>& hitlist)
{//@CODE_3011

  CERR(this,"computeIntersections depuis EnvOSG")
    <<" NON IMPLEMENTE pour cet environnement!!"<<endl;

  return false;
  

}//@CODE_3011


bool EnvironnementOSG::computeIntersectionsVertical(float x, float y,
                                                    osgUtil::IntersectVisitor::HitList& hitlist,
                                                    osg::Node* data)
{//@CODE_1416
  CERR(this,"computeIntersectionsVertical")
    <<" NON IMPLEMENTE pour cet environnemet!!"<<endl;
  
  return false;
}//@CODE_1416


BD* EnvironnementOSG::getBD()
{//@CODE_5046
  assertC( _loader );
  return _loader->getBD();
}//@CODE_5046


void EnvironnementOSG::pushBack(osgGA::GUIEventHandler* handler)
{//@CODE_917
  getEHList().push_back(handler);
  handler->getUsage(*getParser().getApplicationUsage());
}//@CODE_917


void EnvironnementOSG::pushFront(osgGA::GUIEventHandler* handler)
{//@CODE_919
//  osg::ref_ptr<osgGA::GUIEventHandler> pref=handler;
  getEHList().push_front(handler);
  handler->getUsage(*getParser().getApplicationUsage());

}//@CODE_919


void EnvironnementOSG::readAndRun()
{//@CODE_845
  // read the scene from the list of file specified commandline args.
  osg::ref_ptr<osg::Node> loadedModel = osgDB::readNodeFiles(_parser);
  
  // if no model has been successfully loaded report failure.
  if (!loadedModel)  {
    std::cout << _parser.getApplicationName() 
	      <<": No data loaded" << std::endl;
    //exit(1);
  }

  run(loadedModel.get());
}//@CODE_845


/*@NOTE_4834
Set the value of member '_loader' to 'pLoader'.
*/
void EnvironnementOSG::setLoader(LoaderGeneric* pLoader)
{//@CODE_4834
    _loader = pLoader;
   
}//@CODE_4834


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_805
Method which must be called first in a constructor.
*/
void EnvironnementOSG::ConstructorInclude()
{
}


/*@NOTE_806
Method which must be called first in a destructor.
*/
void EnvironnementOSG::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
//attention CB fait parfois sauter ce crochet fermant...
} //end of namespace cooki3d

