/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementProducer.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementProducer'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1

//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "EnvironnementProducer.h"
//#include "Activite.h"
#include "EvtHandler.h"
//#include "ChargeurJeu.h"
#include "LoaderXML.h"

//#include <Producer/KeyboardMouse>
#include <Producer/Camera>
#include <osg/PositionAttitudeTransform>
//#include <Producer/Matrix>
#include "Camera.h"
#include "MediaEvaluable.h"

using namespace osgProducer;
namespace cooki3d{
//@END_USER2





//
// Group: constructor
//
/*@NOTE_85
Constructor method.
*/
EnvironnementProducer::EnvironnementProducer(int argc, char** argv,
                                             LoaderGeneric* loader) //@INIT_85
    : EnvironnementOSG(argc,argv,loader)//manage the program arguments.
    , _viewer(0)
    , _camera1(0)
    , _cfg(0)
    , _ia(0)
    , _noLoopAndInitInRun(false)
{//@CODE_85
    ConstructorInclude();

    init();
  
  
}//@CODE_85


/*@NOTE_32
Destructor method.
*/
EnvironnementProducer::~EnvironnementProducer()
{//@CODE_32
    DestructorInclude();

    CTRACE(this,"~EnvironnementProducer")
      <<"destruction EnvironnementProducer"<<endl;
    // Put in your own code
    
    
}//@CODE_32


void EnvironnementProducer::init()
{//@CODE_3346
  if (! _noLoopAndInitInRun ){

    _viewer = new osgProducer::Viewer(buildConfig());    
    
    // set up the value with sensible default event handlers.
    //autre choix osgProducer::Viewer::NO_EVENT_HANDLERS
    //osgProducer::Viewer::STANDARD_SETTINGS
    //osgProducer::Viewer::TRACKBALL_MANIPULATOR
    //Viewer::SKY_LIGHT_SOURCE |
    
    /*_viewer->setUpViewer(Viewer::TRACKBALL_MANIPULATOR|
      Viewer::HEAD_LIGHT_SOURCE |			
      Viewer::VIEWER_MANIPULATOR |
      Viewer::ESCAPE_SETS_DONE);*/
    _viewer->setUpViewer(Viewer::STANDARD_SETTINGS);
    
    
    // get details on keyboard and mouse bindings used by the viewer.
    _viewer->getUsage(*getParser().getApplicationUsage());


  }
}//@CODE_3346


Producer::CameraConfig* EnvironnementProducer::buildConfig()
{//@CODE_113
    
  Producer::RenderSurface *_rs1 = new Producer::RenderSurface;
  _rs1->setScreenNum(0);
  _rs1->setWindowName("Producer Render : Cooki3d engine");
  //_rs1->useBorder(false);
  _rs1->setWindowRectangle(0,0,_loader->getWidth(),_loader->getHeight());
  /*Producer::Camera **/_camera1 = new Producer::Camera;
  _camera1->setRenderSurface(_rs1);
  //camera1->setOffset( 1.0, 0.0 );
  
  _rs1->setInputRectangle( Producer::RenderSurface::InputRectangle(0.0,1.0,0.0,1.0));
  
  /*Producer::InputArea **/_ia = new Producer::InputArea;
  _ia->addRenderSurface(_rs1);
  
  Producer::CameraConfig *_cfg = new Producer::CameraConfig;
  _cfg->addCamera("Camera 1",_camera1);
  _cfg->setInputArea(_ia);
  return _cfg;
   
}//@CODE_113


void EnvironnementProducer::setRenderSurface(Producer::RenderSurface* rs)
{//@CODE_1721

  
  rs->setScreenNum(0);
  rs->setWindowName("Producer Render : Cooki3d engine");
  rs->setWindowRectangle(0,0,_loader->getWidth(),_loader->getHeight());
  _camera1 = new Producer::Camera;
  _camera1->setRenderSurface(rs);
  rs->setInputRectangle( Producer::RenderSurface::InputRectangle(0.0,1.0,0.0,1.0));
  
  _ia = new Producer::InputArea;
  _ia->addRenderSurface(rs);
  
  Producer::CameraConfig *_cfg = new Producer::CameraConfig;
  _cfg->addCamera("Camera 1",_camera1);
  _cfg->setInputArea(_ia);

  
  // Put in your own code
  _viewer = new osgProducer::Viewer(_cfg);    
  
  _viewer->setUpViewer(Viewer::STANDARD_SETTINGS);
  
  // get details on keyboard and mouse bindings used by the viewer.
  _viewer->getUsage(*getParser().getApplicationUsage());

  
  //debut du run
  //TODO revoir rootNode, attention au ref_ptr!
  _viewer->setSceneData(getRootNode().get());
  
  // create the windows and run the threads.
  _viewer->realize();
  

}//@CODE_1721


// End of Group: constructor

bool EnvironnementProducer::computeIntersections(float x, float y,
                                                 osgUtil::IntersectVisitor::HitList& hitlist,
                                                 osg::Node::NodeMask mask)
{//@CODE_851
  assertC(_viewer);
  return _viewer->computeIntersections(x,y,hitlist);
}//@CODE_851


list<osg::ref_ptr<osgGA::GUIEventHandler> >& EnvironnementProducer::getEHList()
{//@CODE_802
  assertC(_viewer);
  return _viewer->getEventHandlerList();  
}//@CODE_802


osg::FrameStamp* EnvironnementProducer::getFrameStamp()
{//@CODE_3295
  assertC(_viewer);
  return _viewer->getFrameStamp();
}//@CODE_3295


osg::Matrix EnvironnementProducer::getViewMatrix()
{//@CODE_2510
  assertC(_viewer);
  return _viewer->getViewMatrix(); 
}//@CODE_2510


bool EnvironnementProducer::isStopped()
{//@CODE_4787

    return _viewer->done();
}//@CODE_4787


void EnvironnementProducer::requestContinuousUpdate(bool )
{//@CODE_843
}//@CODE_843


void EnvironnementProducer::requestRedraw()
{//@CODE_842
  assertC(_viewer);
  _viewer->update();
}//@CODE_842


void EnvironnementProducer::requestWarpPointer(float x, float y)
{//@CODE_839
  assertC(_viewer);
  _viewer->requestWarpPointer(x,y);
}//@CODE_839


void EnvironnementProducer::run(osg::Node* node)
{//@CODE_114
  // optimize the scene graph, remove rendundent nodes and state etc.
  //osgUtil::Optimizer optimizer;
  
  //provoque une segmentation fault (sans doute personnages)
  //optimizer.optimize(node);
  CTRACE(this,"run")<<"EnvironnementProducer::run(osg::Node* node)..."<<endl;
  
  assertC(_viewer);
  
  // set the scene to render
  _viewer->setSceneData(node);
  
  // create the windows and run the threads.
  _viewer->realize();
  
  while( !_viewer->done() ) {
    runOnce();
  }
  
  // wait for all cull and draw threads to complete before exit.
  _viewer->sync();

  // run a clean up frame to delete all OpenGL objects.
  _viewer->cleanup_frame();
  
  // wait for all the clean up frame to complete.
  _viewer->sync();

  
}//@CODE_114


void EnvironnementProducer::runOnce()
{//@CODE_1724
  assertC(_viewer);
  
  // wait for all cull and draw threads to complete.
  _viewer->sync();
  
  //début code choix de camera
  if (getActiveCamera() != ""){
    /*osg::Matrix transfo;	
      
    osg::PositionAttitudeTransform* pat = 
    Camera::getCamera(getActiveCamera())->getTNode();
    
    pat->computeLocalToWorldMatrix(transfo,NULL);
    
    _viewer->setViewByMatrix(Producer::Matrix(osg::Matrix::inverse(transfo).ptr()));*/
    
    _viewer->setViewByMatrix
      (Producer::Matrix
       (Camera::getCamera(getBD(),getActiveCamera())->getViewMatrix().ptr()));
    
  }
  //fin code choix de camera
  
  
  // update the scene by traversing it with the the update visitor
  //which will call all node update callbacks and animations.
  _viewer->update();
  
  // fire off the cull and draw traversals of the scene.
  _viewer->frame();
  
  
  
  
  //OsgSceneHandler* osh = _viewer->getSceneHandlerList()[0].get();
  //osgUtil::SceneView* sv = osh->getSceneView();
  //postDraw(sv->getState()); //Deprecie
  
  
}//@CODE_1724


void EnvironnementProducer::stop()
{//@CODE_1195
  CTRACE(this,"stop")<<" arrêt de l'application demandé"<<endl;
  _viewer->setDone(true);
}//@CODE_1195


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_33
Method which must be called first in a constructor.
*/
void EnvironnementProducer::ConstructorInclude()
{
}


/*@NOTE_34
Method which must be called first in a destructor.
*/
void EnvironnementProducer::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
