/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementProducer.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementProducer'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _ENVIRONNEMENTPRODUCER_H
#define _ENVIRONNEMENTPRODUCER_H
#include <osgDB/ReadFile>
#include <osgUtil/Optimizer>
#include <osgProducer/Viewer>

//@START_USER1

#include "EnvironnementOSG.h"
namespace cooki3d{

  class LoaderXML;
//@END_USER1


/*@NOTE_31
class ...
*/

class AFX_EXT_CLASS EnvironnementProducer
    : public EnvironnementOSG
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: constructor
//

private:
    void init();

public:
    EnvironnementProducer(int argc, char** argv, LoaderGeneric* loader);
    virtual ~EnvironnementProducer();
    Producer::CameraConfig* buildConfig();
    void setRenderSurface(Producer::RenderSurface* rs);

//
// Non-Grouped Members
//

private:
    osgProducer::Viewer* _viewer;
    Producer::Camera* _camera1;
    Producer::CameraConfig* _cfg;
    Producer::InputArea* _ia;
    bool _noLoopAndInitInRun;

//
// Non-Grouped Methods
//

public:
    virtual bool computeIntersections(float x, float y,
                                      osgUtil::IntersectVisitor::HitList& hitlist,
                                      osg::Node::NodeMask mask = 0xffffffff);
    virtual list<osg::ref_ptr<osgGA::GUIEventHandler> >& getEHList();
    virtual osg::FrameStamp* getFrameStamp();
    virtual osg::Matrix getViewMatrix();
    virtual bool isStopped();
    virtual void requestContinuousUpdate(bool );
    virtual void requestRedraw();
    virtual void requestWarpPointer(float x, float y);
    virtual void run(osg::Node* node);
    void runOnce();
    virtual void stop();
    Producer::Camera* getCamera1() const;
    void setCamera1(Producer::Camera* pCamera1);
    Producer::CameraConfig* getCfg() const;
    void setCfg(Producer::CameraConfig* pCfg);
    Producer::InputArea* getIa() const;
    void setIa(Producer::InputArea* pIa);
    osgProducer::Viewer* getViewer() const;
    void setViewer(osgProducer::Viewer* pViewer);
};

#endif


#ifdef CB_INLINES
#ifndef _ENVIRONNEMENTPRODUCER_H_INLINES
#define _ENVIRONNEMENTPRODUCER_H_INLINES

/*@NOTE_957
Returns the value of member '_camera1'.
*/
inline Producer::Camera* EnvironnementProducer::getCamera1() const
{//@CODE_957
    return _camera1;
}//@CODE_957



/*@NOTE_958
Set the value of member '_camera1' to 'pCamera1'.
*/
inline void EnvironnementProducer::setCamera1(Producer::Camera* pCamera1)
{//@CODE_958
    _camera1 = pCamera1;
}//@CODE_958



/*@NOTE_954
Returns the value of member '_cfg'.
*/
inline Producer::CameraConfig* EnvironnementProducer::getCfg() const
{//@CODE_954
    return _cfg;
}//@CODE_954



/*@NOTE_955
Set the value of member '_cfg' to 'pCfg'.
*/
inline void EnvironnementProducer::setCfg(Producer::CameraConfig* pCfg)
{//@CODE_955
    _cfg = pCfg;
}//@CODE_955



/*@NOTE_951
Returns the value of member '_ia'.
*/
inline Producer::InputArea* EnvironnementProducer::getIa() const
{//@CODE_951
    return _ia;
}//@CODE_951



/*@NOTE_952
Set the value of member '_ia' to 'pIa'.
*/
inline void EnvironnementProducer::setIa(Producer::InputArea* pIa)
{//@CODE_952
    _ia = pIa;
}//@CODE_952



/*@NOTE_948
Returns the value of member '_viewer'.
*/
inline osgProducer::Viewer* EnvironnementProducer::getViewer() const
{//@CODE_948
    return _viewer;
}//@CODE_948



/*@NOTE_949
Set the value of member '_viewer' to 'pViewer'.
*/
inline void EnvironnementProducer::setViewer(osgProducer::Viewer* pViewer)
{//@CODE_949
    _viewer = pViewer;
}//@CODE_949



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
