/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementQT.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementQT'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "EnvironnementQT.h"
#include <osg/Group>
#include <osgUtil/UpdateVisitor>
#include "Camera.h"
#include <osg/PositionAttitudeTransform>
#include "EvtAdapterQT.h"



#include "PickIntersectVisitor.h"
#include <osgGA/GUIEventAdapter>

//#include <qglviewer/QGLViewer.h> //debian sarge 
//#include <QGLViewer/qglviewer.h> //alma

#include "EvtAdapterQT.h"

#ifndef QGL_SUPPORT
#include "specialNoSupport/QGLPseudoSupport.h"
#else

#include <qsize.h>

//#include "QGLViewerOSG.h"
#include "QGLWidgetOSG.h"

namespace cooki3d{
//@END_USER2





//
// Group: init
//
/*@NOTE_2392
Constructor method.
*/
EnvironnementQT::EnvironnementQT(int argc, char** argv,
                                 LoaderGeneric* loader) //@INIT_2392
    : EnvironnementGeneric(argc, argv, loader)
    , _qGLWidget(NULL)
    , _qWidget(NULL)
{//@CODE_2392
    ConstructorInclude();
    setHaveBlockingRunMethod( false );
       
    //car QT lance ses slots dans un thread séparé...
    cooki3d::assertStackMustBePrintNow = true;
   
   
 
}//@CODE_2392


/*@NOTE_4695
Constructor method.
*/
EnvironnementQT::EnvironnementQT(int argc, char** argv, LoaderGeneric* loader,
                                 osgUtil::SceneView* sv,
                                 osgGA::MatrixManipulator* _matrixManipulator) //@INIT_4695
    : EnvironnementGeneric(argc, argv, loader,sv, _matrixManipulator)
    , _qGLWidget(NULL)
    , _qWidget(NULL)
{//@CODE_4695
    ConstructorInclude();

    // Put in your own code
    setHaveBlockingRunMethod( false );

    //car QT lance ses slots dans un thread séparé...
    cooki3d::assertStackMustBePrintNow = true;
}//@CODE_4695


/*@NOTE_2379
Destructor method.
*/
EnvironnementQT::~EnvironnementQT()
{//@CODE_2379
    DestructorInclude();

    // Put in your own code
    if (_qGLWidget ){
      delete _qGLWidget;
    }
    if (_qWidget){
      delete _qWidget;
    }
}//@CODE_2379


// End of Group: init

/*@NOTE_2396
appIdle ...
*/
void EnvironnementQT::appIdle()
{//@CODE_2396

  //un try/catch supplémentaire est fait car
  //QT lance ses slots dans un thread séparé...
  //try {

  //cout<<"appIdle"<<endl;
  updateTimeAndFrameCount();
    
  //début code choix de camera
  if (getActiveCamera()== ""){
    if ( _matrixManip.get() ){
      _sv->getViewMatrix().set(_matrixManip->getInverseMatrix());
    }    
  }
  else {      
    _sv->getViewMatrix()
      .set(Camera::getCamera(getBD(),getActiveCamera())->getViewMatrix());
  }
  //fin code choix de camera
  
  osg::ref_ptr<EvtAdapterQT> adapter=new EvtAdapterQT(this);
  adapter->setEventType(osgGA::GUIEventAdapter::FRAME);
  callHandlers(*adapter);
  
  _sv->update();
  
  //start Cull back
  _sv->cull();
  
  //compile call back
  _sv->draw();
    
    
 //  }
//   catch(EnvironnementInstanceException e){
//     CERRs("mainCooki") << "Exception EnvironnementInstanceException caught !! "
// 		       <<  std::endl;
//     throw e;
//     //loadEnd();  
//   }
//   catch(AssertException e){
//     CERRs("mainCooki") << "Exception AssertException caught !! "
// 		       <<  std::endl;
//     CERRnext <<e.getStackTrace()<<endl;
//     EnvironnementOSG::stopIfStarted();
    
//     throw e;
//     //loadEnd();  
//   }
//   catch( ... ) {
//     CERRs("mainCooki")  << "Exception caught !! "<<  std::endl;
//     EnvironnementOSG::stopIfStarted();
//     //loadEnd();  
//   }
  
  
 
}//@CODE_2396


void EnvironnementQT::requestWarpPointer(float x, float y)
{//@CODE_2414

    //SDL_WarpMouse(static_cast<int>(x), static_cast<int>(y));
 
}//@CODE_2414


void EnvironnementQT::run(osg::Node* n)
{//@CODE_2417
  
  if ( _matrixManip.get() ){
    _matrixManip->setNode(n);
  }
  _sv->setSceneData(n);

  run();
 
}//@CODE_2417


void EnvironnementQT::run()
{//@CODE_2419

  CTRACE(this,"run")<<"..."<<endl;

  assertCMessage( !(_qGLWidget &&  _qWidget) , "état indéterminé");

  // Make the viewer window visible on screen.
  if (_qGLWidget == NULL && _qWidget == NULL){
    _qGLWidget = new QGLWidgetOSG(this); /*Viewer*/
    CTRACE(this,"run")<<"_qGLWidget->show() [1]"<<endl;
    _qGLWidget->show();
  }
  else if ( _qGLWidget ){
    CTRACE(this,"run")<<"_qGLWidget->show() [2]"<<endl;
    _qGLWidget->show();
  }
  else if ( _qWidget ){
    CTRACE(this,"run")<<"_qWidget->show() [3]"<<endl;
    _qWidget->show();
  } 
  
  _start_tick = _timer.tick();

  // send INIT event
  //processUserEvent(USER_INIT_EVENT, 0, 0);
  
  //initialisation de la vue
  osg::ref_ptr<EvtAdapterQT> adapter=new EvtAdapterQT(this);
  adapter->setEventType(static_cast<osgGA::GUIEventAdapter::EventType>(0xffff));//? pq pas...

   if ( _matrixManip.get() ){
     _matrixManip->init(*adapter, *this);
     _matrixManip->home(*adapter, *this);
   }
  
}//@CODE_2419


void EnvironnementQT::stop()
{//@CODE_2420

  CTRACE(this,"stop")<<" arrêt de l'application demandé"<<endl;
  _terminated = true;

}//@CODE_2420


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_2380
Method which must be called first in a constructor.
*/
void EnvironnementQT::ConstructorInclude()
{
}


/*@NOTE_2381
Method which must be called first in a destructor.
*/
void EnvironnementQT::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
#endif
