/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementQT.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementQT'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _ENVIRONNEMENTQT_H
#define _ENVIRONNEMENTQT_H

//@START_USER1

#include <osg/Geode>
#include <osg/ref_ptr>
#include <osg/FrameStamp>
#include <osg/DisplaySettings>
#include <osg/State>
#include <osg/TexGen>
#include <osg/Texture2D>
#include <osgDB/ReadFile>
#include <osgDB/WriteFile>


#include <osgGA/TrackballManipulator>
#include <osgGA/GUIActionAdapter>
#include <osgGA/GUIEventHandler>
#include <osgGA/MatrixManipulator>


#include <osgUtil/SceneView>
#include <osgUtil/DisplayRequirementsVisitor>
#include <osg/Timer>

#include "EnvironnementGeneric.h"


#include "EvtAdapterQT.h"

#ifdef QGL_SUPPORT
#  include <qgl.h>
#else 
#  include "specialNoSupport/QGLPseudoSupport.h"
#endif

using namespace std;
namespace cooki3d{
//@END_USER1


/*@NOTE_2378
class EnvironnementQT...
*/

class AFX_EXT_CLASS EnvironnementQT
    : public EnvironnementGeneric
{

//@START_USER2
  typedef list<osg::ref_ptr<osgGA::GUIEventHandler> > ListEH;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: init
//

public:
    EnvironnementQT(int argc, char** argv, LoaderGeneric* loader);
    EnvironnementQT(int argc, char** argv, LoaderGeneric* loader,
                    osgUtil::SceneView* sv,
                    osgGA::MatrixManipulator* _matrixManipulator);
    virtual ~EnvironnementQT();

//
// Non-Grouped Members
//

private:
    QGLWidget* _qGLWidget;
    QWidget* _qWidget;

//
// Non-Grouped Methods
//

protected:
    void run();

public:
    virtual void appIdle();
    virtual void requestWarpPointer(float x, float y);
    virtual void run(osg::Node* n);
    virtual void stop();
    QGLWidget* getQGLWidget() const;
    void setQGLWidget(QGLWidget* pQGLWidget);
    QWidget* getQWidget() const;
    void setQWidget(QWidget* pQWidget);
};

#endif


#ifdef CB_INLINES
#ifndef _ENVIRONNEMENTQT_H_INLINES
#define _ENVIRONNEMENTQT_H_INLINES

/*@NOTE_4754
Returns the value of member '_qGLWidget'.
*/
inline QGLWidget* EnvironnementQT::getQGLWidget() const
{//@CODE_4754
    return _qGLWidget;
}//@CODE_4754



/*@NOTE_4755
Set the value of member '_qGLWidget' to 'pQGLWidget'.
*/
inline void EnvironnementQT::setQGLWidget(QGLWidget* pQGLWidget)
{//@CODE_4755
    _qGLWidget = pQGLWidget;
    _qWidget = NULL;
}//@CODE_4755



/*@NOTE_4767
Returns the value of member '_qWidget'.
*/
inline QWidget* EnvironnementQT::getQWidget() const
{//@CODE_4767
    return _qWidget;
}//@CODE_4767



/*@NOTE_4768
Set the value of member '_qWidget' to 'pQWidget'.
*/
inline void EnvironnementQT::setQWidget(QWidget* pQWidget)
{//@CODE_4768
    _qWidget = pQWidget;
    _qGLWidget = NULL;
}//@CODE_4768



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
