/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementSDL.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementSDL'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2

#include <osg/Group>
#include <osgUtil/UpdateVisitor>
#include <osg/PositionAttitudeTransform>
//#include <osgUtil/GLObjectsVisitor>
//#include <osgUtil/DisplayListVisitor>

#include "EnvironnementSDL.h"
#include "Camera.h"
#include "PickIntersectVisitor.h"
#include "MainApp.h"

namespace cooki3d{
//@END_USER2




/*@NOTE_913
Constructor method.
*/
EnvironnementSDL::EnvironnementSDL(int argc, char** argv,
                                   LoaderGeneric* loader) //@INIT_913
    : EnvironnementGeneric(argc, argv, loader)
    , _sdlWin(0)
{//@CODE_913
    ConstructorInclude();

   
    
    //Attention, fou la merde quand pour les matériaux couleur
    /*osg::ref_ptr<osg::StateSet> gss = new osg::StateSet;
      _sv->setGlobalStateSet( gss.get( ) );
      gss->setGlobalDefaults( );
      gss->setMode( GL_DEPTH_TEST, osg::StateAttribute::ON );
      gss->setMode( GL_COLOR_MATERIAL, osg::StateAttribute::ON );*/

       
    CTRACE(this,"EnvironnementSDL")<<"av SDLWindow"<<endl;
  
    _sdlWin=new SDLWindow;
    
    if (_loader->getMainApp()->isUnitTest()){
      _sdlWin->setDontMoveCursor(true);
      _sdlWin->setUndecoracted(true);
    }

    _sdlWin->Create_GL_Window("SDL Render : Cooki3d engine",
			      _loader->getWidth(),
			      _loader->getHeight()
			      );


    //Attention NearZ ne semble pas avoir d'influence
    //float Fov=90.0f,float Nearest=3.0f,float Farthest=5000.0f
    //_sv->setProjectionMatrixAsPerspective(90.0f,800.0f/600.0f, 
    // 1000.0f, 1100.0f);
    
 
}//@CODE_913


/*@NOTE_864
Destructor method.
*/
EnvironnementSDL::~EnvironnementSDL()
{//@CODE_864
    DestructorInclude();

    delete _sdlWin;

    // Put in your own code
}//@CODE_864


void EnvironnementSDL::appIdle()
{//@CODE_888
  //cerr<<"EnvironnementSDL::appIdle()"<<endl;
  
    updateTimeAndFrameCount();
    
//début code choix de camera
    if (getActiveCamera()== "")
      _sv->getViewMatrix().set(_matrixManip->getInverseMatrix());
    else {
      /* osg::Matrix transfo,transfo2;
       

      osg::PositionAttitudeTransform* pat = 
	Camera::getCamera(getActiveCamera())->getTNode();

      pat->computeLocalToWorldMatrix(transfo,NULL);
      
      pat->getParent(0)->getParent(0)->getParent(0)->asTransform()->computeLocalToWorldMatrix(transfo2,NULL);
      
      _sv->getViewMatrix().set(osg::Matrix::inverse(transfo2)*osg::Matrix::inverse(transfo));*/

      
      _sv->getViewMatrix()
	.set(Camera::getCamera(getBD(),getActiveCamera())->getViewMatrix());

    }
//fin code choix de camera
    
    
    
    processUserEvent(USER_UPDATE_EVENT, 0, 0);
    
        
    /*osgDB::Registry::instance()->getDatabasePager()->updateSceneGraph(_frameStamp->getReferenceTime());    
      _sv->update();   */ 

   
     _sv->update();
    
    //start Cull back
    /*osgDB::DatabasePager* dp = osgDB::Registry::instance()->getDatabasePager();
      if (dp) dp->signalBeginFrame(_sv->getState()->getFrameStamp());*/
    _sv->cull();



    //compile call back
    _sv->draw();

    //postDraw(_sv->getState());

    //cout<<"_sv->getState()="<<_sv->getState()<<endl;
    
    

    /*if (dp) dp->signalEndFrame();*/



    SDL_GL_SwapBuffers();

    

    /*double availableTime = 0.0025; //  2.5 ms    
    // flush deleted GL objects.
    _sv->flushDeletedGLObjects(availableTime);    
    // compile any GL objects that are required.
    if (dp) dp->compileGLObjects(*(_sv->getState()),availableTime);*/


 
}//@CODE_888


bool EnvironnementSDL::callHandlers(const EvtAdapterSDL& adapter)
{//@CODE_882

    

    if (adapter.getEventType() == 0xffff) {
      if (adapter.getUserEventID() == USER_INIT_EVENT) {
	
	
	_matrixManip->init(adapter, *this);  
	_matrixManip->home(adapter, *this);
	
	return true;
      }
    }
    
    ListEH::iterator i=_listEvtH.begin();
    bool handled=false;

    while ( i != _listEvtH.end() && !handled){
      handled= (*i)->handle(adapter, *this);
      i++;
    }    
    return handled;
 
}//@CODE_882


void EnvironnementSDL::fireEvent(const SDL_Event& event)
{//@CODE_884

    
    // get the current time and mouse state
    double t = _frameStamp->getReferenceTime();
    int ms = SDL_GetMouseState(0, 0);
    
    osg::ref_ptr<EvtAdapterSDL> adapter = 
      new EvtAdapterSDL(event, 
			  0, 
			  0, 
			  _sdlWin->GetSurface()->w, 
			  _sdlWin->GetSurface()->h, 
			  t, ms);
    callHandlers(*adapter);    
 
}//@CODE_884


void EnvironnementSDL::processUserEvent(int code, void* data, int datalen)
{//@CODE_890

    SDL_UserEvent e;
    e.type = SDL_USEREVENT;
    e.code = code;
    e.data1 = data;
    e.data2 = &datalen;
    fireEvent(reinterpret_cast<const SDL_Event &>(e));
 
}//@CODE_890


void EnvironnementSDL::requestWarpPointer(float x, float y)
{//@CODE_901

    SDL_WarpMouse(static_cast<int>(x), static_cast<int>(y));
 
}//@CODE_901


void EnvironnementSDL::run(osg::Node* n)
{//@CODE_878

  CTRACE(this,"run(osg::Node* n)")<<"..."<<endl;

  //GetRootNode()->addChild(n);
    _matrixManip->setNode(n);
    _sv->setSceneData(n);



    /*// by default set up the DatabasePager.
    osgDB::DatabasePager* databasePager = osgDB::Registry::instance()->getOrCreateDatabasePager();
    databasePager->startThread();

    databasePager->registerPagedLODs(n);

    // pass the database pager to the cull visitor so node can send requests to the pager.
    _sv->getCullVisitor()->setDatabaseRequestHandler(databasePager);
            
       // tell the database pager which graphic context the compile of rendering objexts is needed.
    databasePager->setCompileGLObjectsForContexID(_sv->getState()->getContextID(),true);
    
    //..*/


    run();
 
}//@CODE_878


void EnvironnementSDL::run()
{//@CODE_880

   
    SDL_EnableUNICODE(1);
    
    _start_tick = _timer.tick();
    
    // send INIT event
    processUserEvent(USER_INIT_EVENT, 0, 0);
    
    CTRACE(this,"run()")<<"..."<<endl;

    while (!_terminated){
      runOnce();    
    }
 
}//@CODE_880


void EnvironnementSDL::runOnce()
{//@CODE_889

    
    processUserEvent(USER_FRAME_EVENT, 0, 0);
  
    SDL_Event event;

    // do something (maybe render? :)
    appIdle();    

    // check whether a SDL event has been received
    while (SDL_PollEvent(&event) && !_terminated) {
      switch (event.type) {
      case SDL_VIDEORESIZE:
	
	_sdlWin->SetResize(event.resize.w,480*event.resize.w/640);
	_sv->setViewport(0,0,event.resize.w,480*event.resize.w/640);
	
	fireEvent(event);
	break;
	
      case SDL_QUIT:
	_terminated = true;
	fireEvent(event);
	//SDL_Quit(); ->gestion faite dans ~SDLWindow
	break;      
      default:
	fireEvent(event);
      }
    }
    

    
 
}//@CODE_889


void EnvironnementSDL::stop()
{//@CODE_1194
  CTRACE(this,"stop( )")<<" Arrêt de l'application demandé"<<endl;
  //sleep(1);
  _terminated = true;
  //SDL_Quit();
  //sleep(5);
}//@CODE_1194


void EnvironnementSDL::updateTimeAndFrameCount()
{//@CODE_881

    // set the frame stamp for the new frame.
  /*  double time_since_start = _timer.delta_s(_start_tick,_timer.tick());
    _frameStamp->setFrameNumber(_frameNumber++);
    _frameStamp->setReferenceTime(time_since_start);
    _sv->setFrameStamp(_frameStamp.get());
*/
    EnvironnementGeneric::updateTimeAndFrameCount();
    _sdlWin->CalculateFrameRate();
 
}//@CODE_881


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_865
Method which must be called first in a constructor.
*/
void EnvironnementSDL::ConstructorInclude()
{
}


/*@NOTE_866
Method which must be called first in a destructor.
*/
void EnvironnementSDL::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
/*osg::Matrixd matView;
  osg::Matrixd matProj;

  matView=_sv->getViewMatrix();
  matProj=_sv->getProjectionMatrix();
  std::cout<<"matView="<<matView<<std::endl;
  std::cout<<"matProj="<<matProj<<std::endl;*/
  /*std::cout<<"x="<<x<<std::endl;
    std::cout<<"y="<<y<<std::endl;*/
  
/* osgIsect::PolytopeIntersectVisitor::HitList hlist;
  osgIsect::PolytopePicker picker_polytope;
  

  CTRACE(this,"")<<"Start Picking"<<endl;
  bool found=picker_polytope.pick(x,y,matView,matProj,_sv->getSceneData(),hlist,0,0);
  CTRACE(this,"")<<"End Picking"<<endl;

  for (PolytopeIntersectVisitor::HitList::iterator hitr=hlist.begin();hitr!=hlist.end();hitr++)
    {
      
      osgIsect::HitBase hit=*(hitr);
      osgUtil::Hit osghit;
      osghit._geode = hit._geode;

      cout<<"géode.getName="<<hit._geode->getName()<<endl;
      hitlist.push_back(osghit);*/
      
      /*osghit._ratio = hit._ratio;
	osghit._nodePath = hit._nodePath;
	sghit._drawable = hit._drawable;
	osghit._matrix = hit._matrix;
	osghit._inverse = hit._inverse;
	VecIndexList                    _vecIndexList;
	int                             _primitiveIndex;
	osg::Vec3                       _intersectPoint;
	osg::Vec3                       _intersectNormal;
	osg::ref_ptr<osg::LineSegment> _originalLineSegment
	osg::ref_ptr<osg::LineSegment> _localLineSegment*/
      /*    }      
  
      return found;*/
