/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EnvironnementSDL.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EnvironnementSDL'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _ENVIRONNEMENTSDL_H
#define _ENVIRONNEMENTSDL_H

//@START_USER1
#include "SDLWindows.h"

#include <osg/Geode>
#include <osg/ref_ptr>
#include <osg/FrameStamp>
#include <osg/DisplaySettings>
#include <osg/State>
#include <osg/TexGen>
#include <osg/Texture2D>
#include <osgDB/ReadFile>
#include <osgDB/WriteFile>


#include <osgGA/TrackballManipulator>
#include <osgGA/GUIActionAdapter>
#include <osgGA/GUIEventHandler>
#include <osgGA/MatrixManipulator>

//#include <osgSDL/Cursor>
//#include <osgSDL/EvtAdapterSDL>
//using namespace osgSDL;

#include <SDL.h>

#include <osgUtil/SceneView>
#include <osgUtil/DisplayRequirementsVisitor>
#include <osg/Timer>

#include "EnvironnementGeneric.h"
#include "EvtAdapterSDL.h"


using namespace std;

namespace cooki3d{
//@END_USER1


/*@NOTE_863
class ...
*/

class AFX_EXT_CLASS EnvironnementSDL
    : public EnvironnementGeneric
{

//@START_USER2
  typedef list<osg::ref_ptr<osgGA::GUIEventHandler> > ListEH;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    SDLWindow* _sdlWin;

//
// Non-Grouped Methods
//

protected:
    bool callHandlers(const EvtAdapterSDL& adapter);
    void fireEvent(const SDL_Event& event);
    void processUserEvent(int code, void* data, int datalen);
    void run();
    void runOnce();
    virtual void updateTimeAndFrameCount();

public:
    EnvironnementSDL(int argc, char** argv, LoaderGeneric* loader);
    virtual ~EnvironnementSDL();
    virtual void appIdle();
    virtual void requestWarpPointer(float x, float y);
    virtual void run(osg::Node* n);
    virtual void stop();
};

#endif


#ifdef CB_INLINES
#ifndef _ENVIRONNEMENTSDL_H_INLINES
#define _ENVIRONNEMENTSDL_H_INLINES

//@START_USER3
}//end of namespace cooki3d 
//@END_USER3

#endif
#endif
