/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Evaluable.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Evaluable'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "Evaluable.h"
#include "BD.h"
#include "MapRW.h"
#include "LoaderGeneric.h"

using namespace cooki3d;

extern "C"{
  extern double mainYacc(char * ch);
  


  double GetResultat2(char *nomObj,char *nomMeth,double * params,int nbparam){
   
    cout<<"nomMeth"<<nomMeth<<endl;
    cout<<"nomObj"<<nomObj<<endl;

    //on se contente de prendre le premier objet correspondant au nom
    //sachant que pour Animation01 par exemple, toutes les animations
    //de même nom sont synchro et cencé avoir les mêmes propriétées
    ///Evaluable * obj= NULL;
    ///cooki3d::BD::instance()->FindEvaluable(nomObj);
    ///assertC(obj);
    ///return obj->eval(nomMeth,params,nbparam);    
    return 0.0;
  }
  
}

namespace cooki3d{
//@END_USER2


// Static members
std::string Evaluable::_createInstancePrefix = "";
int Evaluable::_instanceCount = 0;


/*@NOTE_4844
Constructor method.
*/
Evaluable::Evaluable(BD* pBD) //@INIT_4844
    : _persistantTODO(false)
    , _noDeleteFlag(false)
{//@CODE_4844
  if ( int(pBD) != -1 ){
      assertC( pBD );
      ConstructorInclude(pBD);
    
      _name = "Evaluable#";
      MapRW map;
      map.writeToStr( Evaluable::_instanceCount++ , _name);
  }
  else {
      CTRACE( this, "Evaluable")
          <<"cas exceptionnel : stl_map need default constructor"<<endl;
      _noDeleteFlag = true;
  }
}//@CODE_4844


/*@NOTE_312
Destructor method.
*/
Evaluable::~Evaluable()
{//@CODE_312
  //TODO Enlever l'aggrégation CB et la remplacer par un objet plus puissant
  
  
  if ( !_noDeleteFlag){ 
    CTRACE(this,"~Evaluable")<<"Destuction de "<<_name
			     <<" (getBD()="<<getBD()<<") "<<endl;
    DestructorInclude();
    //NOTE: getBD() derrière DestructorInclude donne 0
  } else {
    //si _noDeleteFlag dans ce cas là, la base est peutetre déjà rasée
    //il ne faut pas essayer de déférencer l'évaluable.
    CTRACE(this,"~Evaluable")<<"Destuction de "<<_name<<" _noDeleteFlag actif!"
			     <<" (getBD()="<<getBD()<<") "<<endl;
  }
  
  // Put in your own code
}//@CODE_312


/*@NOTE_4085
Check the integritry of the object
*/
bool Evaluable::check()
{//@CODE_4085
       
    return true;
}//@CODE_4085


double Evaluable::eval(std::string methode, double args[10], int nbParam)
{//@CODE_318
  CERR(this,"eval")<<"cette méthode n'est pas implémenté pour l'objet fils"<<endl;
  return 0.0;
}//@CODE_318


BD* Evaluable::getBD() const
{//@CODE_4807
    return GetBD();
}//@CODE_4807


EnvironnementOSG* Evaluable::getEnv() const
{//@CODE_4840
    return getBD()->getLoader()->getEnv();
}//@CODE_4840


bool Evaluable::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_3024

  CERR(this,"loadXML")
    <<"cette méthode n'est pas implémenté pour l'objet fils"<<endl;
    
  return false;

}//@CODE_3024


void Evaluable::setNameWithoutPrefix(std::string name)
{//@CODE_3793
    _name = name;
}//@CODE_3793


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_313
Method which must be called first in a constructor.
*/
void Evaluable::ConstructorInclude(BD* pBD)
{
    INIT_MULTI_OWNED_PASSIVE(BD, BD, Evaluable, Evaluable)
}


/*@NOTE_314
Method which must be called first in a destructor.
*/
void Evaluable::DestructorInclude()
{
    EXIT_MULTI_OWNED_PASSIVE(BD, BD, Evaluable, Evaluable)
}


// Methods for the relation(s) of the class
METHODS_MULTI_OWNED_PASSIVE(BD, BD, Evaluable, Evaluable)

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
