/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Evaluable.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Evaluable'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVALUABLE_H
#define _EVALUABLE_H

//@START_USER1

#include "XMLUtil.h"
#include "CookiMetier.h"


namespace cooki3d{
  class BD;
  class LoaderXML;
  class EnvironnementOSG;
  class LoaderGeneric;
//@END_USER1


/*@NOTE_311
class...
*/

class AFX_EXT_CLASS Evaluable
{
    RELATION_MULTI_OWNED_PASSIVE(BD, BD, Evaluable, Evaluable)

//@START_USER2
 public:
  //pf p2=&test::lit
  //typedef double (Evaluable::* pf0)(void);
  //typedef map<string,pf0,less<string > > mapStrFonc;
  
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude(BD* pBD);
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    std::string _name;
    bool _persistantTODO;
    static std::string _createInstancePrefix;
    bool _noDeleteFlag;
    static int _instanceCount;

//
// Non-Grouped Methods
//

public:
    Evaluable(BD* pBD);
    virtual ~Evaluable();
    virtual bool check();
    virtual double eval(std::string methode, double args[10], int nbParam);
    BD* getBD() const;
    EnvironnementOSG* getEnv() const;
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    void setNameWithoutPrefix(std::string name);
    static std::string getCreateInstancePrefix();
    static void setCreateInstancePrefix(std::string createInstancePrefix);
    std::string getName() const;
    void setName(std::string name);
    bool isNoDeleteFlag() const;
    void setNoDeleteFlag(bool noDeleteFlag);
};

#endif


#ifdef CB_INLINES
#ifndef _EVALUABLE_H_INLINES
#define _EVALUABLE_H_INLINES

/*@NOTE_3531
Returns the value of member '_createInstancePrefix'.
*/
inline std::string Evaluable::getCreateInstancePrefix()
{//@CODE_3531
    return _createInstancePrefix;
}//@CODE_3531



/*@NOTE_3532
Set the value of member '_createInstancePrefix' to 'createInstancePrefix'.
*/
inline void Evaluable::setCreateInstancePrefix(std::string createInstancePrefix)
{//@CODE_3532
    _createInstancePrefix = createInstancePrefix;
}//@CODE_3532



/*@NOTE_939
Returns the value of member '_name'.
*/
inline std::string Evaluable::getName() const
{//@CODE_939
    return _name;
}//@CODE_939



/*@NOTE_940
Set the value of member '_name' to 'name'.
*/
inline void Evaluable::setName(std::string name)
{//@CODE_940
  //TODO détecter les erreurs de doublons
    _name =  _createInstancePrefix+name;
}//@CODE_940



/*@NOTE_4447
Returns the value of member '_noDeleteFlag'.
*/
inline bool Evaluable::isNoDeleteFlag() const
{//@CODE_4447
    return _noDeleteFlag;
}//@CODE_4447



/*@NOTE_4448
Set the value of member '_noDeleteFlag' to 'noDeleteFlag'.
*/
inline void Evaluable::setNoDeleteFlag(bool noDeleteFlag)
{//@CODE_4448
    _noDeleteFlag = noDeleteFlag;
}//@CODE_4448



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
