/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Event.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Event'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVENT_H
#define _EVENT_H

//@START_USER1
#include "Function_1arg.h"
#include "Evaluable.h"
#include "XMLUtil.h"


namespace cooki3d{

  class Command;
//@END_USER1


/*@NOTE_86
classe ...
*/

class AFX_EXT_CLASS Event
    : public virtual Evaluable
{

//@START_USER2
public: 
    
  //typedef Function_1arg<Event*> FctEvtMouse;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    bool _active;
    EnvironnementOSG* _envOSG;
    std::string _code;
    static std::string _emptyEvent;

//
// Non-Grouped Methods
//

public:
    Event(BD* pBD);
    virtual ~Event();
    virtual void executerActions() = 0;
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML) = 0;
    bool getActive() const;
    void setActive(bool active);
    std::string getCode() const;
    void setCode(std::string code);
    EnvironnementOSG* getEnvOSG() const;
    void setEnvOSG(EnvironnementOSG* pEnvOSG);
};

#endif


#ifdef CB_INLINES
#ifndef _EVENT_H_INLINES
#define _EVENT_H_INLINES

/*@NOTE_966
Returns the value of member '_active'.
*/
inline bool Event::getActive() const
{//@CODE_966
    return _active;
}//@CODE_966



/*@NOTE_967
Set the value of member '_active' to 'active'.
*/
inline void Event::setActive(bool active)
{//@CODE_967
    _active = active;
}//@CODE_967



/*@NOTE_3523
Returns the value of member '_code'.
*/
inline std::string Event::getCode() const
{//@CODE_3523
    return _code;
}//@CODE_3523



/*@NOTE_3524
Set the value of member '_code' to 'code'.
*/
inline void Event::setCode(std::string code)
{//@CODE_3524
    _code = code;
}//@CODE_3524



/*@NOTE_3515
Returns the value of member '_envOSG'.
*/
inline EnvironnementOSG* Event::getEnvOSG() const
{//@CODE_3515
    return _envOSG;
}//@CODE_3515



/*@NOTE_3516
Set the value of member '_envOSG' to 'pEnvOSG'.
*/
inline void Event::setEnvOSG(EnvironnementOSG* pEnvOSG)
{//@CODE_3516
    _envOSG = pEnvOSG;
}//@CODE_3516



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
