/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtAdapterJava.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtAdapterJava'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "EvtAdapterJava.h"
#include <osgGA/GUIEventAdapter>
#include "EnvironnementJava.h"


#define BUTTON1_MASK 16L
#define BUTTON2_MASK 8L
#define BUTTON3_MASK 4L


//TODO User editeur_canvas_CanvasListener defines

namespace cooki3d{
//@END_USER2




/*@NOTE_1781
5Constructor method.
*/
EvtAdapterJava::EvtAdapterJava() //@INIT_1781

{//@CODE_1781
    ConstructorInclude();
    
    // Put in your own code
}//@CODE_1781


/*@NOTE_1726
Destructor method.
*/
EvtAdapterJava::~EvtAdapterJava()
{//@CODE_1726
    DestructorInclude();

    // Put in your own code
}//@CODE_1726


void EvtAdapterJava::fireJavaEventKey(int keycode, long bdRef)
{//@CODE_2364
  
  osg::ref_ptr<EvtAdapterJava> eaj=new EvtAdapterJava();

  eaj->setEventType( osgGA::GUIEventAdapter::KEYDOWN );
  eaj->setKey( keycode );
  cerr<<"keycode="<<keycode<<endl;
  
 
 //GUIEventAdapter::MIDDLE_MOUSE_BUTTON
  //GUIEventAdapter::RIGHT_MOUSE_BUTTON
  BD * pBD = ( BD*)bdRef ;
  assertC2( BD::checkAdrBD( pBD), NULL  );
  EnvironnementJava * ej=static_cast<EnvironnementJava*>( pBD->getEnv() );
  
  if (ej){
    //eaj->_time = ej->getTimeSinceStart();
    ej->callHandlers(*eaj);
  }

  
}//@CODE_2364


void EvtAdapterJava::fireJavaEventMouse(int x, int y, int mask, int type,
                                        long bdRef)
{//@CODE_2373

  BD * pBD = ( BD*)bdRef;
  assertC2( BD::checkAdrBD( pBD ), NULL );
  EnvironnementJava * ej=static_cast<EnvironnementJava*>( pBD->getEnv() );
  assertC2( ej, pBD );

  osg::ref_ptr<EvtAdapterJava> eaj=new EvtAdapterJava();

  eaj->setEventType( (osgGA::GUIEventAdapter::EventType)type );

  int vx, vy, vw, vh;
  ej->getViewport( vx,  vy,  vw,  vh);
  eaj->setX( (float(x)/vw) );
  eaj->setY( (float(y)/vh) );
  
  //cout<<"mask="<<mask<<endl;
  //cout<<"x= "<<x<<"y= "<<y<<"mask="<<mask<<endl;
  //cout<<"eaj->_x="<<eaj->_x<<" eaj->_y="<<eaj->_y<<endl;;

  if (mask & BUTTON1_MASK) {
    eaj->setButtonMask ( eaj->getButtonMask()  | LEFT_MOUSE_BUTTON );
    eaj->setButton( LEFT_MOUSE_BUTTON );
  }
  if (mask & BUTTON2_MASK) {
    eaj->setButtonMask( eaj->getButtonMask() | MIDDLE_MOUSE_BUTTON);
    eaj->setButton( MIDDLE_MOUSE_BUTTON );
  }
  if (mask & BUTTON3_MASK) {
    eaj->setButtonMask( eaj->getButtonMask() | RIGHT_MOUSE_BUTTON); 
    eaj->setButton( RIGHT_MOUSE_BUTTON ); 
  }

  if (eaj->getEventType() != osgGA::GUIEventAdapter::PUSH
      && eaj->getEventType() != osgGA::GUIEventAdapter::RELEASE){ 
    eaj->setButton( -1 );
  }else if (eaj->getEventType() == osgGA::GUIEventAdapter::RELEASE){
    eaj->setButtonMask( 0 );
  }
  
  assertC2( eaj->getButton(), pBD );
  
  //eaj->_time = ej->getTimeSinceStart(); //déjà fait de EnvironnementJava
  ej->callHandlers(*eaj);
 
  
}//@CODE_2373


void EvtAdapterJava::fireJavaEventMouseDragged(int x, int y, int mask,
                                               long bdRef)
{//@CODE_1829
  
  fireJavaEventMouse(x, y, mask, osgGA::GUIEventAdapter::DRAG, bdRef);
  
}//@CODE_1829


void EvtAdapterJava::fireJavaEventMouseMoved(int x, int y, int mask, long bdRef)
{//@CODE_1821
  
  fireJavaEventMouse(x, y, mask, osgGA::GUIEventAdapter::MOVE, bdRef);
    
}//@CODE_1821


void EvtAdapterJava::fireJavaEventMousePressed(int x, int y, int mask,
                                               long bdRef)
{//@CODE_1799

  //cout<<"x= "<<x<<"y= "<<y<<"mask="<<mask<<endl;
  fireJavaEventMouse(x, y, mask, osgGA::GUIEventAdapter::PUSH, bdRef);
    
}//@CODE_1799


void EvtAdapterJava::fireJavaEventMouseReleased(int x, int y, int mask,
                                                long bdRef)
{//@CODE_1825

  fireJavaEventMouse(x, y, mask, osgGA::GUIEventAdapter::RELEASE, bdRef);
  
}//@CODE_1825


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1727
Method which must be called first in a constructor.
*/
void EvtAdapterJava::ConstructorInclude()
{
}


/*@NOTE_1728
Method which must be called first in a destructor.
*/
void EvtAdapterJava::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d

//SI 
//OSG version < 1.2
// void EvtAdapterJava::fireJavaEventKey(int keycode)
// {//@CODE_2364
  
//   EvtAdapterJava * eaj=new EvtAdapterJava();

//   eaj->_eventType = osgGA::GUIEventAdapter::KEYDOWN;
//   eaj->_key=keycode;
//   cerr<<"keycode="<<keycode<<endl;
  
 
//  //GUIEventAdapter::MIDDLE_MOUSE_BUTTON
//   //GUIEventAdapter::RIGHT_MOUSE_BUTTON


//   EnvironnementJava * ej=static_cast<EnvironnementJava*>(EnvironnementOSG::instance());
  
//   if (ej){
//     //eaj->_time = ej->getTimeSinceStart();
//     ej->call_handlers(*eaj);
//   }

//   delete eaj;

  
// }//@CODE_2364

// void EvtAdapterJava::fireJavaEventMouse(int x, int y, int mask, int type)
// {//@CODE_2373
  
//   EvtAdapterJava * eaj=new EvtAdapterJava();

//   eaj->_eventType = (osgGA::GUIEventAdapter::EventType)type;
//   eaj->_x=x;
//   eaj->_y=y;
  
//   //cout<<"mask="<<mask<<endl;
//   cout<<"x= "<<x<<"y= "<<y<<"mask="<<mask<<endl;
//   cout<<"eaj->_x="<<eaj->_x<<" eaj->_y="<<eaj->_y<<endl;;

//   if (mask & BUTTON1_MASK) {
//     eaj->_buttonMask |= LEFT_MOUSE_BUTTON;
//     eaj->_button = LEFT_MOUSE_BUTTON;
//   }
//   if (mask & BUTTON2_MASK) {
//     eaj->_buttonMask |= MIDDLE_MOUSE_BUTTON;
//     eaj->_button = MIDDLE_MOUSE_BUTTON;
//   }
//   if (mask & BUTTON3_MASK) {
//     eaj->_buttonMask |= RIGHT_MOUSE_BUTTON; 
//     eaj->_button = RIGHT_MOUSE_BUTTON; 
//   }

//   if (eaj->_eventType != osgGA::GUIEventAdapter::PUSH
//       && eaj->_eventType != osgGA::GUIEventAdapter::RELEASE){ 
//     eaj->_button = -1;
//   }else if (eaj->_eventType == osgGA::GUIEventAdapter::RELEASE){
//     eaj->_buttonMask = 0;
//   }
  
//   assertC( eaj->_button );
  
//   EnvironnementJava * ej=static_cast<EnvironnementJava*>(EnvironnementOSG::instance());
  
//   if (ej){
//     //eaj->_time = ej->getTimeSinceStart(); //déjà fait de EnvironnementJava
//     ej->call_handlers(*eaj);
//   }
//   delete eaj;
  
// }//@CODE_2373
