/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtAdapterQT.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtAdapterQT'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "EvtAdapterQT.h"
#include <osgGA/GUIEventAdapter>
#include "EnvironnementQT.h"



#ifdef QGL_SUPPORT
//#include <QGLViewer/qglviewer.h>
#include <qmap.h>
#include "Methode_1arg.h"
#include "CommandThread.h"
namespace cooki3d{



//@END_USER2




/*@NOTE_2445
5Constructor method.
*/
EvtAdapterQT::EvtAdapterQT(EnvironnementQT* envQT) //@INIT_2445

  : _envQT(envQT)
{//@CODE_2445
    ConstructorInclude();

    // Put in your own code
}//@CODE_2445


/*@NOTE_2428
Destructor method.
*/
EvtAdapterQT::~EvtAdapterQT()
{//@CODE_2428
    DestructorInclude();

    // Put in your own code
}//@CODE_2428


void EvtAdapterQT::fireEventKey(int keycode)
{//@CODE_2446
  
  //  EvtAdapterQT * eaj=new EvtAdapterQT(_envQT);

  this->setEventType( osgGA::GUIEventAdapter::KEYDOWN );
  this->setKey( keycode );
  //cerr<<"keycode="<<keycode<<endl;
  
 
 //GUIEventAdapter::MIDDLE_MOUSE_BUTTON
  //GUIEventAdapter::RIGHT_MOUSE_BUTTON

  if (_envQT){
    _envQT->callHandlers(*this);
  }

  
}//@CODE_2446


void EvtAdapterQT::fireEventMouse(QMouseEvent* e, int type)
{//@CODE_2448

  this->setButton( e->button() );


  //Qt::KeyboardModifiers and Qt::MouseButtons
  
  
#if QT_VERSION < 0x040000

  if(e->stateAfter() & QEvent::LeftButton){
    this->setButtonMask(this->getButtonMask() 
			| LEFT_MOUSE_BUTTON);
  }
  if(e->stateAfter() & QEvent::MidButton){
    this->setButtonMask(this->getButtonMask() 
			| MIDDLE_MOUSE_BUTTON);
  }
  if(e->stateAfter() & QEvent::RightButton){
    this->setButtonMask(this->getButtonMask()
			| RIGHT_MOUSE_BUTTON);
  }
  // - a Ctrl key on the keyboard is also pressed. 
  if(e->stateAfter() & Qt::ControlButton){
    this->setModKeyMask( this->getModKeyMask()
			 | osgGA::GUIEventAdapter::MODKEY_CTRL);
  }
  // - an Alt key on the keyboard is also pressed. 
  if(e->stateAfter() &  Qt::AltButton){
    this->setModKeyMask(this->getModKeyMask() 
			| osgGA::GUIEventAdapter::MODKEY_ALT);
  }
  // - a Meta key on the keyboard is also pressed. 
  if(e->stateAfter() & Qt::MetaButton){
    this->setModKeyMask(this->getModKeyMask()
			| osgGA::GUIEventAdapter::MODKEY_META);
  }
  // - an Shift key on the keyboard is also pressed. 
  if(e->stateAfter() &  Qt::ShiftButton){
    this->setModKeyMask(this->getModKeyMask()
			| osgGA::GUIEventAdapter::MODKEY_SHIFT);
  }

#else
  
  if(e->buttons() & Qt::LeftButton){
    this->setButtonMask(this->getButtonMask()
			| LEFT_MOUSE_BUTTON);
  }
  if(e->buttons() & Qt::MidButton){
    this->setButtonMask(this->getButtonMask() 
			| MIDDLE_MOUSE_BUTTON);
  }
  if(e->buttons() & Qt::RightButton){
    this->setButtonMask( this->getButtonMask()
			 | RIGHT_MOUSE_BUTTON);
  }
  // - a Ctrl key on the keyboard is also pressed. 
  if(e->buttons() & Qt::CTRL){
    this->setModKeyMask( this->getModKeyMask()
			 | osgGA::GUIEventAdapter::MODKEY_CTRL);
  }
  // - an Alt key on the keyboard is also pressed. 
  if(e->buttons() &  Qt::ALT){
    this->setModKeyMask( this->getModKeyMask()
			 | osgGA::GUIEventAdapter::MODKEY_ALT);
  }
  // - a Meta key on the keyboard is also pressed. 
  if(e->buttons() & Qt::META){
    this->setModKeyMask( this->getModKeyMask()
			 | osgGA::GUIEventAdapter::MODKEY_META);
  }
  // - an Shift key on the keyboard is also pressed. 
  if(e->buttons() &  Qt::SHIFT){
    this->setModKeyMask( this->getModKeyMask()
			 | osgGA::GUIEventAdapter::MODKEY_SHIFT);
  }

#endif


  this->setEventType( (osgGA::GUIEventAdapter::EventType)type );

  assertC2(_envQT, NULL);
  
  int vx, vy, vw, vh;
  _envQT->getViewport( vx,  vy,  vw,  vh);
  this->setX( float(e->x())/vw );
  this->setY( float(e->y())/vh );    
  
  _envQT->callHandlers(*this);
    

}//@CODE_2448


void EvtAdapterQT::fireEventMouseDragged(QMouseEvent* e)
{//@CODE_2453
  
  fireEventMouse(e, osgGA::GUIEventAdapter::DRAG);
  
}//@CODE_2453


void EvtAdapterQT::fireEventMouseMoved(QMouseEvent* e)
{//@CODE_2457
  
  fireEventMouse(e, osgGA::GUIEventAdapter::MOVE);
    
}//@CODE_2457


void EvtAdapterQT::fireEventMousePressed(QMouseEvent* e)
{//@CODE_2461

  fireEventMouse(e, osgGA::GUIEventAdapter::PUSH);
  
  
    
}//@CODE_2461


void EvtAdapterQT::fireEventMouseReleased(QMouseEvent* e)
{//@CODE_2465

  fireEventMouse(e, osgGA::GUIEventAdapter::RELEASE);
  
}//@CODE_2465


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_2429
Method which must be called first in a constructor.
*/
void EvtAdapterQT::ConstructorInclude()
{
}


/*@NOTE_2430
Method which must be called first in a destructor.
*/
void EvtAdapterQT::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
#endif
