/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtAdapterQT.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtAdapterQT'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVTADAPTERQT_H
#define _EVTADAPTERQT_H

//@START_USER1
#include <osgGA/GUIEventAdapter>

#ifdef QGL_SUPPORT
#include <qmap.h>
#include <qevent.h>
//#include <QGLViewer/qglviewer.h>
#else 
#include "specialNoSupport/QGLPseudoSupport.h"
#endif



namespace cooki3d{
  class EnvironnementQT;
//@END_USER1


/*@NOTE_2427
class ...
*/

class AFX_EXT_CLASS EvtAdapterQT
    : public osgGA::GUIEventAdapter
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    EnvironnementQT* _envQT;

//
// Non-Grouped Methods
//

protected:
    virtual ~EvtAdapterQT();

public:
    EvtAdapterQT(EnvironnementQT* envQT);
    void fireEventKey(int keycode);
    void fireEventMouse(QMouseEvent* e, int type);
    void fireEventMouseDragged(QMouseEvent* e);
    void fireEventMouseMoved(QMouseEvent* e);
    void fireEventMousePressed(QMouseEvent* e);
    void fireEventMouseReleased(QMouseEvent* e);
    EnvironnementQT* getEnvQT() const;
    void setEnvQT(EnvironnementQT* pEnvQT);
};

#endif


#ifdef CB_INLINES
#ifndef _EVTADAPTERQT_H_INLINES
#define _EVTADAPTERQT_H_INLINES

/*@NOTE_2771
Returns the value of member '_envQT'.
*/
inline EnvironnementQT* EvtAdapterQT::getEnvQT() const
{//@CODE_2771
    return _envQT;
}//@CODE_2771



/*@NOTE_2772
Set the value of member '_envQT' to 'pEnvQT'.
*/
inline void EvtAdapterQT::setEnvQT(EnvironnementQT* pEnvQT)
{//@CODE_2772
    _envQT = pEnvQT;
}//@CODE_2772



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
