/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtBoundingShapeCollision.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtBoundingShapeCollision'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVTBOUNDINGSHAPECOLLISION_H
#define _EVTBOUNDINGSHAPECOLLISION_H

//@START_USER1


#include "Event.h"
#include "BoundingShape.h"
#include "TimeBar.h"
#include "TimeMod.h"
#include "MapRegister.h"
#include "Methode_1arg.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_3668
classe ...
*/

class AFX_EXT_CLASS EvtBoundingShapeCollision
    : public Event
{

//@START_USER2
public: 
  typedef vector<EvtBoundingShapeCollision*> Liste;
  //typedef 
  //Function_1arg<EvtBoundingShapeCollision*> FctEvtBoundingShapeCollision;
  //typedef Methode_1arg<Evaluable,EvtBoundingShapeCollision*> 
  //FctEvtBoundingShapeCollision;
  typedef Command FctEvtBoundingShapeCollision;

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: load
//

public:
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    static Evaluable* staticCreate(BD* pBD);
    EvtBoundingShapeCollision(BD* pBD);
    virtual ~EvtBoundingShapeCollision();
    bool load();

//
// Non-Grouped Members
//

private:
    float _X;
    float _Y;
    float _Z;
    FctEvtBoundingShapeCollision* _codeExec;
    BoundingShape* _collision1;
    BoundingShape* _collision2;
    osg::Timer_t _tick;
    static MapRegister<EvtBoundingShapeCollision*> _register;
    double _standbyDelay;
    int _refreshPeriod;

//
// Non-Grouped Methods
//

public:
    virtual void executerActions();
    static void sendFrameEvt(BD* pBD);
    void test();
    void setCollision1(BoundingShape* pCollision1);
    BoundingShape* getCollision1() const;
    void setCollision2(BoundingShape* pCollision2);
    BoundingShape* getCollision2() const;
    int getRefreshPeriod() const;
    void setRefreshPeriod(int refreshPeriod);
    void setStandbyDelay(double standbyDelay);
    double getStandbyDelay() const;
    float getX() const;
    void setX(float x);
    float getY() const;
    void setY(float y);
    float getZ() const;
    void setZ(float z);
};

#endif


#ifdef CB_INLINES
#ifndef _EVTBOUNDINGSHAPECOLLISION_H_INLINES
#define _EVTBOUNDINGSHAPECOLLISION_H_INLINES

inline void EvtBoundingShapeCollision::sendFrameEvt(BD* pBD)
{//@CODE_3724

  //parcours de tous les évenements
  Register<EvtBoundingShapeCollision*> & reg = _register.getRegister(pBD);
  Register<EvtBoundingShapeCollision*>::iterator it = reg.begin();

  while (it != reg.end() ){
    it->second->test();
    it++;
  }
  
  //on increment le numero de frame
  BoundingShape::_lastFrameNumber = (BoundingShape::_lastFrameNumber+1)%100000;
}//@CODE_3724



/*@NOTE_3689
Set the value of member '_collision1' to 'pCollision1'.
*/
inline void EvtBoundingShapeCollision::setCollision1(BoundingShape* pCollision1)
{//@CODE_3689
    _collision1 = pCollision1;
}//@CODE_3689



/*@NOTE_3708
Returns the value of member '_collision1'.
*/
inline BoundingShape* EvtBoundingShapeCollision::getCollision1() const
{//@CODE_3708
    return _collision1;
}//@CODE_3708



/*@NOTE_3693
Set the value of member '_collision2' to 'pCollision2'.
*/
inline void EvtBoundingShapeCollision::setCollision2(BoundingShape* pCollision2)
{//@CODE_3693
    _collision2 = pCollision2;
}//@CODE_3693



/*@NOTE_3707
Returns the value of member '_collision2'.
*/
inline BoundingShape* EvtBoundingShapeCollision::getCollision2() const
{//@CODE_3707
    return _collision2;
}//@CODE_3707



/*@NOTE_3778
Returns the value of member '_refreshPeriod'.
*/
inline int EvtBoundingShapeCollision::getRefreshPeriod() const
{//@CODE_3778
    return _refreshPeriod;
}//@CODE_3778



/*@NOTE_3779
Set the value of member '_refreshPeriod' to 'refreshPeriod'.
*/
inline void EvtBoundingShapeCollision::setRefreshPeriod(int refreshPeriod)
{//@CODE_3779
    _refreshPeriod = refreshPeriod;
}//@CODE_3779



/*@NOTE_3782
Set the value of member '_standbyDelay' to 'standbyDelay'.
*/
inline void EvtBoundingShapeCollision::setStandbyDelay(double standbyDelay)
{//@CODE_3782
    _standbyDelay = standbyDelay;
}//@CODE_3782



/*@NOTE_4081
Returns the value of member '_standbyDelay'.
*/
inline double EvtBoundingShapeCollision::getStandbyDelay() const
{//@CODE_4081
    return _standbyDelay;
}//@CODE_4081



/*@NOTE_3675
Returns the value of member '_X'.
*/
inline float EvtBoundingShapeCollision::getX() const
{//@CODE_3675
    return _X;
}//@CODE_3675



/*@NOTE_3676
Set the value of member '_X' to 'x'.
*/
inline void EvtBoundingShapeCollision::setX(float x)
{//@CODE_3676
    _X = x;
}//@CODE_3676



/*@NOTE_3679
Returns the value of member '_Y'.
*/
inline float EvtBoundingShapeCollision::getY() const
{//@CODE_3679
    return _Y;
}//@CODE_3679



/*@NOTE_3680
Set the value of member '_Y' to 'y'.
*/
inline void EvtBoundingShapeCollision::setY(float y)
{//@CODE_3680
    _Y = y;
}//@CODE_3680



/*@NOTE_3683
Returns the value of member '_Z'.
*/
inline float EvtBoundingShapeCollision::getZ() const
{//@CODE_3683
    return _Z;
}//@CODE_3683



/*@NOTE_3684
Set the value of member '_Z' to 'z'.
*/
inline void EvtBoundingShapeCollision::setZ(float z)
{//@CODE_3684
    _Z = z;
}//@CODE_3684



//@START_USER3
//attention CB fait parfois sauter ce crochet fermant...
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
