/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtHandler.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtHandler'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
//#include "Activite.h"
#include "EvtHandler.h"
#include <iostream>
#include <osgGA/GUIEventHandler>
#include "EnvironnementOSG.h"
//#include "BD.h"
#include "EvtMouse.h"
#include "CommandThread.h"
#include "Function_3args.h"
#include "Camera.h"
#include "EvtKey.h"
#include "EvtBoundingShapeCollision.h"
#include "ScanSetGraph.h"

namespace cooki3d{
//@END_USER2




/*@NOTE_99
Constructor method.
*/
EvtHandler::EvtHandler(EnvironnementOSG* envOSG) //@INIT_99
    : _envOSG(envOSG)
{//@CODE_99
    ConstructorInclude();
    //handlerDiscret = true;
    // Put in your own code
}//@CODE_99


/*@NOTE_93
Destructor method.
*/
EvtHandler::~EvtHandler()
{//@CODE_93
  
  DestructorInclude();
  CTRACE(this,"~EvtHandler")<<"destruction EvtHandler : "<<this<<endl;
  // Put in your own code
}//@CODE_93


void EvtHandler::accept(osgGA::GUIEventHandlerVisitor& gehv)
{//@CODE_137
   gehv.visit(*this); 
   
}//@CODE_137


void EvtHandler::getUsage(osg::ApplicationUsage& rUsage) const
{//@CODE_133
  rUsage.addKeyboardMouseBinding("c","the COOKIE touuuuuuuuuuuuuuuuuuuuuuuch");
  CTRACE(this,"getUsage")<<"Mon getUsage est appelé"<<std::endl;
}//@CODE_133


bool EvtHandler::handle(const osgGA::GUIEventAdapter& ea,
                        osgGA::GUIActionAdapter& aa)
{//@CODE_129

  std::string evt= "Null";
  EvtMouse::Liste objEvt;
  std::string Nomobj;
  osg::Vec3 Point;
  static float derX,derY;
  bool reponse = false;
  
  
  switch(ea.getEventType()){
    
  case osgGA::GUIEventAdapter::KEYDOWN:
    {
      
      
      CTRACE(this,"handle")<<" KEYDOWN ea.getKey()="<<ea.getKey()<<endl;
      
      reponse = EvtKey::process(ea,_envOSG);
      
      switch( ea.getKey() )  {
      
      case 'c' :  
      case 'C':
	{
	  
	  
	  /*if (_envOSG->getActiveCamera()=="" 
	    && Camera::getCamera("level0::camera0")!=NULL){
	    _envOSG->setActiveCamera("level0::camera0");
	  }
	  else {
	  _envOSG->setActiveCamera("");
	  }*/	  
	  Camera * cam = NULL;
	  if (_envOSG->getActiveCamera()== "" ){
	    cam = Camera::getFirstCamera(_envOSG->getBD());
	  }else {
	    cam = Camera::getNextCamera( _envOSG->getBD(),
					 _envOSG->getActiveCamera() );
	  }

	  if (cam){
	    _envOSG->setActiveCamera( cam->getName() );
	  }else {
	    _envOSG->setActiveCamera( "" );
	  }
	  cout<<"set next camera... \""
	      <<_envOSG->getActiveCamera()
	      <<"\""<<endl; 

	  reponse = true;
	}	       
	/*case osgGA::GUIEventAdapter::KEY_Print :
	  case osgGA::GUIEventAdapter::KEY_Help :*/
	break;
      case 's' :  
      case 'S':
	{
	  
	  osgUtil::IntersectVisitor::HitList hits;
	  
	  _envOSG->computeIntersections( derX, derY, hits,0x1);    
	  
	  if (hits.size()>0) {
	    //cout<<"name="<<hits[0]._geode->getName()<<endl;

#ifdef UNIX
	    FILE * filePtr = fopen("/tmp/selectionCooki","wb");
	    CTRACE(this,"handle")<<" open /tmp/selectionCooki "<<endl;
#else
	    std::string s = getenv("SYSTEMROOT");
	    s = s+ "\\TEMP\\selectionCooki";
	    FILE * filePtr = fopen(s.c_str(),"wb");
	    CTRACE(this,"handle")<<" open "<<s<<endl;
#endif
	    if (!filePtr) { 
	      CERR(this,"EvtHandler::handle")<<"Impossible de crée un fichier "
					     <<"pour le \"copier-coller\""<<endl;  
	    }else {
	      //const char * cName =  hits[0]._geode->getName().c_str();
	      const char * cName = 
		ScanSetGraph::getFirstNamePath(hits[0]._geode.get()).c_str();
	      fwrite(&cName[0],1,sizeof(char)*strlen(cName),filePtr);
	      fclose(filePtr);
	      cout<<"Selection : "<<cName<<endl;
	      reponse = true;
	    }
	  }	  
	  break;
	}	
	
      default:    
	{ 
	  reponse = false;
	  break;
	}
      }//end switch(ea.getEventType())
      
      break;
    }//end case osgGA::GUIEventAdapter::KEYDOWN
  case osgGA::GUIEventAdapter::KEYUP:
    {
      CTRACE(this,"handle")<<"KEYUP ea.getKey()="<<ea.getKey()<<endl;

      reponse = EvtKey::process(ea,_envOSG);

      break;
    }  
  case osgGA::GUIEventAdapter::PUSH: 
  case osgGA::GUIEventAdapter::MOVE: 
  case osgGA::GUIEventAdapter::DRAG:  
  case osgGA::GUIEventAdapter::RELEASE: 
    {
      if (ea.getModKeyMask() != 0){
	CTRACE2(this,"handle")<<"ea.getModKeyMask()="
			      <<ea.getModKeyMask()<<endl;
      }
      
      
      evt=EvtMouse::getStringOSG(int(ea.getEventType()));
      derX = ea.getX();
      derY = ea.getY();      

      if (evt!="Null"){
	
	if (evt == "Move"){
	  CTRACE2(this,"handle")<<"evt = "<<evt<<" derX="<<derX
				<<" derY="<<derY<<endl
				<<"ea.getButton()="<<ea.getButton()
				<<"ea.getButtonMask()="<<ea.getButtonMask()
				<<endl;
	}
	else {
	  CTRACE(this,"handle")<<"evt = "<<evt
			       <<" &ea="<<&ea
			       <<" (&ea)->getX()="<<(&ea)->getX()
			       <<" derX="<<derX
			       <<" derY="<<derY<<endl
			       <<"ea.getButton()="<<ea.getButton()
			       <<"ea.getButtonMask()="<<ea.getButtonMask()
			       <<endl;
	}
	
	reponse = EvtMouse::process(ea,_envOSG);	
      }
      break;
    }  
  case osgGA::GUIEventAdapter::NONE: reponse = true;
  case osgGA::GUIEventAdapter::DOUBLECLICK: 
  case osgGA::GUIEventAdapter::RESIZE: 
    //case osgGA::GUIEventAdapter::SCROLLUP: 
    //case osgGA::GUIEventAdapter::SCROLLDOWN: 
    //case osgGA::GUIEventAdapter::SCROLLLEFT :
    //case osgGA::GUIEventAdapter::SCROLLRIGHT: 
  case osgGA::GUIEventAdapter::SCROLL:
  case osgGA::GUIEventAdapter::PEN_PRESSURE:
  case osgGA::GUIEventAdapter::PEN_PROXIMITY_ENTER:
  case osgGA::GUIEventAdapter::PEN_PROXIMITY_LEAVE:

    break;

  case osgGA::GUIEventAdapter::FRAME: 
    //cout<<"FRAME"<<endl;
    EvtBoundingShapeCollision::sendFrameEvt(_envOSG->getBD()); 
    break;
    
  } 

  

 
  return reponse;
  
}//@CODE_129


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_94
Method which must be called first in a constructor.
*/
void EvtHandler::ConstructorInclude()
{
}


/*@NOTE_95
Method which must be called first in a destructor.
*/
void EvtHandler::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
  /*Function_3args<EvtMouse::Liste,string,osg::Vec3> * trait=
    new Function_3args<EvtMouse::Liste,string,
    osg::Vec3>("EvtMouse::traiter",EvtMouse::traiter);
  
  trait->setArg1(objEvt);
  trait->setArg2(Nomobj);
  trait->setArg3(Point);
  (new CommandThread(trait))->start();    */
