/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtKey.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtKey'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
//#include "Activite.h"
#include "Event.h"
#include "EvtKey.h"
#include <math.h>
//#include "Zone.h"
#include "XMLUtil.h"
#include "BD.h"
#include "Function_1arg.h"
//#include <vector>

namespace cooki3d{
//@END_USER2




/*@NOTE_2557
Constructor method.
*/
EvtKey::EvtKey(BD* pBD) //@INIT_2557
   
  : Evaluable(pBD) //heritage virtual
    , Event(pBD)  
    ,_processed(false)
    , _evtType()
    , _keySymbol()
    , _modKeyMask()
    , _listeZones()
    , _codeExec(NULL)
{//@CODE_2557
    ConstructorInclude();

    // Put in your own code
}//@CODE_2557


/*@NOTE_2514
Destructor method.
*/
EvtKey::~EvtKey()
{//@CODE_2514
    DestructorInclude();

    // Put in your own code
}//@CODE_2514


void EvtKey::executerActions()
{//@CODE_2559
  assertC(_codeExec);
  //_codeExec->setArg1(this);  
  EvtKey * p=this;
  _codeExec->pSetArg1(&p);  
  _codeExec->exec();
}//@CODE_2559


EvtKey::Liste EvtKey::findAllEvtKey(BD* pBD,
                                    const osgGA::GUIEventAdapter& eventAdapter)
{//@CODE_2560
  
  EvtKey * evt;
  Liste liste;
  BD::EvaluableIterator iEvaluable(/*BD::getThreadInstance()*/pBD);
  while (++iEvaluable)    {
    evt = dynamic_cast<EvtKey*>(iEvaluable.Get());
    if (evt 
	&& (eventAdapter.getEventType() == evt->getEvtType())
	&& (eventAdapter.getKey() > 0)
	&& ( ((unsigned int)eventAdapter.getKey()) == evt->getKeySymbol())
	)
      {
	liste.push_back(evt);
      }
  }
  
  return liste;
}//@CODE_2560


bool EvtKey::loadCode()
{//@CODE_4049

  
  CTRACE(this,"loadCode")<<getCode()<<endl;

    //BUG C++-JVM dynamic_cast foireux sur lancement interne
  //_codeExec =dynamic_cast< FctEvtMouse * > (BD::instance()->FindEvaluable("codeEvtSouris0"));
  _codeExec = static_cast< FctEvtKey * > 
    (getBD()->FindEvaluable(getCode()));

  if (!_codeExec) {
    CERR(this,"loadCode")<<"code EvtKey introuvable "<<getCode()<<endl;

      //<<" a ete detruit"<<endl;
    //this->~EvtKey(); //on ne peut pas car LoaderXML fait un getName !! 
    //assertC(_codeExec);
    return false;
  }

  return true;
   
}//@CODE_4049


bool EvtKey::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_2566


  //chargement des proprietes de l'evt
  bool result = subLoadCommonXML( node, loaderXML );
  
  if (result){
    //chargemen du code de l'évt 
    result = subLoadCodeXML( node, loaderXML );
  }
  
  return result;
}//@CODE_2566


bool EvtKey::process(const osgGA::GUIEventAdapter& ea, EnvironnementOSG* envOSG)
{//@CODE_2568
  
  EvtKey::Liste objEvt=EvtKey::findAllEvtKey(envOSG->getBD(), ea );
  //std::string nomobj;
  //osg::Vec3 point;
  bool traite = false;
  //osgUtil::Hit hit;

  //TODO Traiter plusieurs niveau de profondeur
  if (objEvt.size()>0) {    
    
      
    for (unsigned int i=0; i<objEvt.size() ; i++){
      
      //par défaut, l'évt est considéré comme traité
      objEvt[i]->setProcessed(true);
      objEvt[i]->executerActions();
      //on regarde si l'utilisateur n'a pas changé
      //la considération future de l'évt
      if (objEvt[i]->isProcessed()){
	traite = true;
      }    
    }
  }
   
  //NOTE:ce boolean a des conséquences sur la suite des
  //EvtHandlers qui ne recevront pas l'évt si il a 
  //été considéré traité par un objet EvtKey
  return traite;
  
}//@CODE_2568


Evaluable* EvtKey::staticCreate(BD* pBD)
{//@CODE_3033
    return new EvtKey(pBD);
}//@CODE_3033


bool EvtKey::subLoadCodeXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_4065
 
  XMLUtil xmlEvt(node);
  
  //recuperation du nom de la fonction
  setCode(xmlEvt.getFirstText("code"));
  
  return loadCode();
   
}//@CODE_4065


bool EvtKey::subLoadCommonXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_3992

  
  
  string debut,fin,mouv,nom;
  XMLUtil xmlEvt(node);
  
  setName(xmlEvt.getFirstText("nom"));

  std::string sEventType = xmlEvt.getFirstText("evtType");
  if      ( sEventType == "KeyDown" ){
    setEvtType(osgGA::GUIEventAdapter::KEYDOWN);
  }
  else if ( sEventType == "KeyUp" ){
    setEvtType(osgGA::GUIEventAdapter::KEYUP);
  }
  else {
    CERR(this, "loadXML")<<"EventType:"<<sEventType
			 <<" est inconnu!!"<<endl;
  }

  //récupération de la valeur de la touche qui est en attribut
  const xmlpp::Element* elem = xmlEvt.getFirstElement("keySymbol");

  xmlpp::Attribute * attrib = elem->get_attribute( "value" );
  if (attrib){
    CTRACE(this,"loadXML")<<"scan..."<<attrib->get_value().c_str()<<endl;
    sscanf(attrib->get_value().c_str(), "%x", &_keySymbol);
  }else {

    setKeySymbol( int ( xmlEvt.getFirstText("keySymbol")[0] ) );    
  } 

   
  //de meme pour modKeyMask
  const xmlpp::Element * elem2 = xmlEvt.getFirstElement("modKeyMask");
  
  attrib = elem2->get_attribute( "value" );
  if (attrib){
    sscanf(attrib->get_value().c_str(), "%x", &_modKeyMask);    
  }else {
    CTRACE(this,"loadXML")<<"pas de modKeyMask"<<endl;
  }

  CTRACE(this,"loadXML")<<"getKeySymbol()="<<getKeySymbol()<<endl;
  CTRACE(this,"loadXML")<<"char(getKeySymbol())="<<char(getKeySymbol())<<endl;


  //recuperation des noeuds actifs
  _listeZones.loadXML( node );

  
  //recuperation du nom de la fonction
  //=> non pris en charge par subLoadXML
   
  return true;
}//@CODE_3992


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_2515
Method which must be called first in a constructor.
*/
void EvtKey::ConstructorInclude()
{
}


/*@NOTE_2516
Method which must be called first in a destructor.
*/
void EvtKey::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
//poubelle
//Function_3args<EvtKey::Liste,string,osg::Vec3> * trait=
//	new Function_3args<EvtKey::Liste,string,
//	osg::Vec3>("EvtKey::traiter",EvtKey::traiter);
//trait->setArg1(objEvt);
//trait->setArg2(Nomobj);
//trait->setArg3(Point);
//
