/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtKey.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtKey'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVTKEY_H
#define _EVTKEY_H

//@START_USER1


#include "Event.h"
#include "NodeNameList.h"
#include "Methode_1arg.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_2513
classe ...
*/

class AFX_EXT_CLASS EvtKey
    : public Event
{

//@START_USER2
public: 
  typedef vector<EvtKey*> Liste;
  //typedef Function_1arg<EvtKey*> FctEvtKey;
  //typedef Methode_1arg<Evaluable, EvtKey*> FctEvtKey;
  typedef Command FctEvtKey;
  

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

protected:
    bool _processed;
    osgGA::GUIEventAdapter::EventType _evtType;
    unsigned int _keySymbol;
    unsigned int _modKeyMask;
    NodeNameList _listeZones;
    FctEvtKey* _codeExec;

//
// Non-Grouped Methods
//

public:
    EvtKey(BD* pBD);
    virtual ~EvtKey();
    virtual void executerActions();
    static EvtKey::Liste findAllEvtKey(BD* pBD,
                                       const osgGA::GUIEventAdapter& eventAdapter);
    bool loadCode();
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    static bool process(const osgGA::GUIEventAdapter& ea,
                        EnvironnementOSG* envOSG);
    static Evaluable* staticCreate(BD* pBD);
    virtual bool subLoadCodeXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    virtual bool subLoadCommonXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    osgGA::GUIEventAdapter::EventType getEvtType() const;
    void setEvtType(osgGA::GUIEventAdapter::EventType evtType);
    void setKeySymbol(unsigned int keySymbol);
    unsigned int getKeySymbol() const;
    NodeNameList& getListeZones();
    void setListeZones(const NodeNameList& rListeZones);
    void setModKeyMask(unsigned int modKeyMask);
    unsigned int getModKeyMask() const;
    bool isProcessed() const;
    void setProcessed(bool processed);
};

#endif


#ifdef CB_INLINES
#ifndef _EVTKEY_H_INLINES
#define _EVTKEY_H_INLINES

/*@NOTE_3354
Returns the value of member '_evtType'.
*/
inline osgGA::GUIEventAdapter::EventType EvtKey::getEvtType() const
{//@CODE_3354
    return _evtType;
}//@CODE_3354



/*@NOTE_3355
Set the value of member '_evtType' to 'evtType'.
*/
inline void EvtKey::setEvtType(osgGA::GUIEventAdapter::EventType evtType)
{//@CODE_3355
    _evtType = evtType;
}//@CODE_3355



/*@NOTE_3358
Set the value of member '_keySymbol' to 'keySymbol'.
*/
inline void EvtKey::setKeySymbol(unsigned int keySymbol)
{//@CODE_3358
    _keySymbol = keySymbol;
}//@CODE_3358



/*@NOTE_3370
Returns the value of member '_keySymbol'.
*/
inline unsigned int EvtKey::getKeySymbol() const
{//@CODE_3370
    return _keySymbol;
}//@CODE_3370



/*@NOTE_3505
Returns the value of member '_listeZones'.
*/
inline NodeNameList& EvtKey::getListeZones()
{//@CODE_3505
    return _listeZones;
}//@CODE_3505



/*@NOTE_3506
Set the value of member '_listeZones' to 'rListeZones'.
*/
inline void EvtKey::setListeZones(const NodeNameList& rListeZones)
{//@CODE_3506
    _listeZones = rListeZones;
}//@CODE_3506



/*@NOTE_3362
Set the value of member '_modKeyMask' to 'modKeyMask'.
*/
inline void EvtKey::setModKeyMask(unsigned int modKeyMask)
{//@CODE_3362
    _modKeyMask = modKeyMask;
}//@CODE_3362



/*@NOTE_3371
Returns the value of member '_modKeyMask'.
*/
inline unsigned int EvtKey::getModKeyMask() const
{//@CODE_3371
    return _modKeyMask;
}//@CODE_3371



/*@NOTE_2554
Returns the value of member '_processed'.
*/
inline bool EvtKey::isProcessed() const
{//@CODE_2554
    return _processed;
}//@CODE_2554



/*@NOTE_2555
Set the value of member '_processed' to 'processed'.
*/
inline void EvtKey::setProcessed(bool processed)
{//@CODE_2555
    _processed = processed;
}//@CODE_2555



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
