/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtKeyGroup.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtKeyGroup'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2


#include "EvtKeyGroup.h"
#include "XMLUtil.h"

namespace cooki3d{
//@END_USER2




/*@NOTE_4022
Constructor method.
*/
EvtKeyGroup::EvtKeyGroup(BD* pBD) //@INIT_4022
    : Evaluable(pBD)
{//@CODE_4022
    ConstructorInclude();

    // Put in your own code
}//@CODE_4022


/*@NOTE_3996
Destructor method.
*/
EvtKeyGroup::~EvtKeyGroup()
{//@CODE_3996
    DestructorInclude();

    // Put in your own code
}//@CODE_3996


bool EvtKeyGroup::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_4027
  

  XMLUtil xml(node);
  
  setName(xml.getFirstText("nom"));
  
  
  vector<const xmlpp::Element*> evtNodes= xml.getAllElement("evtKeyChild");

  if ( evtNodes.size()==0 ){
    //on a un evtGroup qui possède aucun noeud evt
    CWARNs("EvtKeyGroup::loadXML")
      <<" Le groupe EvtKeyGroup "<<getName()
      <<" ne possède auncun fils EvtKeyChild !!!!!"
      <<endl;
  }
  
  EvtKey * evtKey;
  for (unsigned int i=0; i< evtNodes.size();i++) {
    
    evtKey = new EvtKey(getBD());
    evtKey->subLoadCommonXML( evtNodes[i], loaderXML );
    evtKey->subLoadCodeXML( node , loaderXML );
    
    //NOTE : on pourrait garder une liste des evts chargés...
    //_listEvtKey.psuh_back ( evtKey );   
  }
  return true;

}//@CODE_4027


Evaluable* EvtKeyGroup::staticCreate(BD* pBD)
{//@CODE_4030
    return new EvtKeyGroup(pBD);
}//@CODE_4030


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_3997
Method which must be called first in a constructor.
*/
void EvtKeyGroup::ConstructorInclude()
{
}


/*@NOTE_3998
Method which must be called first in a destructor.
*/
void EvtKeyGroup::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d

//poubelle

