/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtMouse.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtMouse'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
//#include "Activite.h"
#include "Event.h"
#include "EvtMouse.h"
#include <math.h>
//#include "Zone.h"
#include "XMLUtil.h"
#include "BD.h"
#include "Function_1arg.h"
#include "ScanSetGraph.h"

// #if __GXX_MERGED_TYPEINFO_NAMES == 0
// //#error "XXXX"
// #endif


// #include <typeinfo>
// //#include <vector>

// #if __GXX_MERGED_TYPEINFO_NAMES == 0
// //#error "XXXX"
// #endif

// #if __GXX_MERGED_TYPEINFO_NAMES == 1
// #error "OOOO"
// #endif

template<class Tdest,class Tsrc>
inline Tdest * cooki_cast(Tsrc * ptr )
{  
  Tdest * d = dynamic_cast<Tdest*>( ptr );
  if (d){
    return d;
  } else {  
    const type_info & dest = typeid( Tdest );
    const type_info & src = typeid( *ptr );  
    
    if ( strcmp( src.name(),  dest.name()) == 0 ){
      cout<<"DYNAMIC CAST RECTIFIE !!"<<endl;
      d = static_cast<Tdest*>( ptr );
      assert( d );
      return d;
    } else {
      cerr<<"Warning !!!: DYNAMIC CAST NON RECTIFIE POUR CE CAS !!!"<<endl;
      
      cerr<<"src.name()="<<src.name()<<endl;
      cerr<<"dst.name()="<<dest.name()<<endl;
      
    }
  }
  
  return NULL;
}

//#define dynamic_cast cooki_cast


namespace cooki3d{
//@END_USER2



//
// Group: load
//
// Static members
MapRegister<EvtMouse*> EvtMouse::_register;
// End of Group: load





//
// Group: load
//
bool EvtMouse::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_333

    
  string debut,fin,mouv,nom;
  XMLUtil xmlEvt(node);
  
  setName(xmlEvt.getFirstText("nom"));

  setType(xmlEvt.getFirstText("type"));
  
  //recuperation des noeuds actifs
  _listeZones.loadXML( node );
  
  //recuperation du nom de la fonction
  setCode(xmlEvt.getFirstText("code"));

  return load();
}//@CODE_333


/*@NOTE_332
Constructor method.
*/
EvtMouse::EvtMouse(BD* pBD) //@INIT_332
   
  :  Evaluable(pBD), Event(pBD) //virtual heritage
     ,_alt(false)
     , _meta(false) 
     , _ctrl(false)
     , _shift(false)
     , _button(-1)
     , _codeExec(NULL)
     , _cursX(0)
     , _cursY(0)
     , _hit()
     , _listeZones()
     , _processed(false)
     , _type("")
     , _X(-1)
     , _Y(-1)
     , _Z(-1)
     , _activeZone("")
{//@CODE_332
    ConstructorInclude();

    // Put in your own code
}//@CODE_332


/*@NOTE_328
Destructor method.
*/
EvtMouse::~EvtMouse()
{//@CODE_328
    DestructorInclude();

    // Put in your own code
      _register.getRegister( getBD() ).remove( getName() );
}//@CODE_328


bool EvtMouse::load()
{//@CODE_3365
   
  if (_listeZones.size()==0){
    //pb : on a un evenement qui possede aucun noeud
    CWARN(this,"load")<<" L'evenement souris "<<getName()
		      <<" n'agit sur aucun noeud!!!!!"<<endl;
    //<<" l'instance va donc etre detruite"<<endl;
    //this->~EvtMouse();
    //return false;
  }
  
  //code+getNom()
  //string codeName = getName();
  //codeName[0] = (char((int('A')-int('a'))+int(codeName[0])));
  //codeName = "code"+ codeName;
  
  CTRACE(this,"load")<</*codeName*/getCode()<<endl;
  
  //BUG C++-JVM dynamic_cast foireux sur lancement interne
  //_codeExec =dynamic_cast< FctEvtMouse * > (BD::instance()->FindEvaluable("codeEvtSouris0"));

  //CERR(BD::instance()->FindEvaluable(getCode()),"test !!")<<"test"<<endl;
  
  //CERRs("........")<<typeid( * BD::instance()->FindEvaluable(getCode()) ).name()<<endl;
  //OK dans ce cas là, égalité des noms de types
  //_codeExec = cooki_cast< FctEvtMouse, Evaluable >( getBD()->FindEvaluable(getCode()) ); 
  _codeExec = cooki_cast< Command, Evaluable >( getBD()->FindEvaluable(getCode()) ); 

     /*, typeid(FctEvtMouse)*/ 

  /*static_cast,*//*dynamic_cast*/ /*FctEvtMouse **/

  //Code origine : FOIRE JAVA
  //_codeExec = dynamic_cast< FctEvtMouse * >(  BD::instance()
  // ->FindEvaluable(getCode()) );

  //FOIRE JAVA
  //_codeExec = dynamic_cast< Function_1arg<EvtMouse*> * >(  BD::instance()
  //  ->FindEvaluable(getCode()) );

  

  // _codeExec = ( FctEvtMouse *)
//     abi::__dynamic_cast( BD::instance()->FindEvaluable(getCode()),
// 		      new abi::__class_type_info(typeid(Evaluable *).name()),
// 		      new abi::__class_type_info(typeid(FctEvtMouse *).name()),
// 			 0);


  if (!_codeExec) {
    CERR(this,"load")<<"code EvtMouse introuvable "<<getCode()<<" a ete detruit"<<endl;
    this->~EvtMouse();    
    //assertC(_codeExec);
    return false;
  }
  
  _register.getRegister( getBD() ).add( getName(), this );
  
  return true;
  
}//@CODE_3365


/*@NOTE_3036
(static)
*/
Evaluable* EvtMouse::staticCreate(BD* pBD)
{//@CODE_3036
    return new EvtMouse(pBD);
}//@CODE_3036


bool EvtMouse::checkPotentialActiveNode(const std::string& pickName,
                                        LoaderGeneric* loader)
{//@CODE_4319

  bool res = false;
  
  //parcours de tous les EvtMouse
  Register<EvtMouse*> & reg = _register.getRegister( loader->getBD() );
  Register<EvtMouse*>::iterator it  = reg.begin();
  
  EvtMouse * em=NULL;
  
  while (it != reg.end() ){
    
    em = it->second;
    
    em->_listeZones.checkAddPotentialZone( pickName );
    
    it++;
  }

  return res;
}//@CODE_4319


/*@NOTE_4327
Check the integritry of the object
*/
bool EvtMouse::check()
{//@CODE_4327
  //check if OK 

  if (! _listeZones.check() ){
    CWARN(this,"check")
      <<getName()
      <<" : NodeNameList is not OK to detect user parametrized events  !"
      <<endl; 
  }

  return true;

}//@CODE_4327


// End of Group: load

/*@NOTE_625
Execute le code relié à l'évenement
*/
void EvtMouse::executerActions()
{//@CODE_625
  assertC(_codeExec);
  // cout<<"av _codeExec->setArg1(this);"<<endl;
  //_codeExec->setArg1(this);  
  EvtMouse * p = this;
  _codeExec->pSetArg1(&p);  
  //cout<<"av _codeExec->exec();"<<endl;
  _codeExec->exec();
}//@CODE_625


EvtMouse::Liste EvtMouse::findAllEvtMouse(BD* pBD, std::string type)
{//@CODE_393
  
  EvtMouse * evt;
  Liste liste;
 
  //parcours de tous les EvtMouse
  Register<EvtMouse*> &reg = _register.getRegister( pBD );
  Register<EvtMouse*>::iterator it  = reg.begin();
  
  while (it != reg.end() ){
    
    evt = it->second;
    
    if (evt && (type == evt->getType())) {
      liste.push_back(evt);
    }
    
    it++;
  }
  return liste;
  
}//@CODE_393


std::string EvtMouse::getStringOSG(int i)
{//@CODE_614
  
  switch (i) {
    
  case osgGA::GUIEventAdapter::PUSH: return "Push";    
  case osgGA::GUIEventAdapter::MOVE: return "Move";
    
  case osgGA::GUIEventAdapter::DRAG: return "Drag";
  case osgGA::GUIEventAdapter::RELEASE: return "Release";
  default : 
    CERRs("EvtMouse::getStringOSG")<<" Undefined osgGA::GUIEventAdapter !"
				   <<endl;
  }
  return "Undefined";
}//@CODE_614


bool EvtMouse::process(const osgGA::GUIEventAdapter& ea,
                       EnvironnementOSG* envOSG)
{//@CODE_621
  
  std::string evt=EvtMouse::getStringOSG(int(ea.getEventType()));
  EvtMouse::Liste objEvt=EvtMouse::findAllEvtMouse(envOSG->getBD(),evt);
  std::string nomobj;
  osg::Vec3 point;
  bool traite = false;
  osgUtil::Hit hit;
  
  //TODO Traiter plusieurs niveau de profondeur
  if (objEvt.size()>0) {    
    
    osgUtil::IntersectVisitor::HitList hits;
    float x,y;
    x=ea.getX();
    y=ea.getY(); 
    CTRACEs("EvtMouse::process")<<"x="<<x<<" y="<<y<<endl;
    
    envOSG->computeIntersections( x, y, hits);    
    
    if (hits.size()>0) {
      /*nomobj= hits[0]._geode->getName();
      if (nomobj.length() == 0) {
	       assertC(hits[0]._geode->getParent(0));
       	 nomobj=hits[0]._geode->getParent(0)->getName();       	 
	 }*/
      nomobj = ScanSetGraph::getFirstNamePath( hits[0]._geode.get() ); 
      
      CTRACEs("EvtMouse::process")<<" nomobj="<<nomobj<<endl;
      point=hits[0].getWorldIntersectPoint();
      hit = hits[0];
    }else {
      nomobj="@"; //=>signifie aucun objet touche
        point = osg::Vec3(x,y,0);                  
    }  
    
    for (unsigned int i=0; i<objEvt.size() ; i++){
      if (objEvt[i]->_listeZones.findZone(nomobj)){ 
	objEvt[i]->setX(point.x());
	objEvt[i]->setY(point.y());
	objEvt[i]->setZ(point.z());
	objEvt[i]->setActiveZone(nomobj);
	objEvt[i]->setHit(hit);
	//NOTE : Curseur n'aura jamais de decimals 
	//car cest la getPosition curseur en pixels.  
	objEvt[i]->setCursX((int)x); 
	objEvt[i]->setCursY((int)y); 
	objEvt[i]->setAlt(ea.getModKeyMask() 
			  & osgGA::GUIEventAdapter::MODKEY_ALT);
	objEvt[i]->setCtrl(ea.getModKeyMask()
			   & osgGA::GUIEventAdapter::MODKEY_CTRL);
	objEvt[i]->setMeta(ea.getModKeyMask()
			   & osgGA::GUIEventAdapter::MODKEY_META);
	objEvt[i]->setShift(ea.getModKeyMask()
			   & osgGA::GUIEventAdapter::MODKEY_SHIFT);
        objEvt[i]->setEnvOSG(envOSG);
	objEvt[i]->setButton(ea.getButton());
	
	CTRACEs("EvtMouse::process")<<"zone active OK "
				     <<nomobj<<endl;
	
	
	//par defaut, l'evt est considere comme traite
	objEvt[i]->setProcessed(true);
	objEvt[i]->executerActions();
	//on regarde si l'utilisateur n'a pas change
	//la consideration de l'evt
	if (objEvt[i]->isProcessed()){
	  traite = true;
	}
      }
    }
  }
  //NOTE:ce boolean a des consequences sur la suite de
  //EvtHandler qui ne recevront pas l'evt si il a 
  //ete considere traite par un objet EvtMouse
  return traite;
  
}//@CODE_621


bool EvtMouse::processRectangleSelection(EnvironnementOSG* envOSG,
                                         std::vector<SimpleHit> simpleHits)
{//@CODE_3019
  
  std::string evt="Select";
  EvtMouse::Liste objEvt=EvtMouse::findAllEvtMouse(envOSG->getBD(), evt);
  std::string nomobj;
  osg::Vec3 point;
  bool traite = false;
    
  if (objEvt.size()>0) {    
        
    point = osg::Vec3(0,0,0);                    
    if (simpleHits.size()>0) {

      //TODO Traiter plusieurs niveau de profondeur
      nomobj= simpleHits[0]._geode->getName();
      if (nomobj.length() == 0) {
	assertC2(simpleHits[0]._geode->getParent(0), envOSG->getBD());
	nomobj=simpleHits[0]._geode->getParent(0)->getName();       	 
      }
      
      CTRACEs("EvtMouse::process")<<" nomobj="<<nomobj<<endl;
    }else {
      nomobj="@"; //=>signifie aucun objet touche
        
    }  
    
    for (unsigned int i=0; i<objEvt.size() ; i++){
      if (objEvt[i]->_listeZones.findZone(nomobj)){ 
	objEvt[i]->setX(point.x());
	objEvt[i]->setY(point.y());
	objEvt[i]->setZ(point.z());
	objEvt[i]->setActiveZone(nomobj);
        

        objEvt[i]->setEnvOSG(envOSG);
	
	//par defaut, l'evt est considere comme traite
	objEvt[i]->setProcessed(true);
	objEvt[i]->executerActions();
	//on regarde si l'utilisateur n'a pas change
	//la consideration de l'evt
	if (objEvt[i]->isProcessed()){
	  traite = true;
	}
      }
    }
  }
  //NOTE:ce boolean a des consequences sur la suite de
  //EvtHandler qui ne recevront pas l'evt si il a 
  //ete considere traite par un objet EvtMouse
  return traite;
  
}//@CODE_3019


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_329
Method which must be called first in a constructor.
*/
void EvtMouse::ConstructorInclude()
{
}


/*@NOTE_330
Method which must be called first in a destructor.
*/
void EvtMouse::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
//poubelle
  //Function_3args<EvtMouse::Liste,string,osg::Vec3> * trait=
      //			new Function_3args<EvtMouse::Liste,string,
      //			osg::Vec3>("EvtMouse::traiter",EvtMouse::traiter);
      
      //trait->setArg1(objEvt);
      //trait->setArg2(Nomobj);
      //trait->setArg3(Point);
      //(new CommandThread(trait))->start();    
    

//   BD::EvaluableIterator iEvaluable(pBD);
//   while (++iEvaluable)    {
//     //cout<<"iEvaluable.Get()->getName()="<<iEvaluable.Get()->getName()<<endl;
//     //cout<<"typeid( *iEvaluable.Get() )="
//     //<<typeid( *iEvaluable.Get() ).name()<<endl;

//     //intermediaire Bug QT ???
//     //if (iEvaluable.Get()->getName().substr(0,4) != "code"){
//     evt = dynamic_cast<EvtMouse*>(iEvaluable.Get());
//     //static_cast<EvtMouse*>(iEvaluable.Get());      
    
//     if (evt && (type == evt->getType())) {
//       liste.push_back(evt);
//     }
//     //}
//   } 
