/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtMouse.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtMouse'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVTMOUSE_H
#define _EVTMOUSE_H

//@START_USER1

#include "Event.h"
#include "NodeNameList.h"
#include "MapRegister.h"
#include "LoaderGeneric.h"
#include "Methode_1arg.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_327
classe ...
*/

class AFX_EXT_CLASS EvtMouse
    : public Event
{

//@START_USER2
public: 
  typedef vector<EvtMouse*> Liste;
  //typedef Function_1arg<EvtMouse*> FctEvtMouse;
  //typedef Methode_1arg<Evaluable, EvtMouse*> FctEvtMouse;
  typedef Command FctEvtMouse;
  
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: ModKey
//

private:
    bool _alt;
    bool _meta;
    bool _ctrl;
    bool _shift;

public:
    bool isAlt() const;
    void setAlt(bool alt);
    bool isMeta() const;
    void setMeta(bool meta);
    bool isCtrl() const;
    void setCtrl(bool ctrl);
    bool isShift() const;
    void setShift(bool shift);

//
// Group: data
//

private:
    int _button;
    FctEvtMouse* _codeExec;
    int _cursX;
    int _cursY;
    osgUtil::Hit _hit;
    NodeNameList _listeZones;
    bool _processed;
    std::string _type;
    float _X;
    float _Y;
    float _Z;
    std::string _activeZone;

public:
    int getButton() const;
    void setButton(int button);
    int getCursX() const;
    void setCursX(int cursX);
    int getCursY() const;
    void setCursY(int cursY);
    osgUtil::Hit getHit() const;
    void setHit(osgUtil::Hit hit);
    NodeNameList& getListeZones();
    void setListeZones(const NodeNameList& rListeZones);
    bool isProcessed() const;
    void setProcessed(bool processed);
    std::string getType() const;
    void setType(std::string type);
    float getX() const;
    void setX(float x);
    float getY() const;
    void setY(float y);
    float getZ() const;
    void setZ(float z);
    std::string getActiveZone() const;
    void setActiveZone(std::string activeZone);

//
// Group: load
//

private:
    static MapRegister<EvtMouse*> _register;

public:
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    EvtMouse(BD* pBD);
    virtual ~EvtMouse();
    bool load();
    static Evaluable* staticCreate(BD* pBD);
    static bool checkPotentialActiveNode(const std::string& pickName,
                                         LoaderGeneric* loader);
    virtual bool check();

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//

public:
    virtual void executerActions();
    static EvtMouse::Liste findAllEvtMouse(BD* pBD, std::string type);
    static std::string getStringOSG(int i);
    static bool process(const osgGA::GUIEventAdapter& ea,
                        EnvironnementOSG* envOSG);
    static bool processRectangleSelection(EnvironnementOSG* envOSG,
                                          std::vector<SimpleHit> simpleHits);
};

#endif


#ifdef CB_INLINES
#ifndef _EVTMOUSE_H_INLINES
#define _EVTMOUSE_H_INLINES


//
// Group: ModKey
//
/*@NOTE_2665
Returns the value of member '_alt'.
*/
inline bool EvtMouse::isAlt() const
{//@CODE_2665
    return _alt;
}//@CODE_2665



/*@NOTE_2666
Set the value of member '_alt' to 'alt'.
*/
inline void EvtMouse::setAlt(bool alt)
{//@CODE_2666
    _alt = alt;
}//@CODE_2666



/*@NOTE_2671
Returns the value of member '_meta'.
*/
inline bool EvtMouse::isMeta() const
{//@CODE_2671
    return _meta;
}//@CODE_2671



/*@NOTE_2672
Set the value of member '_meta' to 'meta'.
*/
inline void EvtMouse::setMeta(bool meta)
{//@CODE_2672
    _meta = meta;
}//@CODE_2672



/*@NOTE_2668
Returns the value of member '_ctrl'.
*/
inline bool EvtMouse::isCtrl() const
{//@CODE_2668
    return _ctrl;
}//@CODE_2668



/*@NOTE_2669
Set the value of member '_ctrl' to 'ctrl'.
*/
inline void EvtMouse::setCtrl(bool ctrl)
{//@CODE_2669
    _ctrl = ctrl;
}//@CODE_2669



/*@NOTE_2674
Returns the value of member '_shift'.
*/
inline bool EvtMouse::isShift() const
{//@CODE_2674
    return _shift;
}//@CODE_2674



/*@NOTE_2675
Set the value of member '_shift' to 'shift'.
*/
inline void EvtMouse::setShift(bool shift)
{//@CODE_2675
    _shift = shift;
}//@CODE_2675



// End of Group: ModKey


//
// Group: data
//
/*@NOTE_2983
Returns the value of member '_button'.
*/
inline int EvtMouse::getButton() const
{//@CODE_2983
    return _button;
}//@CODE_2983



/*@NOTE_2984
Set the value of member '_button' to 'button'.
*/
inline void EvtMouse::setButton(int button)
{//@CODE_2984
    _button = button;
}//@CODE_2984



/*@NOTE_2502
Returns the value of member '_cursX'.
*/
inline int EvtMouse::getCursX() const
{//@CODE_2502
    return _cursX;
}//@CODE_2502



/*@NOTE_2496
Set the value of member '_cursX' to 'cursX'.
*/
inline void EvtMouse::setCursX(int cursX)
{//@CODE_2496
    _cursX = cursX;
}//@CODE_2496



/*@NOTE_2503
Returns the value of member '_cursY'.
*/
inline int EvtMouse::getCursY() const
{//@CODE_2503
    return _cursY;
}//@CODE_2503



/*@NOTE_2500
Set the value of member '_cursY' to 'cursY'.
*/
inline void EvtMouse::setCursY(int cursY)
{//@CODE_2500
    _cursY = cursY;
}//@CODE_2500



/*@NOTE_1926
Returns the value of member '_hit'.
*/
inline osgUtil::Hit EvtMouse::getHit() const
{//@CODE_1926
    return _hit;
}//@CODE_1926



/*@NOTE_1927
Set the value of member '_hit' to 'hit'.
*/
inline void EvtMouse::setHit(osgUtil::Hit hit)
{//@CODE_1927
    _hit = hit;
}//@CODE_1927



/*@NOTE_3501
Returns the value of member '_listeZones'.
*/
inline NodeNameList& EvtMouse::getListeZones()
{//@CODE_3501
    return _listeZones;
}//@CODE_3501



/*@NOTE_3502
Set the value of member '_listeZones' to 'rListeZones'.
*/
inline void EvtMouse::setListeZones(const NodeNameList& rListeZones)
{//@CODE_3502
    _listeZones = rListeZones;
}//@CODE_3502



/*@NOTE_2505
Returns the value of member '_processed'.
*/
inline bool EvtMouse::isProcessed() const
{//@CODE_2505
    return _processed;
}//@CODE_2505



/*@NOTE_2506
Set the value of member '_processed' to 'processed'.
*/
inline void EvtMouse::setProcessed(bool processed)
{//@CODE_2506
    _processed = processed;
}//@CODE_2506



/*@NOTE_981
Returns the value of member '_type'.
*/
inline std::string EvtMouse::getType() const
{//@CODE_981
    return _type;
}//@CODE_981



/*@NOTE_982
Set the value of member '_type' to 'type'.
*/
inline void EvtMouse::setType(std::string type)
{//@CODE_982
    _type = type;
}//@CODE_982



/*@NOTE_978
Returns the value of member '_X'.
*/
inline float EvtMouse::getX() const
{//@CODE_978
    return _X;
}//@CODE_978



/*@NOTE_979
Set the value of member '_X' to 'x'.
*/
inline void EvtMouse::setX(float x)
{//@CODE_979
    _X = x;
}//@CODE_979



/*@NOTE_975
Returns the value of member '_Y'.
*/
inline float EvtMouse::getY() const
{//@CODE_975
    return _Y;
}//@CODE_975



/*@NOTE_976
Set the value of member '_Y' to 'y'.
*/
inline void EvtMouse::setY(float y)
{//@CODE_976
    _Y = y;
}//@CODE_976



/*@NOTE_972
Returns the value of member '_Z'.
*/
inline float EvtMouse::getZ() const
{//@CODE_972
    return _Z;
}//@CODE_972



/*@NOTE_973
Set the value of member '_Z' to 'z'.
*/
inline void EvtMouse::setZ(float z)
{//@CODE_973
    _Z = z;
}//@CODE_973



/*@NOTE_969
Returns the value of member '_activeZone'.
*/
inline std::string EvtMouse::getActiveZone() const
{//@CODE_969
    return _activeZone;
}//@CODE_969



/*@NOTE_970
Set the value of member '_activeZone' to 'activeZone'.
*/
inline void EvtMouse::setActiveZone(std::string activeZone)
{//@CODE_970
    _activeZone = activeZone;
}//@CODE_970



// End of Group: data

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
