/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          File.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'File'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2

#include <stdlib.h>
#include <osgDB/Registry>
#include <osgDB/ReadFile>
#include <osgDB/WriteFile>
#include <osg/MatrixTransform>
#include <osg/PositionAttitudeTransform>

#include "File.h"
#include "XMLUtil.h"
#include "BD.h"
#include "LoaderXML.h"
#include "ScanSetGraph.h"
#include "Methode_3args.h"
#include "MapRW.h"
       

namespace cooki3d{
//@END_USER2




/*@NOTE_1394
Constructor method.
*/
File::File(BD* pBD) //@INIT_1394
  :  Evaluable(pBD)
  ,_pathSet()
     ,_pathCount()
     , _fichier("")
     , _listGeode()
     , _listGroup()
     , _pathUnicity(true)
{//@CODE_1394
    ConstructorInclude();

    // Put in your own code
}//@CODE_1394


/*@NOTE_1390
Destructor method.
*/
File::~File()
{//@CODE_1390
    DestructorInclude();

    // Put in your own code
}//@CODE_1390


bool File::load(double x, double y, double altitude, double scale,
                osg::Group* rootNode)
{//@CODE_3562

  //chargement du fichier
  _levelNode = osgDB::readNodeFile(/*LoaderXML::getPath(*/_fichier/*)*/);
  CTRACE(this,"loadXML(const xmlpp::Node* node)")
    <<" load level fichier : '"
    <</*LoaderXML::getPath(*/_fichier/*)*/<<"'"<<endl;
  assertCMessage/*Code*/(_levelNode.get(),
		     getName()<<" : Echec sur chargement de \""
		     <</*LoaderXML::getPath(*/_fichier/*)*/<<"\""
			 /*,  return false*/);
 
  if (_pathUnicity){
    
    //parcours de l'arbre et adptation des noms de noeuds
    ScanSetGraph mesh;
    Methode_3args<File,osg::Node*,osg::Node*,std::string> 
      com(getBD(),"File::load",&File::scanRenameCommand,this);   
    com.setName("parcoursGrapheFichier"+getName());
    mesh.scanEtCommand3args(_levelNode.get(),NULL,
			    _levelNode.get()->getName(),&com);
    //on nettoye les données maintenant inutiles
    _pathSet.clear();
    _pathCount.clear();
  }
  
  
  //getPosition et scale (post)
  _pat = new osg::PositionAttitudeTransform();
  _pat->setName(getName());
  _pat->setPosition(osg::Vec3(x,y,altitude));
  _pat->setScale(osg::Vec3(scale,scale,scale));
  osg::StateSet *state= new osg::StateSet();
  state->setMode(GL_RESCALE_NORMAL, osg::StateAttribute::ON );
  _pat->setStateSet(state);
  
  //TODO Mettre au point ca, ne pas oublier le stateSet...
  // const osg::Matrix identity;
//   if ( _levelNode.get()->asTransform()
//        && _levelNode.get()->asTransform()->asMatrixTransform()
//        && ( _levelNode.get()->asTransform()->asMatrixTransform()
// 	    ->getMatrix() ==  identity ) ) {

//     //on supprime le "Scene Root" qui sert à rien..  
//     int num=_levelNode.get()->asGroup()->getNumChildren();
//     for (int i=0; i<num;i++) {
//       _pat->addChild( _levelNode.get()->asGroup()->getChild(i) );
//       _levelNode.get()->asGroup()->removeChild( i );
//     }

//     CERR(this, "loadXML")<<"Suppress scene root"<<endl;
    
//   } 
//   else
    
    {
      _pat->addChild(_levelNode.get());
    }
  

  if (rootNode != NULL){

    rootNode->addChild( _pat );
  
  }

  CTRACE(this,"loadXML")<<"end"<<endl;
  
  //EnvironnementOSG::instance()->getRootNode()->addChild(levelNode.get());
  
  //CTRACE(this,"LoadXML")<<"après 2"<<getenv("OSG_FILE_PATH")<<endl;
  //Attention block la sortie standard si la variable n'existe pas

  return true;     

}//@CODE_3562


bool File::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_1395

  CTRACE(this,"loadXML")<<"LoadFichier &&&&&&&&&&&&&&&&&&&&&&&&&"<<endl;
  
  XMLUtil xml(node);
  
  setName(xml.getFirstText("nom"));

  setFichier(loaderXML->getPath( xml.getFirstText("item") ));


  //getPosition et scale (pré)
  double x= atof(xml.getFirstText("x").c_str());
  double y= atof(xml.getFirstText("y").c_str());
  double altitude = atof(xml.getFirstText("altitude").c_str());
  double scale = atof(xml.getFirstText("scale").c_str());

  _pathUnicity = xml.getFirstText("pathUnicity") == "true";
  
  //gestion du path pour trouver les fonts, images...
  loaderXML->loadFilePathXML( node );
  
  /*vector<const xmlpp::Element*> filePaths= xml.getAllElement("filePath");

  //méthode 4 optimum + garder ce qu'il y a déjà dans le path
  osgDB::FilePathList & fpl =
  osgDB::Registry::instance()->getDataFilePathList();
  for (unsigned int i=0; i<filePaths.size();i++) {
  xml.set(filePaths[i]);
    fpl.push_back(loaderXML->getPath( xml.getFirstText("nom") ));      
    }
  osgDB::Registry::instance()->setDataFilePathList(fpl);*/
  
  return load( x,  y,  altitude,  scale, loaderXML->getRootNode().get());  

}//@CODE_1395


bool File::save(std::string fileName)
{//@CODE_4640
  return osgDB::writeNodeFile( *getFileRootNode(), fileName );
}//@CODE_4640


void File::scanRenameCommand(osg::Node* n, osg::Node* parent, std::string path)
{//@CODE_2144
  
  MapRW utilStr;    
  osg::Geode * g = dynamic_cast<osg::Geode*>( n );
  
  //cout<<path<<endl;
  
  int count = 0;
  bool isDoublon = _pathSet.find( path ) != _pathSet.end();
  
  if ( isDoublon ){
    
    mapStrInt::iterator itCount = _pathCount.find( path );
    if ( itCount == _pathCount.end() ){
      _pathCount[ path ] = 1;
      count = 1;
    }else {
      count = itCount->second + 1;
      _pathCount[ path ] = count;
    }    
  }

  //si c'est une geode on met à jour la liste des geodes
  //et on rajoute systematiquement le numero relatif dans le nom de la geode
  if ( g ) {
    std::string s = n->getName()+"#";
    assertC( parent->asGroup() );
    /*_listGeode.size()*/
    utilStr.writeToStr ( parent->asGroup()->getChildIndex( n ) , s);
    n->setName( s.c_str() );
    _listGeode.push_back( g );
    //std::cerr<<"push_back "<<g<<std::endl;
  }
  
  //sinon on met à jour la liste des groupes
  //et le numero dans le nom du group 
  //si c'est un doublon ou bien une chaine vide  
  else {
    
    osg::Group * grp =  dynamic_cast<osg::Group*>( n ) ;
    assertC( grp );
    
    if ( isDoublon || (n->getName().length() == 0) ){
      
      std::string s = n->getName()+"#";
      utilStr.writeToStr ( /*_listGroup.size()*/ count, s);
      n->setName( s.c_str() );
      
    }
    _listGroup.push_back( grp );
    
  }
  
  //maj de l'ens des paths pour la détection des doublons
  _pathSet.insert( path );
  
}//@CODE_2144


Evaluable* File::staticCreate(BD* pBD)
{//@CODE_3046
    return new File(pBD);
}//@CODE_3046


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1391
Method which must be called first in a constructor.
*/
void File::ConstructorInclude()
{
}


/*@NOTE_1392
Method which must be called first in a destructor.
*/
void File::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
//attention, parfois le crochet saute avec CB...
} //end of cooki3d namespace
