/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Function_0argWithResult.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Function_0argWithResult<Result>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _FUNCTION_0ARGWITHRESULT_H
#define _FUNCTION_0ARGWITHRESULT_H

//@START_USER1
//#include "XMLUtil.h"
//#include "yaccLex/Pile.h"
//#include "Evaluable.h"
//#include "Event.h"
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_3096
class ...
*/
template<class Result>
class Function_0argWithResult
    : public Command
{

//@START_USER2
public:

    //typedef map<string,Evaluable *,less<string > > mapStrThis;

  typedef Result Fonction();
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    FonctionPTR _fonction;
    Result _result;

//
// Non-Grouped Methods
//

public:
    Function_0argWithResult(BD* pBD, std::string nom, FonctionPTR fonction);
    virtual ~Function_0argWithResult();
    virtual void exec();
    Result getResult() const;
};

#endif


#ifdef CB_INLINES
#ifndef _FUNCTION_0ARGWITHRESULT_H_INLINES
#define _FUNCTION_0ARGWITHRESULT_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_3098
Method which must be called first in a constructor.
*/
template<class Result>
void Function_0argWithResult<Result>::ConstructorInclude()
{
}



/*@NOTE_3099
Method which must be called first in a destructor.
*/
template<class Result>
void Function_0argWithResult<Result>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_3107
Constructor method.
*/
template<class Result>
inline Function_0argWithResult<Result>::Function_0argWithResult(BD* pBD,
                                                                std::string nom,
                                                                FonctionPTR fonction) //@INIT_3107
   : Command(pBD)
    , _fonction(fonction)
    , _result()
{//@CODE_3107
    ConstructorInclude();

    // Put in your own code
    setName(nom);
}//@CODE_3107



/*@NOTE_3097
  Destructor method.
*/
template<class Result>
inline Function_0argWithResult<Result>::~Function_0argWithResult()
{//@CODE_3097
  DestructorInclude();
  
  // Put in your own code
}//@CODE_3097



template<class Result>
void Function_0argWithResult<Result>::exec()
{//@CODE_3110
    _result = _fonction();
}//@CODE_3110



/*@NOTE_3111
Returns the value of member '_result'.
*/
template<class Result>
inline Result Function_0argWithResult<Result>::getResult() const
{//@CODE_3111
    return _result;
}//@CODE_3111



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
