/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Function_1argWithResult.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Function_1argWithResult<Result,Arg1>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _FUNCTION_1ARGWITHRESULT_H
#define _FUNCTION_1ARGWITHRESULT_H

//@START_USER1
//#include "XMLUtil.h"
//#include "yaccLex/Pile.h"
//#include "Evaluable.h"
//#include "Event.h"
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_5024
class ...
*/
template<class Result,class Arg1>
class Function_1argWithResult
    : public Command
{

//@START_USER2
public:

    //typedef map<string,Evaluable *,less<string > > mapStrThis;

  typedef Result Fonction(Arg1 );
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    FonctionPTR _fonction;
    Result _result;
    Arg1 _arg1;

//
// Non-Grouped Methods
//

public:
    Function_1argWithResult(BD* pBD, std::string nom, FonctionPTR fonction);
    virtual ~Function_1argWithResult();
    virtual void exec();
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
    Result getResult() const;
};

#endif


#ifdef CB_INLINES
#ifndef _FUNCTION_1ARGWITHRESULT_H_INLINES
#define _FUNCTION_1ARGWITHRESULT_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_5026
Method which must be called first in a constructor.
*/
template<class Result,class Arg1>
void Function_1argWithResult<Result,Arg1>::ConstructorInclude()
{
}



/*@NOTE_5027
Method which must be called first in a destructor.
*/
template<class Result,class Arg1>
void Function_1argWithResult<Result,Arg1>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_5033
Constructor method.
*/
template<class Result,class Arg1>
inline Function_1argWithResult<Result,Arg1>::Function_1argWithResult(BD* pBD,
                                                                     std::string nom,
                                                                     FonctionPTR fonction) //@INIT_5033
   : Command(pBD)
    , _fonction(fonction)
    , _result()
    , _arg1()
{//@CODE_5033
    ConstructorInclude();

    // Put in your own code
    setName(nom);
}//@CODE_5033



/*@NOTE_5025
  Destructor method.
*/
template<class Result,class Arg1>
inline Function_1argWithResult<Result,Arg1>::~Function_1argWithResult()
{//@CODE_5025
  DestructorInclude();
  
  // Put in your own code
}//@CODE_5025



template<class Result,class Arg1>
void Function_1argWithResult<Result,Arg1>::exec()
{//@CODE_5037
    _result = _fonction(_arg1);
}//@CODE_5037



/*@NOTE_5039
Returns the value of member '_arg1'.
*/
template<class Result,class Arg1>
inline Arg1 Function_1argWithResult<Result,Arg1>::getArg1() const
{//@CODE_5039
    return _arg1;
}//@CODE_5039



/*@NOTE_5040
Set the value of member '_arg1' to 'arg1'.
*/
template<class Result,class Arg1>
inline void Function_1argWithResult<Result,Arg1>::setArg1(Arg1 arg1)
{//@CODE_5040
    _arg1 = arg1;
}//@CODE_5040



/*@NOTE_5032
Returns the value of member '_result'.
*/
template<class Result,class Arg1>
inline Result Function_1argWithResult<Result,Arg1>::getResult() const
{//@CODE_5032
    return _result;
}//@CODE_5032



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
