/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Function_2args.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Function_2args<Arg1,Arg2>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _FUNCTION_2ARGS_H
#define _FUNCTION_2ARGS_H

//@START_USER1
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_500
class ...
*/
template<class Arg1,class Arg2>
class Function_2args
    : public Command
{

//@START_USER2
public:

  typedef void Fonction(Arg1,Arg2);
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    FonctionPTR _fonction;
    Arg1 _arg1;
    Arg2 _arg2;

//
// Non-Grouped Methods
//

public:
    Function_2args(BD* pBD, std::string nom, FonctionPTR fonction);
    virtual ~Function_2args();
    virtual void exec();
    virtual void pSetArg1(void* arg1);
    virtual void pSetArg2(void* arg2);
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
    Arg2 getArg2() const;
    void setArg2(Arg2 arg2);
};

#endif


#ifdef CB_INLINES
#ifndef _FUNCTION_2ARGS_H_INLINES
#define _FUNCTION_2ARGS_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_502
Method which must be called first in a constructor.
*/
template<class Arg1,class Arg2>
void Function_2args<Arg1,Arg2>::ConstructorInclude()
{
}



/*@NOTE_503
Method which must be called first in a destructor.
*/
template<class Arg1,class Arg2>
void Function_2args<Arg1,Arg2>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_508
Constructor method.
*/
template<class Arg1,class Arg2>
inline Function_2args<Arg1,Arg2>::Function_2args(BD* pBD, std::string nom,
                                                 FonctionPTR fonction) //@INIT_508
    :Command(pBD)
    ,_fonction(fonction)
    , _arg1()
    , _arg2()
{//@CODE_508
    ConstructorInclude();

    // Put in your own code
    setName(nom);
}//@CODE_508



/*@NOTE_501
  Destructor method.
*/
template<class Arg1,class Arg2>
inline Function_2args<Arg1,Arg2>::~Function_2args()
{//@CODE_501
  DestructorInclude();
  
  // Put in your own code
}//@CODE_501



template<class Arg1,class Arg2>
void Function_2args<Arg1,Arg2>::exec()
{//@CODE_511
    _fonction(_arg1,_arg2);
}//@CODE_511



template<class Arg1,class Arg2>
void Function_2args<Arg1,Arg2>::pSetArg1(void* arg1)
{//@CODE_5239
    setArg1( *((Arg1*)(arg1)));
}//@CODE_5239



template<class Arg1,class Arg2>
void Function_2args<Arg1,Arg2>::pSetArg2(void* arg2)
{//@CODE_5237
    setArg2( *((Arg2*)(arg2)));
}//@CODE_5237



/*@NOTE_1059
Returns the value of member '_arg1'.
*/
template<class Arg1,class Arg2>
inline Arg1 Function_2args<Arg1,Arg2>::getArg1() const
{//@CODE_1059
    return _arg1;
}//@CODE_1059



/*@NOTE_1060
Set the value of member '_arg1' to 'arg1'.
*/
template<class Arg1,class Arg2>
inline void Function_2args<Arg1,Arg2>::setArg1(Arg1 arg1)
{//@CODE_1060
    _arg1 = arg1;
}//@CODE_1060



/*@NOTE_1056
Returns the value of member '_arg2'.
*/
template<class Arg1,class Arg2>
inline Arg2 Function_2args<Arg1,Arg2>::getArg2() const
{//@CODE_1056
    return _arg2;
}//@CODE_1056



/*@NOTE_1057
Set the value of member '_arg2' to 'arg2'.
*/
template<class Arg1,class Arg2>
inline void Function_2args<Arg1,Arg2>::setArg2(Arg2 arg2)
{//@CODE_1057
    _arg2 = arg2;
}//@CODE_1057



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
