/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Function_3args.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Function_3args<Arg1,Arg2,Arg3>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _FUNCTION_3ARGS_H
#define _FUNCTION_3ARGS_H

//@START_USER1
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_515
class ...
*/
template<class Arg1,class Arg2,class Arg3>
class Function_3args
    : public Command
{

//@START_USER2
public:
  
  typedef void Fonction(Arg1,Arg2,Arg3);
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    FonctionPTR _fonction;
    Arg1 _arg1;
    Arg2 _arg2;
    Arg3 _arg3;

//
// Non-Grouped Methods
//

public:
    Function_3args(BD* pBD, std::string nom, FonctionPTR fonction);
    virtual ~Function_3args();
    virtual void exec();
    virtual void pSetArg1(void* arg1);
    virtual void pSetArg2(void* arg2);
    virtual void pSetArg3(void* arg3);
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
    Arg2 getArg2() const;
    void setArg2(Arg2 arg2);
    Arg3 getArg3() const;
    void setArg3(Arg3 arg3);
};

#endif


#ifdef CB_INLINES
#ifndef _FUNCTION_3ARGS_H_INLINES
#define _FUNCTION_3ARGS_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_517
Method which must be called first in a constructor.
*/
template<class Arg1,class Arg2,class Arg3>
void Function_3args<Arg1,Arg2,Arg3>::ConstructorInclude()
{
}



/*@NOTE_518
Method which must be called first in a destructor.
*/
template<class Arg1,class Arg2,class Arg3>
void Function_3args<Arg1,Arg2,Arg3>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_524
Constructor method.
*/
template<class Arg1,class Arg2,class Arg3>
inline Function_3args<Arg1,Arg2,Arg3>::Function_3args(BD* pBD, std::string nom,
                                                      FonctionPTR fonction) //@INIT_524
    : Command(pBD)
      , _fonction(fonction)
      , _arg1()
      , _arg2()
      , _arg3()
{//@CODE_524
    ConstructorInclude();

    // Put in your own code
    setName(nom);
}//@CODE_524



/*@NOTE_516
  Destructor method.
*/
template<class Arg1,class Arg2,class Arg3>
inline Function_3args<Arg1,Arg2,Arg3>::~Function_3args()
{//@CODE_516
  DestructorInclude();
  
  // Put in your own code
}//@CODE_516



template<class Arg1,class Arg2,class Arg3>
void Function_3args<Arg1,Arg2,Arg3>::exec()
{//@CODE_527
    _fonction(_arg1,_arg2,_arg3);
}//@CODE_527



template<class Arg1,class Arg2,class Arg3>
void Function_3args<Arg1,Arg2,Arg3>::pSetArg1(void* arg1)
{//@CODE_5241
    setArg1( *((Arg1*)(arg1)));
}//@CODE_5241



template<class Arg1,class Arg2,class Arg3>
void Function_3args<Arg1,Arg2,Arg3>::pSetArg2(void* arg2)
{//@CODE_5243
    setArg2( *((Arg2*)(arg2)));
}//@CODE_5243



template<class Arg1,class Arg2,class Arg3>
void Function_3args<Arg1,Arg2,Arg3>::pSetArg3(void* arg3)
{//@CODE_5245
    setArg3( *((Arg3*)(arg3)));
}//@CODE_5245



/*@NOTE_1053
Returns the value of member '_arg1'.
*/
template<class Arg1,class Arg2,class Arg3>
inline Arg1 Function_3args<Arg1,Arg2,Arg3>::getArg1() const
{//@CODE_1053
    return _arg1;
}//@CODE_1053



/*@NOTE_1054
Set the value of member '_arg1' to 'arg1'.
*/
template<class Arg1,class Arg2,class Arg3>
inline void Function_3args<Arg1,Arg2,Arg3>::setArg1(Arg1 arg1)
{//@CODE_1054
    _arg1 = arg1;
}//@CODE_1054



/*@NOTE_1050
Returns the value of member '_arg2'.
*/
template<class Arg1,class Arg2,class Arg3>
inline Arg2 Function_3args<Arg1,Arg2,Arg3>::getArg2() const
{//@CODE_1050
    return _arg2;
}//@CODE_1050



/*@NOTE_1051
Set the value of member '_arg2' to 'arg2'.
*/
template<class Arg1,class Arg2,class Arg3>
inline void Function_3args<Arg1,Arg2,Arg3>::setArg2(Arg2 arg2)
{//@CODE_1051
    _arg2 = arg2;
}//@CODE_1051



/*@NOTE_1047
Returns the value of member '_arg3'.
*/
template<class Arg1,class Arg2,class Arg3>
inline Arg3 Function_3args<Arg1,Arg2,Arg3>::getArg3() const
{//@CODE_1047
    return _arg3;
}//@CODE_1047



/*@NOTE_1048
Set the value of member '_arg3' to 'arg3'.
*/
template<class Arg1,class Arg2,class Arg3>
inline void Function_3args<Arg1,Arg2,Arg3>::setArg3(Arg3 arg3)
{//@CODE_1048
    _arg3 = arg3;
}//@CODE_1048



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
