/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          GroupParams.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'GroupParams'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "GroupParams.h"


int GroupParams::Parameter::getValueInt(){
  assertC2( _type == "int", pBD);
  return atoi( _value.c_str() );
}
float GroupParams::Parameter::getValueFloat(){
  assertC2( _type == "float", pBD);
  return atof( _value.c_str() );
}
std::string GroupParams::Parameter::getValueString(){
  
  return _value;
}

bool GroupParams::Parameter::loadXML(const xmlpp::Node* node, 
				     LoaderXML* loaderXML){
 
  XMLUtil xml(node);
  
  _name = xml.getFirstText("nom");
  _type = xml.getFirstText("type");
  _value = xml.getFirstText("value");
 
  return true;
}

//@END_USER2




/*@NOTE_3605
Constructor method.
*/
GroupParams::GroupParams(BD* pBD) //@INIT_3605
    : Evaluable(pBD)
    , _listParameter()
{//@CODE_3605
    ConstructorInclude();

    // Put in your own code
}//@CODE_3605


/*@NOTE_3600
Destructor method.
*/
GroupParams::~GroupParams()
{//@CODE_3600
    DestructorInclude();

    // Put in your own code
}//@CODE_3600


GroupParams::Parameter* GroupParams::getParameter(std::string name)
{//@CODE_3612

  assertC (_listParameter.find(name) != _listParameter.end() );

  GroupParams::Parameter* value = _listParameter[name];
  return value;
}//@CODE_3612


bool GroupParams::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_3617

  XMLUtil xml(node);
  
  setName( xml.getFirstText("nom"));

  vector<const xmlpp::Element*> params= xml.getAllElement("parameter");
  Parameter * par = NULL;
  

  for (unsigned int i=0; i< params.size();i++) {
    par = new Parameter(getBD());
    par->loadXML(params[i],loaderXML);
    _listParameter[par->getName()] = par;
  }
  return true;
}//@CODE_3617


Evaluable* GroupParams::staticCreate(BD* pBD)
{//@CODE_3625
    return new GroupParams(pBD);
}//@CODE_3625


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_3601
Method which must be called first in a constructor.
*/
void GroupParams::ConstructorInclude()
{
}


/*@NOTE_3602
Method which must be called first in a destructor.
*/
void GroupParams::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
