/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          LoaderGeneric.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'LoaderGeneric'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "Evaluable.h"
#include "LoaderGeneric.h"
#include "XMLUtil.h"
#include "MoteurJeuC.h"





namespace cooki3d{
//@END_USER2




/*@NOTE_3640
Constructor method.
*/
LoaderGeneric::LoaderGeneric(MainApp* mainApp) //@INIT_3640
  :  _currentPluginInitializing(NULL)
     , _rootNode(NULL)
     , _path("./")
     , _loadFinished(false)
     , _render(true)
     , _specialInterfacePlugin(NULL)    
     , _bd(NULL)
     , _env(NULL)
     , _mainApp(mainApp)
     , _genCore(false)
     , _renderMask(0xffffffff)
     , _pickMask(0x00ffffff)
     , _width(800)
     , _height(600)
     , _desc("")
     , _name("")
{//@CODE_3640
    ConstructorInclude();

    // Put in your own code
    _rootNode = new osg::Group;
    _rootNode->setName("root"); 

    _bd = new BD( this );
}//@CODE_3640


/*@NOTE_3627
Destructor method.
*/
LoaderGeneric::~LoaderGeneric()
{//@CODE_3627
    DestructorInclude();

    // Put in your own code
    
    //il est autorisé qu'un plugin puisse intancier et effacer lui meme 
    //un environnement, cependant il n'est pas possible au moment de
    //l'effacement de l'environnenent que l'Evaluable MoteurJeuC soit
    //effacé pendant sont execution, l'instance de BD ne doit donc pas 
    //pas l'effacer..., il sera donc effacé ici.
    if ( _specialInterfacePlugin != NULL ){
      delete _specialInterfacePlugin;
      _specialInterfacePlugin = NULL;
    }
    //if (_rootNode){
      //_rootNode->unref(); //TODO revoir unref fait par EnvOSG
    //  _rootNode = NULL;
    //}
    CTRACE(this,"~LoaderGeneric()")<<"_rootNode->referenceCount()="
				   <<_rootNode->referenceCount()<<endl;

    //Toute les entités vont être effacées avant le déférencement
    //de l'environnement et du noeud principal.
    delete _bd;
    //getBD()->eraseAll(); fait dans le delete
    _bd = NULL;
    
    //Ensuite on efface l'environnement
    

}//@CODE_3627


void LoaderGeneric::postInitInstances(MoteurJeuC* moteurJeuC)
{//@CODE_4457
  
  
  _currentPluginInitializing = moteurJeuC;
  
  moteurJeuC->postInitInstances(this);
  
  _currentPluginInitializing = NULL;


}//@CODE_4457


void LoaderGeneric::postInitInstancesAllLibs()
{//@CODE_3652
  
  //TODO Register<MoteurJeuC>
  BD::EvaluableIterator itMed(getBD());
  
  MoteurJeuC * moteurJeuC = NULL;
  
  while (++itMed){
    moteurJeuC = dynamic_cast<MoteurJeuC *>(itMed.Get());
    
    if (moteurJeuC){
      _currentPluginInitializing = moteurJeuC;
      moteurJeuC->postInitInstances(this);
    }
  }
  _currentPluginInitializing = NULL;
 
}//@CODE_3652


void LoaderGeneric::preInitInstances(MoteurJeuC* moteurJeuC)
{//@CODE_4458
  
  _currentPluginInitializing = moteurJeuC;
      
  moteurJeuC->preInitInstances(this);
  
  _currentPluginInitializing = NULL;


}//@CODE_4458


void LoaderGeneric::preInitInstancesAllLibs()
{//@CODE_3653
  
  //TODO Register<MoteurJeuC>
  BD::EvaluableIterator itMed(getBD());
  
  MoteurJeuC * moteurJeuC = NULL;
  
  while (++itMed){
    moteurJeuC = dynamic_cast<MoteurJeuC *>(itMed.Get());
    
    if (moteurJeuC){
      _currentPluginInitializing = moteurJeuC;
      moteurJeuC->preInitInstances(this);
    }
  }
  _currentPluginInitializing = NULL;
  
}//@CODE_3653


void LoaderGeneric::setSpecialInterfacePlugin()
{//@CODE_4456
  assertC( _currentPluginInitializing );
  _specialInterfacePlugin = _currentPluginInitializing;
  _specialInterfacePlugin->setNoDeleteFlag( true );

}//@CODE_4456


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_3628
Method which must be called first in a constructor.
*/
void LoaderGeneric::ConstructorInclude()
{
}


/*@NOTE_3629
Method which must be called first in a destructor.
*/
void LoaderGeneric::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
