/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          LoaderGeneric.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'LoaderGeneric'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _LOADERGENERIC_H
#define _LOADERGENERIC_H

//@START_USER1
#include <string>

#include "XMLUtil.h"


namespace cooki3d{

  class MoteurJeuC; 
  class MainApp;
//@END_USER1


/*@NOTE_3626
class...
*/

class AFX_EXT_CLASS LoaderGeneric
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    MoteurJeuC* _currentPluginInitializing;

protected:
    osg::ref_ptr<osg::Group> _rootNode;
    std::string _path;
    bool _loadFinished;
    bool _render;
    MoteurJeuC* _specialInterfacePlugin;
    BD* _bd;
    EnvironnementOSG* _env;
    MainApp* _mainApp;
    bool _genCore;
    osg::Node::NodeMask _renderMask;
    osg::Node::NodeMask _pickMask;
    int _width;
    int _height;
    std::string _desc;
    std::string _name;

//
// Non-Grouped Methods
//

protected:
    void postInitInstancesAllLibs();
    void preInitInstancesAllLibs();

public:
    LoaderGeneric(MainApp* mainApp);
    virtual ~LoaderGeneric();
    std::string getPath(std::string file);
    void postInitInstances(MoteurJeuC* moteurJeuC);
    void preInitInstances(MoteurJeuC* moteurJeuC);
    void setSpecialInterfacePlugin();
    BD* getBD() const;
    void setBD(BD* pBd);
    std::string getDesc() const;
    EnvironnementOSG* getEnv() const;
    void setEnv(EnvironnementOSG* pEnv);
    bool isGenCore() const;
    void setGenCore(bool genCore);
    int getHeight() const;
    void setHeight(int height);
    bool isLoadFinished() const;
    void setLoadFinished(bool loadFinished);
    MainApp* getMainApp() const;
    std::string getName() const;
    void setName(std::string name);
    void setPath(std::string path);
    osg::Node::NodeMask getPickMask() const;
    void setPickMask(osg::Node::NodeMask pickMask);
    bool isRender() const;
    void setRender(bool render);
    osg::Node::NodeMask getRenderMask() const;
    void setRenderMask(osg::Node::NodeMask renderMask);
    osg::ref_ptr<osg::Group> getRootNode() const;
    void setRootNode(osg::ref_ptr<osg::Group> rootNode);
    int getWidth() const;
    void setWidth(int width);
};

#endif


#ifdef CB_INLINES
#ifndef _LOADERGENERIC_H_INLINES
#define _LOADERGENERIC_H_INLINES

inline std::string LoaderGeneric::getPath(std::string file)
{//@CODE_3650
      assertC(file.length()>=2);
#ifdef UNIX    
    if (file[0]!='/'){
       return _path+file;
    }
#else
    if (file[1]!=':' 
	&& file[0]!='/'){ //test avec wine
       return _path+file;
    } 
#endif
    return file;
}//@CODE_3650



/*@NOTE_4829
Returns the value of member '_bd'.
*/
inline BD* LoaderGeneric::getBD() const
{//@CODE_4829
    return _bd;
}//@CODE_4829



/*@NOTE_4830
Set the value of member '_bd' to 'pBd'.
*/
inline void LoaderGeneric::setBD(BD* pBd)
{//@CODE_4830
    _bd = pBd;
}//@CODE_4830



/*@NOTE_5210
Returns the value of member '_desc'.
*/
inline std::string LoaderGeneric::getDesc() const
{//@CODE_5210
    return _desc;
}//@CODE_5210



/*@NOTE_4823
Returns the value of member '_env'.
*/
inline EnvironnementOSG* LoaderGeneric::getEnv() const
{//@CODE_4823
    return _env;
}//@CODE_4823



/*@NOTE_4824
Set the value of member '_env' to 'pEnv'.
*/
inline void LoaderGeneric::setEnv(EnvironnementOSG* pEnv)
{//@CODE_4824
    _env = pEnv;
}//@CODE_4824



/*@NOTE_5200
Returns the value of member '_genCore'.
*/
inline bool LoaderGeneric::isGenCore() const
{//@CODE_5200
    return _genCore;
}//@CODE_5200



/*@NOTE_5220
Set the value of member '_genCore' to 'genCore'.
*/
inline void LoaderGeneric::setGenCore(bool genCore)
{//@CODE_5220
    _genCore = genCore;
}//@CODE_5220



/*@NOTE_5208
Returns the value of member '_height'.
*/
inline int LoaderGeneric::getHeight() const
{//@CODE_5208
    return _height;
}//@CODE_5208



/*@NOTE_5222
Set the value of member '_height' to 'height'.
*/
inline void LoaderGeneric::setHeight(int height)
{//@CODE_5222
    _height = height;
}//@CODE_5222



/*@NOTE_4335
Returns the value of member '_loadFinished'.
*/
inline bool LoaderGeneric::isLoadFinished() const
{//@CODE_4335
    return _loadFinished;
}//@CODE_4335



/*@NOTE_4336
Set the value of member '_loadFinished' to 'loadFinished'.
*/
inline void LoaderGeneric::setLoadFinished(bool loadFinished)
{//@CODE_4336
    _loadFinished = loadFinished;
}//@CODE_4336



/*@NOTE_5131
Returns the value of member '_mainApp'.
*/
inline MainApp* LoaderGeneric::getMainApp() const
{//@CODE_5131
    return _mainApp;
}//@CODE_5131



/*@NOTE_5212
Returns the value of member '_name'.
*/
inline std::string LoaderGeneric::getName() const
{//@CODE_5212
    return _name;
}//@CODE_5212



/*@NOTE_5224
Set the value of member '_name' to 'name'.
*/
inline void LoaderGeneric::setName(std::string name)
{//@CODE_5224
    _name = name;
}//@CODE_5224



/*@NOTE_3664
Set the value of member '_path' to 'path'.
*/
inline void LoaderGeneric::setPath(std::string path)
{//@CODE_3664
    _path = path;
}//@CODE_3664



/*@NOTE_5204
Returns the value of member '_pickMask'.
*/
inline osg::Node::NodeMask LoaderGeneric::getPickMask() const
{//@CODE_5204
    return _pickMask;
}//@CODE_5204



/*@NOTE_5226
Set the value of member '_pickMask' to 'pickMask'.
*/
inline void LoaderGeneric::setPickMask(osg::Node::NodeMask pickMask)
{//@CODE_5226
    _pickMask = pickMask;
}//@CODE_5226



/*@NOTE_4380
Returns the value of member '_render'.
*/
inline bool LoaderGeneric::isRender() const
{//@CODE_4380
    return _render;
}//@CODE_4380



/*@NOTE_4381
Set the value of member '_render' to 'render'.
*/
inline void LoaderGeneric::setRender(bool render)
{//@CODE_4381
    _render = render;
}//@CODE_4381



/*@NOTE_5228
Returns the value of member '_renderMask'.
*/
inline osg::Node::NodeMask LoaderGeneric::getRenderMask() const
{//@CODE_5228
    return _renderMask;
}//@CODE_5228



/*@NOTE_5229
Set the value of member '_renderMask' to 'renderMask'.
*/
inline void LoaderGeneric::setRenderMask(osg::Node::NodeMask renderMask)
{//@CODE_5229
    _renderMask = renderMask;
}//@CODE_5229



/*@NOTE_4783
Returns the value of member '_rootNode'.
*/
inline osg::ref_ptr<osg::Group> LoaderGeneric::getRootNode() const
{//@CODE_4783
    return _rootNode;
}//@CODE_4783



/*@NOTE_4784
Set the value of member '_rootNode' to 'rootNode'.
*/
inline void LoaderGeneric::setRootNode(osg::ref_ptr<osg::Group> rootNode)
{//@CODE_4784
    _rootNode = rootNode;
}//@CODE_4784



/*@NOTE_5206
Returns the value of member '_width'.
*/
inline int LoaderGeneric::getWidth() const
{//@CODE_5206
    return _width;
}//@CODE_5206



/*@NOTE_5231
Set the value of member '_width' to 'width'.
*/
inline void LoaderGeneric::setWidth(int width)
{//@CODE_5231
    _width = width;
}//@CODE_5231



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
