/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          LoaderXML.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'LoaderXML'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
//void setUpDiffBump(osgFX::Effect * bump,std::string diffFile,std::string bumpFile);


#include <sstream>
#include <string>
//#include <glibmm-2.4/glibmm/ustring.h>


#include <osgFX/BumpMapping>
//#include <osgCal/CoreModel>
//#include <osgCal/Model>
#include <osg/MatrixTransform>
#include <osgDB/WriteFile>
#include <osgDB/Registry>

#include "ScanSetGraph.h"
#include "LoaderXML.h"
#include "SolGravitation.h"
#include "SolCollisions.h"
#include "File.h"
#include "Animation.h"
#include "Sequence.h"
#include "EvtMouse.h"
#include "CharacterSeqAnim.h"
#ifdef OSG_CAL_SUPPORT
#   include "CharacterOsgCal.h"
#endif 
#include "Camera.h"
#include "OsgNodeReference.h"
#include "Sound.h"
#ifdef SMPEG_SUPPORT
#   include "SoundMpeg.h"
#endif
#include "Texte.h"
#include "BoundingShape.h"
#include "EvtKey.h"
#include "GroupParams.h"
#include "Methode_2args.h"
#include "EvtBoundingShapeCollision.h"
#include "AnimationGroup.h"
#include "EvtKeyGroup.h"
#include "TimeBar.h"

namespace cooki3d {




LoaderXML::Loader::Loader
( std::string s, 
  Function_1argWithResult<Evaluable*,BD*>::FonctionPTR ptr ) :
  _nomNodeXml(s) ,
  _ptrFonc(ptr)
{
  //_fonc->setPersistant(true);
  //_fonc = new Function_0argWithResult
  //   <Evaluable*>("Command loaderXml_"+s,ptr);
}

Evaluable * LoaderXML::Loader::exec(BD * pBD){
  
  //_fonc->exec();
  //return _fonc->getResult();
  return _ptrFonc(pBD);
}
 
//@END_USER2




/*@NOTE_285
  Constructor method.
*/
LoaderXML::LoaderXML(MainApp* mainApp) //@INIT_285
    : LoaderGeneric(mainApp)
{//@CODE_285
  ConstructorInclude();
  
  
  //on s'assure qu'il n'y a qu'une instance
  //de Loader possible (enfin en gros..)
  //assertC(_loadFinished==false); 

  
  
  //if (_orderByLoadList == NULL){
  //_orderByLoadList = new std::vector<LoaderXML::Loader>();
  
  
  //en premier les terrains pour pouvoir éventuellment generer les maps
  //sans d'autre choses chargé en même temps. Attention que les terrains
  //ne se chevauches pas sinon problemes...->generer les séparément
  _orderByLoadList.push_back(Loader("solGravitation", 
				    cooki3d::SolGravitation::staticCreate));
  
  _orderByLoadList.push_back(Loader("solCollisions", 
				    cooki3d::SolCollisions::staticCreate));
  
  _orderByLoadList.push_back(Loader("file", 
				    cooki3d::File::staticCreate));

  //l'appel sera en réalité static car une config animation 
  //peut en représenter plusieurs (1 par osg::Node)
  _orderByLoadList.push_back(Loader("animation", 
				    cooki3d::Animation::staticCreate));
  
  _orderByLoadList.push_back(Loader("sequence", 
				    cooki3d::Sequence::staticCreate));
  
  //Deprecie
  //_orderByLoadList.push_back(Loader("collision", 
  //cooki3d::Collision::staticCreate));
  
  _orderByLoadList.push_back(Loader("evtMouse", 
				    cooki3d::EvtMouse::staticCreate));
  
  //Deprecie
  //_orderByLoadList.push_back(Loader("evtCollision", 
  //			    cooki3d::EvtCollision::staticCreate));
  
#ifdef OSG_CAL_SUPPORT  
  _orderByLoadList.push_back(Loader("characterOsgCal",
				    cooki3d::CharacterOsgCal::staticCreate));
#endif
  
  _orderByLoadList.push_back(Loader("characterSeqAnim",
				    cooki3d::CharacterSeqAnim::staticCreate));
    
  _orderByLoadList.push_back(Loader("camera", cooki3d::Camera::staticCreate));
  
  _orderByLoadList.push_back(Loader("osgNodeReference",
				    cooki3d::OsgNodeReference::staticCreate));
  
  _orderByLoadList.push_back(Loader("sound", cooki3d::Sound::staticCreate));
  
#ifdef SMPEG_SUPPORT
  _orderByLoadList.push_back(Loader("soundMpeg", 
				    cooki3d::SoundMpeg::staticCreate));
#endif
  
  _orderByLoadList.push_back(Loader("texte", cooki3d::Texte::staticCreate));

  _orderByLoadList.push_back(Loader("boundingShape", 
				    cooki3d::BoundingShape::staticCreate));

  _orderByLoadList.push_back(Loader("evtKey", 
				    cooki3d::EvtKey::staticCreate));

  _orderByLoadList.push_back(Loader("groupParams", 
				    cooki3d::GroupParams::staticCreate));

  _orderByLoadList.push_back(Loader("evtBoundingShapeCollision", 
				    cooki3d::EvtBoundingShapeCollision::staticCreate));
  
  _orderByLoadList.push_back(Loader("animationGroup", 
				    cooki3d::AnimationGroup::staticCreate));

  _orderByLoadList.push_back(Loader("evtKeyGroup", 
				    cooki3d::EvtKeyGroup::staticCreate));

  _orderByLoadList.push_back(Loader("timeBar", 
				    cooki3d::TimeBar::staticCreate));
  

  
}//@CODE_285


/*@NOTE_281
  Destructor method.
*/
LoaderXML::~LoaderXML()
{//@CODE_281
  DestructorInclude(); 
  //_loadFinished = false;
  //_orderByLoadList = NULL;
  CTRACE(this,"~LoaderXML")<<" Destruction du chargeur"
				<<" de jeu (tjs unique)"<<endl;
  
  // Put in your own code
}//@CODE_281


Evaluable* LoaderXML::loadEvaluableXML(const xmlpp::Node* node,
                                       std::string nodeName)
{//@CODE_4351
  
  std::vector<LoaderXML::Loader>::iterator itChunk = _orderByLoadList.begin();
  
  while ( itChunk != _orderByLoadList.end()
	 && (*itChunk)._nomNodeXml != nodeName ){
    
    itChunk ++;
  }
  if ( itChunk == _orderByLoadList.end()){
    CERR(this,"loadEvaluableXML")<<"not found chunk "<<nodeName<<" !!"<<endl; 
  }
  else {
    return loadEvaluableXML( node, *itChunk );
  }
  
  return NULL;
     
}//@CODE_4351


Evaluable* LoaderXML::loadEvaluableXML(const xmlpp::Node* node,
                                       LoaderXML::Loader& chunkLoader)
{//@CODE_4354
  
  
  Evaluable * eval = NULL;
  
  XMLUtil xmlJustSee(  node  );//attention 1 seule utilisation par champs
  
  if ( xmlJustSee.getFirstText("enable") == "false"){
    
    CWARN(this,"loadXml")<<"XML: "<<chunkLoader._nomNodeXml<<" \""
			 <<xmlJustSee.getFirstText("nom")<<"\" is disabled!"<<endl;
  } else {
    CINFOs<<"loadXML: "<< chunkLoader._nomNodeXml<<" \""
	  <<xmlJustSee.getFirstText("nom")<<"\" ..."<<endl;
    eval = chunkLoader.exec(getBD());
    
    if (! eval->loadXML( node, this) ){
      //CERR(this,"loadXML")<<"XML: \""<<eval->getName()<<"\" KO"<<endl; 
      //SEGFAULT sur eval->getName  si jamais le destructeur 
      //a été précedement appelé !!
      throw LoaderXmlException();
    } else {
      if (eval->getName() != "staticLoader"){
	CINFOs<<"loadXML: \""<<eval->getName()<<"\" OK"<<endl;
      }
    }
  }

  return eval;
   
}//@CODE_4354


bool LoaderXML::loadFilePathXML(const xmlpp::Node* node)
{//@CODE_4347

  XMLUtil xml(node);
  
  vector<const xmlpp::Element*> filePaths= xml.getAllElement("filePath");
  //méthode 4 optimum + garder ce qu'il y a déjà dans le path
  osgDB::FilePathList & fpl =
    osgDB::Registry::instance()->getDataFilePathList();
  for (unsigned int i=0; i<filePaths.size();i++) {
    xml.set(filePaths[i]);
   fpl.push_back( this->getPath( xml.getFirstText("nom") ));      
  }
  osgDB::Registry::instance()->setDataFilePathList(fpl);
    
  return false;
}//@CODE_4347


bool LoaderXML::loadJeu(std::string absFileName)
{//@CODE_286
#ifdef XML_SUPPORT 
  MapRW mapp;
  string path,file,ext;
  mapp.split(absFileName,path,file,ext);
  CTRACE(this,"loadJeu(std::string absFileName)")<<"absFileName="
						 <<absFileName<<endl;
  CTRACE(this,"loadJeu(std::string absFileName)")<<"file ="<<file<<endl;
  CTRACE(this,"loadJeu(std::string absFileName)")<<"ext ="<<ext
						 <<endl;

  if (ext == ".xml"){    
    try {
      xmlpp::DomParser parser;
      parser.set_substitute_entities(true);
      parser.parse_file( absFileName );
      return loadJeuFromParser(parser);
    }
    catch(const std::exception& ex) {
      std::cout << "Exception caught : " << ex.what() << std::endl;
      return false;
    }
  }
#else
  CERR(this,"loadJeu(std::string absFileName)")<<"Le support XML n'est pas compilé!!!"<<endl;    
#endif
 return false;


}//@CODE_286


bool LoaderXML::loadJeuFromParser(xmlpp::DomParser& parser)
{//@CODE_1132
  
  //new BD(); //création de l'instance de base de donnée à la main
  ///if( parser) ) {
    
#ifndef XML_SUPPORT 
  assert(0);
#endif

  bool res =false;
  
  //Walk the tree:
  const xmlpp::Node* node = parser.get_document()->get_root_node(); 
  
  std::string nodeName = node->get_name();
  if (nodeName != "jeu") assertC(0);
  
  XMLUtil xml(node);
  //quelques propriétés du chargeur (Warning : tjs respecter l'ordre)
  _name = xml.getFirstText("nom");
  _path=xml.getFirstText("pathJeu");  
  _genCore=xml.getFirstText("genCore") == "true";
  _render =xml.getFirstText("render") == "true";
  //TODO
  //_renderMask
  //_pickMask
  _width = atoi(xml.getFirstText("width").c_str());
  _height = atoi(xml.getFirstText("height").c_str());
  _desc = xml.getFirstText("desc");
  

  //chargement des librairies 
  vector<const xmlpp::Element*> liste 
    = xml.getAllElement("librairie");
  
  vector<const xmlpp::Element*>::iterator it=liste.begin();
  Evaluable * eval =NULL;
  
  while (it != liste.end()){
    
    XMLUtil xmlLib(*it);
    
    if (   xmlLib.getFirstText("enable") == "false"  ){
      CWARN(this,"loadXml")<<"XML: library \""<<xmlLib.getFirstText("nom")
			   <<"\" is disabled"<<endl;
    }else {

      CINFOs<<"XML: "<<"librairie loading..."<<endl;
      eval = new MoteurJeuC(getBD());
      if (eval->loadXML(*it,this)){     
	CINFOs<<"XML: \""<<eval->getName()<<"\" OK"<<endl;
      }else {
	CERR(this,"loadJeuFromParser")<<"XML: \""
				      <<eval->getName()<<"\" KO"<<endl;
	throw LoaderXmlException();
      }
    }
    ++it;
  }
  
  
  //pré initialisation des librairies.
  preInitInstancesAllLibs();
  
  
  //Chargement de chaque élément level
  liste = xml.getAllElement("level");
  it=liste.begin();
  if (liste.size() == 0){
    CWARN(this,"loadJeuFromParser")
      <<" Attention aucun <level> definis!!"
      <<endl;
  }
  
  try {
    while (it != liste.end()){
      *it;
      loadLevelXML(*it);      
      ++it;
    }
    
    //si l'on est en mode rendu 
    //TODO passer le rootNode dans Environnement vers LoaderXml
    //if (_render){
    
    //parcours de l'arbre et liaison des collisions et des animations...
    //en 2 pass car la premiere pass créer des références de noeud 
    //exigées par la deuxieme 
    //pass 1:
    CINFOs<<"scanCommandPass1..."<<endl;
    ScanSetGraph mesh;  
    Methode_2args<LoaderXML,osg::Node*,osg::Node*> 
      com(getBD(),"LoaderXML::scanCommandPass1",
	  &LoaderXML::scanCommandPass1,this);   
    mesh.scanEtCommand2args( getRootNode().get(), NULL,&com);
    
    //quelques vérifications (pass1)
    if (!Animation::checkAllInstances(this) || 
	!Sequence::checkAllInstances(this)){
      throw LoaderXmlException();
    }
    
    //pass 2:
    CINFOs<<"scanCommandPass2..."<<endl;
    Methode_2args<LoaderXML,osg::Node*,osg::Node*> 
      com2(getBD(),"LoaderXML::scanCommandPass2",
	   &LoaderXML::scanCommandPass2,this);   
    mesh.scanEtCommand2args(/*EnvironnementOSG::instance()->*/
			    getRootNode().get(),NULL,&com2);
    
    //quelques vérifications (pass2)
    //TODO
    /* if (!BoundingShape::checkAllInstances()){
       throw LoaderXmlException();
       }
       if (!Camera::checkAllInstances()){
       throw LoaderXmlException();
       }*/
    if (!getBD()->checkAllInstances()){
      throw LoaderXmlException();
    }
    
    //taches à lancer à la fin du chargement  //
    
    //post initialisation des librairies
    postInitInstancesAllLibs();
    
    //post initialisation automatiques
    //on démarre les média qui doivent être lancé (play()) au démarrage
    //MediaEvaluable::playInstancesOnStart(); 
    // => fait dans class EnvironnementOSG (setLoader)
  
    
    //signaler la fin du chargement aux arrières taches 
    //en attente de démarrage
    CTRACE(this,"loadJeuFromParser")
      <<"XML -----------> setLoadFinished(true);"<<endl;
    setLoadFinished(true);
    
    
    //écriture d'un core de l'arbre osg pour le débuggage
    if (_genCore){
      CINFOs<<"core file generation :"<<_path+"core.osg ..."<<endl;
      if (!osgDB::writeNodeFile(*(/*EnvironnementOSG::instance()->*/
				 getRootNode()),_path+"core.osg") ){
	CERR(this,"loadJeuFromParser")<<" fail to write core file !!"<<endl;
      }
    }
    res= true;
  }
  catch(const LoaderXmlException& ex) {
    //CERR(this,"loadJeuFromParser")<<" LoaderXmlException! "
    //	  <<"=> le chargement sera incomplet!"<<endl;
    CERR(this,"loadJeuFromParser")<<" LoaderXmlException! "
    	  <<"=> the load has failed !"<<endl;

    res= false;
  }
  return res;
  
}//@CODE_1132


bool LoaderXML::loadJeuFromString(std::string fluxXML)
{//@CODE_1130
      
  CTRACE(this,"loadJeuFromString(std::string fluxXML)")<<fluxXML<<endl;
  try {
    xmlpp::DomParser parser;
    parser.set_substitute_entities(true);
    parser.parse_memory(fluxXML);
    return loadJeuFromParser(parser);
  }
  catch(const std::exception& ex) {
    std::cout << "Exception caught: " << ex.what() << std::endl;
    return false;
  }  
  return false;
}//@CODE_1130


bool LoaderXML::loadLevelXML(const xmlpp::Node* node)
{//@CODE_735
    
   
  XMLUtil xml(node);
  
  if (   xml.getFirstText("enable") == "false"  ){
    CWARN(this,"loadXml")<<"XML: level \""<<xml.getFirstText("nom")
			 <<"\" is disabled"<<endl;
    return false;
  }

  //gestion du path pour trouver les fonts, images...
  this->loadFilePathXML( node );

  std::string sLevelName = xml.getFirstText("nom");
  CINFOs<<"loadXML: level \""<<sLevelName<<"\"..."<<endl;
    
  vector<const xmlpp::Element*> liste;
  vector<const xmlpp::Element*>::iterator it;
  
  
  
  for(std::vector<LoaderXML::Loader>::iterator itChunk 
	= _orderByLoadList.begin();
      itChunk != _orderByLoadList.end();
      itChunk ++){
    
    CTRACEnext<<"support chunk :"<< (*itChunk)._nomNodeXml<<endl;
    liste = xml.getAllElement( (*itChunk)._nomNodeXml );
    it=liste.begin();
    
    //Evaluable * eval = NULL;

    //on ajoute un prefixe pour toute les instances 
    //reliées à ce level
    std::string oldPrefix = Evaluable::getCreateInstancePrefix();
    Evaluable::setCreateInstancePrefix( oldPrefix + sLevelName+"->");

    while (it != liste.end()){
      
      loadEvaluableXML( *it, *itChunk );
      
//       XMLUtil xmlJustSee(  *it  );//attention 1 seule utilisation par champs
      
//       if ( xmlJustSee.getFirstText("enable") == "false"){
	
// 	CWARN(this,"loadXml")<<"XML: "<<(*itChunk)._nomNodeXml<<" \""
// 			     <<xmlJustSee.getFirstText("nom")<<"\" is disabled!"<<endl;
//       }else {
// 	CINFOs<<"loadXML: "<<(*itChunk)._nomNodeXml<<" \""
// 	      <<xmlJustSee.getFirstText("nom")<<"\" ..."<<endl;
// 	eval = (*itChunk).exec();
	
// 	if (! eval->loadXML(*it,this) ){
// 	  //CERR(this,"loadXML")<<"XML: \""<<eval->getName()<<"\" KO"<<endl; 
// 	  //SEGFAULT car eval->getName est déjà effacé!!
// 	  throw LoaderXmlException();
// 	}else {
// 	  if (eval->getName() != "staticLoader"){
// 	    CINFOs<<"loadXML: \""<<eval->getName()<<"\" OK"<<endl;
// 	  }
// 	}
//       }

      ++it;
    }
    Evaluable::setCreateInstancePrefix( oldPrefix );    
  }  
  return true;
}//@CODE_735


void LoaderXML::scanCommandPass1(osg::Node* n, osg::Node* parent)
{//@CODE_718
  
  const std::string s = ScanSetGraph::getFirstNamePath( n );
  CTRACE(this,"scanCommandPass1")<<"s="<<s<<endl;
  
  //peut engendrer des modifications dans l'arbre final
  OsgNodeReference::linkOsgNodeReference( n, parent, s, this );

  Animation::linkAnimation( n, s, this);
  AnimationGroup::linkAnimationGroup( n, s, this);
  Sequence::linkSequence( n, s, this);

  //dependance avec Animation et Sequence
  //peut engendrer des modifications dans l'arbre final
  CharacterSeqAnim::linkCharacterSeqAnim( n, s, this );

  //on compabilise les noeuds possibles pour la vérification finale
  EvtMouse::checkPotentialActiveNode(s, this);
  
  //Ici, on doit éventuellement rapeller scanCommandPass1 
  //sur un parent ajouté
  //dans le cas où un nouveau noeud a été inséré
  if ( ScanSetGraph::getFirstNamePath( n ) != s){
    
    CINFOs<<"nodePath \""<<s<<"\" has been moved to \""<<
      ScanSetGraph::getFirstNamePath( n )<<"\""<<endl;

    //si c'est le premier parent qui  a changé
    //on rescan le nouveau path
    if (parent != n->getParent(0) ) {
      
      CTRACEs("LoaderXML::scanCommandPass1")
	<<"RESCAN~ "<<n<<" with new path "
	<<ScanSetGraph::getFirstNamePath( n )<<endl;
      
      scanCommandPass1( n, n->getParent(0) );
  }
  //sinon
  //on decide de ne pas remonter de plus d'un parent en arrière
  else {
    CERR(this,"scanCommandPass1")<<"The structure has been altered"
				 <<" by node insertion "
				 <<"without be loaded correctly!"<<endl;
  }
}
  
}//@CODE_718


void LoaderXML::scanCommandPass2(osg::Node* n, osg::Node* parent)
{//@CODE_2264
  const std::string s = ScanSetGraph::getFirstNamePath( n );
  Camera::linkCamera( n, s, this );
  BoundingShape::linkBoundingShape( n, parent, s, this );

  //cout<<"s="<<s<<endl;
  //deprecie
  //Collision::lierCollision(n);  //apres Ani,Seq et Perso  
}//@CODE_2264


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_282
Method which must be called first in a constructor.
*/
void LoaderXML::ConstructorInclude()
{
}


/*@NOTE_283
Method which must be called first in a destructor.
*/
void LoaderXML::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d


// void setUpDiffBump(osgFX::Effect * effet,std::string diffFile,std::string bumpFile)
// {
//   osgFX::BumpMapping *bump = dynamic_cast<osgFX::BumpMapping *>(effet); 
//   assertC(bump);
  
//   bump->setLightNumber(0);
//   bump->setNormalMapTextureUnit(2);

//   // generate texture coordinates
//   //TexCoordGenerator tcg(bump->getDiffuseTextureUnit(),bump->getDiffuseTextureUnit());
//   //for (unsigned i=0; i<bump->getNumChildren(); ++i)
//   //  bump->getChild(i)->accept(tcg);
  
//   // set up diffuse texture
//   osg::Texture2D * diffuse_tex = new osg::Texture2D;
//   diffuse_tex->setImage(osgDB::readImageFile(diffFile));
//   diffuse_tex->setFilter(osg::Texture::MIN_FILTER, 
// 			 osg::Texture::LINEAR_MIPMAP_LINEAR);
//   diffuse_tex->setFilter(osg::Texture::MAG_FILTER, osg::Texture::LINEAR);
//   diffuse_tex->setWrap(osg::Texture::WRAP_S, osg::Texture::REPEAT);
//   diffuse_tex->setWrap(osg::Texture::WRAP_T, osg::Texture::REPEAT);
//   diffuse_tex->setMaxAnisotropy(8);
//   bump->setOverrideDiffuseTexture(diffuse_tex);
  
//   // set up normal map texture
//   osg::Texture2D * normal_tex = new osg::Texture2D;
//   normal_tex->setImage(osgDB::readImageFile(bumpFile));
//   normal_tex->setFilter(osg::Texture::MIN_FILTER, osg::Texture::LINEAR_MIPMAP_LINEAR);
//   normal_tex->setFilter(osg::Texture::MAG_FILTER, osg::Texture::LINEAR);
//   normal_tex->setWrap(osg::Texture::WRAP_S, osg::Texture::REPEAT);
//   normal_tex->setWrap(osg::Texture::WRAP_T, osg::Texture::REPEAT);
//   normal_tex->setMaxAnisotropy(8);
//   bump->setOverrideNormalMapTexture(normal_tex);
  
//   // generate tangent-space basis vector
//   //bump->prepareChildren();
  
//   // recreate techniques on next step
//   //bump->dirtyTechniques();




// bool LoaderXML::loadXML(const xmlpp::Node* node)
// {//@CODE_735
    
   
//   XMLUtil xml(node);
//   CTRACE(this,"loadXML")<<" loadLevel "<<xml.getFirstText("nom")<<endl;

//   vector<const xmlpp::Element*> liste;
//   vector<const xmlpp::Element*>::iterator it;

//   //en premier les terrains pour pouvoir éventuellment generer les maps
//   //sans d'autre choses chargé en même temps. Attention que les terrains
//   //ne se chevauches pas sinon problemes...->generer les séparément
//   liste = xml.getAllElement("solGravitation");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     //CINFOs<<"XML: load SolGravitation"<<endl;
//     if (!(new SolGravitation())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

//   liste = xml.getAllElement("solCollisions");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new SolCollisions())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

  
//   liste = xml.getAllElement("fichier");
//   it=liste.begin();      
//   while (it != liste.end()){
//     if (!(new File())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }
  
//   liste = xml.getAllElement("animation");
//   it=liste.begin();
//   while (it != liste.end()){
//     //appel static car une config animation 
//     //peut en représenter plusieurs (1 par osg::Node)
//     if (!Animation::staticLoadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

//   liste = xml.getAllElement("sequence");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new Sequence())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

  
//   liste = xml.getAllElement("collision");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new Collision())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }
  

//   liste = xml.getAllElement("evtMouse");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new EvtMouse())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }
  
//   liste = xml.getAllElement("evtCollision");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new EvtCollision())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

// #ifdef OSG_CAL_SUPPORT  
//   liste = xml.getAllElement("personnageOsgCal");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new CharacterOsgCal())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }
// #endif

//   liste = xml.getAllElement("personnageSeqAnim");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new CharacterSeqAnim())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

//   liste = xml.getAllElement("camera");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new Camera())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

//   liste = xml.getAllElement("osgNodeReference");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new OsgNodeReference())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

//   liste = xml.getAllElement("son");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new Sound())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }

// #ifdef SMPEG_SUPPORT
//   liste = xml.getAllElement("sonMpeg");
//   it=liste.begin();
  
//   while (it != liste.end()){
//     if (!(new SoundMpeg())->loadXML(*it)){
//       throw LoaderXmlException();
//     }
//     ++it;
//   }
// #endif

//   liste = xml.getAllElement("t


 //méthode 1 (tordu mais c'est une première idée qui marche)
  //string path="";
  //for (unsigned int i=0; i<filePaths.size();i++) {
  //  xml.set(filePaths[i]);
  //  path =path +":"+LoaderXML::getPath()+ xml.getFirstText("nom");      
  //}

  //if (path.length() > 0){
  //  path.erase(0,1);
  //  setenv("OSG_FILE_PATH",path.c_str(),1);
  //  CTRACE(this,"LoadXML")<<"après "<<getenv("OSG_FILE_PATH")<<endl;
  //}
  //CTRACE(this,"LoadXML")<<"path="<<path<<endl;  
  //osgDB::Registry::instance()->initDataFilePathList();

  //méthode 2 plus propre (on garde le for)
  //osgDB::Registry::instance()->setDataFileList(path);

  //méthode 3 optimum (on garde le for)
  ////on a un typedef std::deque<std::string> FilePathList;
  //construction de FilePathList fpl;
  //osgDB::Registry::instance()->setDataFileList(fpl);
