/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          LoaderXML.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'LoaderXML'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _LOADERXML_H
#define _LOADERXML_H

//@START_USER1
//#include "MapRW.h"
#include <vector>
#include <osg/Node>

#include <osgFX/Registry>
#include <osgFX/Effect>
//#include "Character.h"
//#include <libxml++/libxml++.h>
#include "XMLUtil.h"

#include "MoteurJeuC.h"
#include "Function_1argWithResult.h"
#include "LoaderGeneric.h"
     
namespace cooki3d{

  class LoaderXmlException {};

  class Event;
//@END_USER1


/*@NOTE_280
class...
*/

class AFX_EXT_CLASS LoaderXML
    : public LoaderGeneric
{

//@START_USER2
public:
    typedef map<string,Event *,less<string > > mapStrEvt;
  //static void setPath(std::string s){
  //      _path = s;
  //  }

    class Loader {
    public:
      std::string _nomNodeXml;
      Function_1argWithResult<Evaluable*,BD*>::FonctionPTR _ptrFonc;
            
      Loader(std::string s, 
	     Function_1argWithResult<Evaluable*,BD*>::FonctionPTR ptr);

      Evaluable * exec(BD * pBD);
      
    };

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    std::vector<LoaderXML::Loader> _orderByLoadList;

//
// Non-Grouped Methods
//

public:
    LoaderXML(MainApp* mainApp);
    virtual ~LoaderXML();
    virtual Evaluable* loadEvaluableXML(const xmlpp::Node* node,
                                        std::string nodeName);
    virtual Evaluable* loadEvaluableXML(const xmlpp::Node* node,
                                        LoaderXML::Loader& chunkLoader);
    bool loadFilePathXML(const xmlpp::Node* node);
    bool loadJeu(std::string absFileName);
    bool loadJeuFromParser(xmlpp::DomParser& parser);
    bool loadJeuFromString(std::string fluxXML);
    virtual bool loadLevelXML(const xmlpp::Node* node);
    void scanCommandPass1(osg::Node* n, osg::Node* parent);
    void scanCommandPass2(osg::Node* n, osg::Node* parent);
    std::vector<LoaderXML::Loader> getOrderByLoadList() const;
    void setOrderByLoadList(std::vector<LoaderXML::Loader> orderByLoadList);
};

#endif


#ifdef CB_INLINES
#ifndef _LOADERXML_H_INLINES
#define _LOADERXML_H_INLINES

/*@NOTE_3122
Returns the value of member '_orderByLoadList'.
*/
inline std::vector<LoaderXML::Loader> LoaderXML::getOrderByLoadList() const
{//@CODE_3122
    return _orderByLoadList;
}//@CODE_3122



/*@NOTE_3123
Set the value of member '_orderByLoadList' to 'orderByLoadList'.
*/
inline void LoaderXML::setOrderByLoadList(std::vector<LoaderXML::Loader> orderByLoadList)
{//@CODE_3123
    _orderByLoadList = orderByLoadList;
}//@CODE_3123



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
