/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MainApp.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MainApp'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1

//pour une raison inconnue, si on initialise un EnvironnementQT
//avant de charger les plugins,... le __dynamic_cast plante 
//dans les evt souris

#include <cstdlib>
#include <iostream>

using namespace std;

#ifndef UNIX
extern "C" {
  extern int SDL_main(int argc, char *argv[]);
}
int main(int argc, char *argv[])
{
     //cout<<"test2"<<endl;
 int i= SDL_main(argc,argv);
 
 //system("PAUSE");
 return i;
}
#endif

#ifdef QGL_SUPPORT
#include <qapplication.h> //QGL
#endif

#include "CookiMetier.h"

#ifdef QGL_SUPPORT
#include "EnvironnementQT.h" //QGLx
#endif

#include <iostream>
#include <stdlib.h>

#include "EnvironnementProducer.h"
#include "EnvironnementSDL.h"
#include "EnvironnementJava.h"
#include "EvtHandler.h"
#include "LoaderXML.h"
#include "BD.h"
#include "MapRW.h"
#include "MediaEvaluable.h"
//#include "yaccLex/Pile.h"

#include <osg/Notify>

#ifdef UNIX
//... specifiq includes
#else
#  include <process.h>
#endif


using namespace std;
using namespace cooki3d;


//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "MainApp.h"

int AFX_EXT_CLASS main(int argc, char *argv[]){
  //dans le cadre d'un execution separee, on recupere 
  //le signal sigsegv
  //en execution interne cela ne semble pas compatible avec la jvm 1.5.0_06-b05
  //compilee avec gcc 3.2.1-7a (J2SE release), le bug est tres violent,
  //il se produit au chargement de la librairie...
  setup_sigsegv();
  
  MainApp ma;
  return (int)ma.mainCooki( argc, argv );
}
//@END_USER2


// Static members
std::ofstream* MainApp::_cookiLogs = NULL;
std::streambuf* MainApp::_saveBufCout = NULL;
std::streambuf* MainApp::_saveBufCerr = NULL;


/*@NOTE_5088
Constructor method.
*/
MainApp::MainApp() //@INIT_5088
  :  _loaderAppli(NULL)
     , _mjcDefault(NULL)
     , _javaEnv(NULL)
     , _unitTest(false)
   
{//@CODE_5088
    ConstructorInclude();

    // Put in your own code
}//@CODE_5088


/*@NOTE_5084
Destructor method.
*/
MainApp::~MainApp()
{//@CODE_5084
    DestructorInclude();

    // Put in your own code
}//@CODE_5084


void MainApp::eraseAllFromJava()
{//@CODE_5128
  if (_javaEnv){
    
    if (_javaEnv->isStopped()){
      //2ieme passage
      //efffectue le nettoyage des autres objets C++
      CTRACEs("eraseAllFromJava")<<" pass 2"<<endl;
      
      //effacement du loader avant l'environnement
      //NOTE: BD::eraseAll() ne sera fait dans la destruction du loader
      loadEnd( true );

      //effacement de l'environnement en dernier
      delete _javaEnv;
      _javaEnv = NULL;   
      
    }
    else {
      
      //1er passage (1st pass)
      //lancement ordre de nettoyage des objets OpenGL
      //et attente du thread que l'ordre soit effecute.
      CTRACEs("eraseAllFromJava")<<" pass 1"<<endl;      
      
      _javaEnv->stop();

      CTRACEs("eraseAllFromJava")<<" pass 1.1"<<endl;      
      
    }
  }
  else {
    CERRs("eraseAllFromJava")<<"_javaEnv was NULL !"<<endl;
  }
  
}//@CODE_5128


bool MainApp::loadBegin(char* fichierXml, char* fluxXml)
{//@CODE_5090

  if (fichierXml || fluxXml){

    //attention il faut un pointeur
    //sinon le TimeMod ou une autre classe peut rester en attente de la fin du 
    //chargement alors quil a deja eu lieu (la variable static de classe 
    ///chargementFini est reinitialise dans le destructeur)
    _loaderAppli = new cooki3d::LoaderXML(this);
    
    if (fichierXml){
      CTRACEs("loadBegin")<<"Fichier xml choisi :"<<fichierXml<<endl;          
      //chargement du fichier xml
      return ((LoaderXML*)_loaderAppli)->loadJeu(fichierXml);
    }else {
      assertC2( fluxXml, NULL );
      
      //chargement du flux xml
      std::string s(fluxXml);
      CTRACEs("loadBegin")<<"FluxXml choisi : "
		     <<s.substr(0,s.length()/10)
		     <<"..."<<endl;      
      return ((LoaderXML*)_loaderAppli)->loadJeuFromString(s);
    }
  }else {
    _loaderAppli = new cooki3d::LoaderGeneric(this);
    return loadByDefaultBegin();
  }
  return true;
}//@CODE_5090


bool MainApp::loadByDefaultBegin()
{//@CODE_5089
  
  CERRs("loadByDefaultBegin")
    <<"Comportement de secours ...,"
    <<"chargement de MoteurJeuDefaut/libPlugin"<<endl;          
    
  _loaderAppli->setPath("./");
   
  MoteurJeuC * _mjcDefault=new MoteurJeuC(_loaderAppli->getBD());
  

#ifdef UNIX
  _mjcDefault->setLib("./MoteurJeuDefaut/libPlugin.so");   
#else
  _mjcDefault->setLib("MoteurJeuDefaut\\libPlugin.dll");
#endif
  if ( _mjcDefault->load() ){
    _loaderAppli->preInitInstances( _mjcDefault );
    _loaderAppli->postInitInstances( _mjcDefault );
  }

  _loaderAppli->setLoadFinished( true );
  
  return true;
}//@CODE_5089


void MainApp::loadEnd(bool bRealEnd)
{//@CODE_5094

  //on efface le chargeur de jeu. uniquemt a la fin reelle !!
  //car le run n'est pas forcement bloquant !!
  //   //nettoyage si l'environnement est bloquant (s'occupe du rendu)
  //   //par ex. ce n'est pas le cas pour jogl et jproducer
  
  if (bRealEnd){

    if (_loaderAppli != NULL ){
      //NOTE: BD::eraseAll() est fait dans la destruction le loader
      CTRACEs("loadEnd")<< " delete loader Appli "<<endl;
      delete _loaderAppli;
      _loaderAppli = NULL;
    }
    else  {
      CERRs("loadEnd")<< " _loaderAppli is already NULL ";
      std::string s;
      printStackTrace( s );
      CERRnext<<s<<endl;
    }

    //on efface pas le fichier car des sortie texte peuvent 
    //intervenirs dans les destructeurs...
    // if (_cookiLogs != NULL){
    //       delete _cookiLogs;
    //       _cookiLogs = NULL;
    //     }

    if (_mjcDefault != NULL){
      delete _mjcDefault;
      _mjcDefault = NULL;
    }

  }
}//@CODE_5094


void MainApp::loadInterface(EnvironnementOSG& env, bool bExecRun)
{//@CODE_5097
    
  assertC2 (_loaderAppli, NULL);
    
  if ( _loaderAppli->isLoadFinished() ) {
    
    //isRender :  le boolean render, il faut egalement que ce parametre
    //soit a true pour faire un rendu
    //Note : il peut etre a false dans le cadre d'un script par exemple.
    if ( _loaderAppli->isRender() ){
      
      //on set la scene loadee
      env.setRootNode( _loaderAppli->getRootNode() );

      //very important links
      //_loaderAppli->setMainApp( this ); => constructor
      _loaderAppli->setEnv( &env );      
      
      //checks
      assertC2( _loaderAppli->getBD(), NULL );
      assertC2( env.getLoader() == _loaderAppli, _loaderAppli->getBD() );

      //on demarre les media qui doivent etre lance (play()) au demarrage
      //si on est pas dans une optique de test d'execution
      if (!_unitTest){
	MediaEvaluable::playInstancesOnStart(_loaderAppli->getBD());
      }
      
      
      //bExecRun : ce booleen decide si on fait le run ou pas
      //Note : le run n'est pas forcement bloquant      
      if ( bExecRun  ){
	
	//ajout d'une boucle de gestion personnalisee des evenements
	EvtHandler * eh=new EvtHandler(&env);
	env.pushFront(eh);
	
	//lancer l'environnement
	env.run( env.getRootNode().get() );
	
	//finalise si l'environnement est bloquant, 
	//cela signifie qu'il est sorti du rendu en sortant du run.
	//TODO: voir si effacer _loaderAppli legerement avant que 
	//l'environnemnt se detruise a des repercutions fatales
	//sur les objets utilisant une reference a ce LoaderGeneric...
	loadEnd( env.isHaveBlockingRunMethod()  );
      }
    }
    
    
  } else {
    CERRs("loadInterface")
      <<" Loader XML has returned errors, because load is not finished"
      <<" the envirnonnement interface has been stopped !"<<endl;
  }

}//@CODE_5097


long MainApp::mainCooki(int argc, char** argv, bool bCookiLogsRedirect)
{//@CODE_5116

  try {
        
    char * choixEnv=NULL;    
    char * fichierXml=NULL;
    char * fluxXml=NULL;
    char * aide[] = 
      {"help: ",
       "-h ",
       "-env {sdl, producer, qgl (if supported) }",
       "-xml {fichier xml} (if suppported)",
       "-debugOsg { ALWAYS, FATAL, WARN, NOTICE, INFO,"
       " DEBUG_INFO, INFO, DEBUG_INFO, DEBUG_FP }",
       "-debugCooki { false, true }",
       "-fluxXml {<jeu>...</jeu>}",
       "-redirectLogs { false, true }",
       "-unitTest { false, true } (if supported)",
       "endTab"}; 
  
  
    for(int i = 1; i< argc; i=i+2){
    
      if (strcmp(argv[i],"-unitTest")==0){ //consiste a tester une execution
	//sur quelques secondes pour palier a d'eventuelles segfault
	//qui pourraient fermer une application importante de l'utilisateur 
	//comme le navigator dans le cadre des applets...
	assertC2(i+1 <argc,NULL);
	_unitTest = strcmp(argv[i+1],"true")==0;	
      }
      else if (strcmp(argv[i],"-redirectLogs")==0){ //redirection des logs
	assertC2(i+1 <argc,NULL);
	bCookiLogsRedirect = strcmp(argv[i+1],"true")==0;	
      }
      else if (strcmp(argv[i],"-debugCooki")==0){ //niveau de debug cooki
	assertC2(i+1 <argc,NULL);
	cooki3d::activationCTRACE = strcmp(argv[i+1],"true")==0;	
      }
      else if ( strcmp(argv[i],"-env")==0){//choix de l'environnement
	assertC2(i+1 <argc,NULL);
	choixEnv = argv[i+1];            
      }
      else if ( strcmp(argv[i],"-xml")==0){//chargement d'un fichier xml
	assertC2(i+1 <argc,NULL);
	fichierXml = argv[i+1];      
      }
      else if ( strcmp(argv[i],"-fluxXml")==0){//chargement d'un flux xml
	assertC2(i+1 <argc,NULL);
	fluxXml = argv[i+1];
      }
      else if ( strcmp(argv[i],"-h")==0 ){//aide 
	int j=0;
	while (strcmp(aide[j],"endTab") !=0){
	  cout<<aide[j]<<endl;
	  j++;
	}
	return 0;
      
      }
      else if (strcmp(argv[i],"-debugOsg")==0){ //niveau de debug osg
	assertC2(i+1 <argc,NULL);
	if (strcmp(argv[i+1],"DEBUG_FP")==0){ //en 1er car la + utilisee
	  osg::setNotifyLevel(osg::DEBUG_FP);
	}
	else if (strcmp(argv[i+1],"ALWAYS")==0){
	  osg::setNotifyLevel(osg::ALWAYS);
	}
	else if (strcmp(argv[i+1],"FATAL")==0){
	  osg::setNotifyLevel(osg::FATAL);
	}
	else if (strcmp(argv[i+1],"WARN")==0){
	  osg::setNotifyLevel(osg::WARN);
	}
	else if (strcmp(argv[i+1],"ALWAYS")==0){
	  osg::setNotifyLevel(osg::ALWAYS);
	}
	else if (strcmp(argv[i+1],"NOTICE")==0){
	  osg::setNotifyLevel(osg::NOTICE);
	}
	else if (strcmp(argv[i+1],"INFO")==0){
	  osg::setNotifyLevel(osg::INFO);
	}
	else if (strcmp(argv[i+1],"DEBUG_INFO")==0){
	  osg::setNotifyLevel(osg::DEBUG_INFO);
	}
	else if (strcmp(argv[i+1],"INFO")==0){
	  osg::setNotifyLevel(osg::INFO);
	}
	else if (strcmp(argv[i+1],"DEBUG_INFO")==0){
	  osg::setNotifyLevel(osg::DEBUG_INFO);
	}      
	else {
	  cerr<<"Valeur '"<<argv[i+1]<<"' pour debugOsg inconnue !! "
	      <<endl<<" Utilisez -h pour l'aide"<<endl;
	}
      
      } 
      else {//option inconnue
	cerr<<"Option ."<<argv[i]<<". inconnue !! "<<endl<<" Utilisez -h pour l'aide"<<endl;
	return -1;
      
      }
    }

    if (_unitTest){
      CINFOs<<"=> This execution is a unitTest, "
	    <<"( dont read this log if the window has started )"<<endl;
    }

    //redirection des logs 
    if ( bCookiLogsRedirect ){
      pid_t id = getpid();
      std::string sId;
      MapRW rw;
      rw.writeToStr( id,sId );
      if (_cookiLogs == NULL){
#     ifdef UNIX
	std::string s( "/tmp/cookiLogs"+sId+".txt" );
#     else
	char * sys = getenv("SYSTEMROOT");
	std::string s;
	if (sys == NULL){
	  s = "C:\\Windows";
	}
	else {
	  s = std::string( sys );
	}
	s = s+ "\\TEMP\\cookiLogs"+sId+".txt";
#     endif
	_cookiLogs = new std::ofstream( s.c_str() , fstream::out );
      }

      _saveBufCout = cout.rdbuf();
      _saveBufCerr = cout.rdbuf();
      std::cout.rdbuf( _cookiLogs->rdbuf() );  
      std::cerr.rdbuf( _cookiLogs->rdbuf() );  

      cout<<endl<<"##### Logs begin #####"<<endl;

    } else {
      if ( _saveBufCout ){
	std::cout.rdbuf( _saveBufCout );	
      }
      if ( _saveBufCerr ){
	std::cerr.rdbuf( _saveBufCerr );	
      }
    }

    if (! loadBegin( fichierXml, fluxXml ) ){
      CERRs("mainCooki") <<"Load has failed, quit main function."<<endl;
      loadEnd();  
      return -1;
    }
    else {
      
    }

    //bEnvBloquant = true;
    int result=0;
    assertC2( _loaderAppli, NULL );

    //si un environnement a ete intancie par un plugin exterieur...
    // if (EnvironnementOSG::instance( true ) != NULL){
      
//       //ne pas avoir cela serai simplement incoherent,
//       //si l'on instancie un environnement, c'est pour faire un rendu!
//       assertC(_loaderAppli->isRender()); 

//       //on lance l'interface preinstancie par l'utilisateur.
//       loadInterface(*EnvironnementOSG::instance());
      
//     }
    //non permis 
    //assertC( BD::getThreadInstance()->getEnv() == NULL );
  

    //si l'on souhaite lancer un rendu... 
    //(la plupart du temps sauf pour les scripts de l'editeur...)
    /*else*/ 
    if ( _loaderAppli->isRender() ){

      if (choixEnv == NULL){
	CTRACEs("mainCooki")<<"Par d'environnement "
		       <<"=> comportement par defaut!!"<<endl;
	/// COMPORTEMENT PAR DEFAUT EN DUR///
	//mainEnvPRODUCER(argc,argv,fichierXml);           
      
#   ifdef QGL_SUPPORT     
	mainEnvQT(argc,argv);       
#   else 
	mainEnvSDL(argc,argv);
#   endif
      
      } else {
      
	CTRACEs("mainCooki")<<"Environnement choisi :"<<choixEnv<<endl;
      
	if (strcmp(choixEnv,"sdl")==0){
	  result = mainEnvSDL(argc,argv); 
	}
	else if (strcmp(choixEnv,"producer")==0){      
	  result = mainEnvProducer(argc,argv);
	}
#  ifdef QGL_SUPPORT
	else if (strcmp(choixEnv,"qgl") == 0){
	  result = mainEnvQT(argc,argv);
	}
#  endif
	else if (strcmp(choixEnv,"jogl") == 0){
	  //pas de destruction demandee (surtout pas dans ce cas)
	  //ca mainJavaToJavaEnvJOGL est juste 
	  //une initialisation non bloquante de l'environnement
	  //bEnvBloquant=false;
	  result = mainEnvJavaJogl(argc,argv);
	
	
	}
	else if (strcmp(choixEnv,"jproducer") == 0){
	  //pas de destruction demandee (surtout pas dans ce cas)
	  //ca mainEditeurJavaJavaProducer est juste 
	  //une initialisation non bloquante de l'environnement
	  //bEnvBloquant=false;
	  result = mainEnvJavaProducer(argc,argv);
	
	}
	else {       
	  CERRs("mainCooki")<<"erreur syntaxe incorrexte,"
		       <<" environnement \""<<choixEnv
		       <<"\" non supporte"<<endl;     
	}
      }       
    } else {
      //on oublie pas de terminer le chargement XML si aucun
      //environnement de rendu n'a ete lance
      loadEnd();
    }
    
    return result;
  
  }
  catch(EnvironnementInstanceException ){
    CERRs("mainCooki") << "Exception EnvironnementInstanceException caught !! "
		       <<  std::endl;
    loadEnd();  
  }
  catch(AssertException e){
    CERRs("mainCooki") << "Exception AssertException caught !! "
		       <<  std::endl;
    CERRnext <<e.getStackTrace()<<endl;
    //BD::stopIfStarted(result);
    loadEnd();  
  }
  catch (LoaderXmlException){
    CERRs("mainCooki") << "Exception LoaderXmlException caught !! "
		       <<  std::endl;
    //BD::stopIfStarted(result);
    loadEnd(); 
  } 
  catch( ... ) {
    CERRs("mainCooki")  << "Exception caught !! "<<  std::endl;
    //BD::stopIfStarted(result);
    loadEnd();  
  }
  return -1;
}//@CODE_5116


long MainApp::mainEnvJavaJogl(int argc, char** argv)
{//@CODE_5109
  CTRACEs("mainEnvJavaJogl")
    <<"-------mainEditeurJavaJava--(JOGL)-------"<<endl;
  
  //  assertCMessageCode(_javaEnv == NULL,
  // 		     "L'environnement est sans doute en attente d'arret",
  // 		     return -1);
  
  //ici on cree un pointeur car mainJavaToJavaEnvJOGL est juste 
  //une initialisation non bloquante de l'environnement
  //l'environnement et le chargeur xml devra atre detruit
  //dans eraseAllFromJava grace a lastEnvJavaJogl
  EnvironnementJava * ej =new EnvironnementJava(argc,argv,_loaderAppli);
  _javaEnv = ej;

  //pas de destruction demandee (surtout pas dans ce cas)
  //ca mainEditeurJavaJavaProducer est juste 
  //une initialisation non bloquante de l'environnement (false)
  
  //non bloquant
  // _javaEnv->setHaveBlockingRun( false );//non necessaire..
  assertC2( !(_javaEnv->isHaveBlockingRunMethod( )),
	    NULL ); //verif
  loadInterface( *_javaEnv );
      
  
  CINFOs<<"return ("<<_javaEnv->getLoader()->getBD()
	<<") BDref="<<long(_javaEnv->getLoader()->getBD())
	<<endl;
  return long(_javaEnv->getLoader()->getBD());

}//@CODE_5109


long MainApp::mainEnvJavaProducer(int argc, char** argv)
{//@CODE_5112
     
  if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO|SDL_INIT_TIMER) < 0 ) {
    fprintf(stderr, "Impossible d'initialiser SDL: %s\n", SDL_GetError());
    return -1;
  }
  atexit(SDL_Quit);
  
  //cout<<"---------------------------------------"<<endl;
  
  _javaEnv = new EnvironnementProducer(argc,argv,_loaderAppli);
  
  //pas de destruction demandee (surtout pas dans ce cas)
  //ca mainEditeurJavaJavaProducer est juste 
  //une initialisation non bloquante de l'environnement ( false )
  //pas de run demande, sera fait dans initProducerRenderSurface
  //une fois l'environnement reellement cree ( false )
  
  //non bloquant
  _javaEnv->setHaveBlockingRunMethod( false );
  loadInterface(*_javaEnv,/*false,*/false);

  
  //sinon le TimeMod ou une autre classe va ete en attente de la fin du 
  //chargement alors quil a deja eu lieu (la variable static de classe 
  ///chargementFini est reinitialise dans le destructeur)
  ///*dernierChargeurXML*/_loaderAppli->loadJeuFromString(string(argv[1]));

  //pas de run sur env a faire,
  //le constructeur different de EnvironnementProducer previent
  //que le "drawSurface" est separe
  
  CINFOs<<"return ("<<_javaEnv->getLoader()->getBD()
	<<") BDref="<<long(_javaEnv->getLoader()->getBD())
	<<endl;
  return long(_javaEnv->getLoader()->getBD());

}//@CODE_5112


long MainApp::mainEnvProducer(int argc, char** argv)
{//@CODE_5106

  if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO|SDL_INIT_TIMER) < 0 ) {
    fprintf(stderr, "Impossible d'initialiser SDL: %s\n", SDL_GetError());
    return -1;
  }
  atexit(SDL_Quit);
  
  CTRACEs("mainEnvPRODUCER")<<"--- main Env PRODUCER ---"<<endl;
  
  EnvironnementProducer env(argc,argv,_loaderAppli);
  
  //bloquant (par defaut)
  loadInterface(env);
    
  return 0;
}//@CODE_5106


long MainApp::mainEnvQT(int argc, char** argv)
{//@CODE_5100

#ifdef QGL_SUPPORT
  {
 
    // Read command lines arguments.
    QApplication application(argc,argv);
    
    CTRACEs("mainEnvQT")<<"Environnement QT"<<endl;
    
    EnvironnementQT env(argc,argv,_loaderAppli);
    
    //le run de EnvironnementQT est non bloquant
    //env.setHaveBlockingRun( false ); non necessaire en principe
    assertC2( !env.isHaveBlockingRunMethod( ) , NULL ); //verif
    loadInterface( env ); 
    
    assertC2( env.getQGLWidget() , NULL);
    
#if QT_VERSION < 0x040000
    // Set the viewer as the application main widget.
    application.setMainWidget(env.getQGLWidget());
#endif
    
    // Run main loop. (bloquant)
    bool result = application.exec();
    
    //on finalise, comme pour un environnement bloquant apres le exec()
    loadEnd( true ); 
    
    return result;
  }
#else 
  {
    return -1;
  }
#endif
   
}//@CODE_5100


long MainApp::mainEnvSDL(int argc, char** argv)
{//@CODE_5103

  CTRACEs("mainEnvSDL")<<"main Env SDL"<<endl; 
  
  EnvironnementSDL env(argc,argv,_loaderAppli);
  
  //bloquant (par defaut)
  loadInterface(env);

  return 0;
}//@CODE_5103


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_5085
Method which must be called first in a constructor.
*/
void MainApp::ConstructorInclude()
{
}


/*@NOTE_5086
Method which must be called first in a destructor.
*/
void MainApp::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
