/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MainApp.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MainApp'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MAINAPP_H
#define _MAINAPP_H

//@START_USER1
#include "CookiMetier.h"



namespace cooki3d {
  class MoteurJeuC;
  class LoaderGeneric;
  class EnvironnementOSG;
//@END_USER1


/*@NOTE_5083
class...
*/

class MainApp
{

//@START_USER2
    bool _bUnitTest;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    LoaderGeneric* _loaderAppli;
    static std::ofstream* _cookiLogs;
    MoteurJeuC* _mjcDefault;
    EnvironnementOSG* _javaEnv;
    static std::streambuf* _saveBufCout;
    static std::streambuf* _saveBufCerr;
    bool _unitTest;

//
// Non-Grouped Methods
//

protected:
    bool loadBegin(char* fichierXml, char* fluxXml);
    bool loadByDefaultBegin();
    void loadEnd(bool bRealEnd = true);
    void loadInterface(EnvironnementOSG& env, bool bExecRun = true);
    long mainEnvJavaJogl(int argc, char** argv);
    long mainEnvJavaProducer(int argc, char** argv);
    long mainEnvProducer(int argc, char** argv);
    long mainEnvQT(int argc, char** argv);
    long mainEnvSDL(int argc, char** argv);

public:
    MainApp();
    virtual ~MainApp();
    void eraseAllFromJava();
    long mainCooki(int argc, char** argv, bool bCookiLogsRedirect = false);
    bool isUnitTest() const;
};

#endif


#ifdef CB_INLINES
#ifndef _MAINAPP_H_INLINES
#define _MAINAPP_H_INLINES

/*@NOTE_5255
Returns the value of member '_unitTest'.
*/
inline bool MainApp::isUnitTest() const
{//@CODE_5255
    return _unitTest;
}//@CODE_5255



//@START_USER3
} //end of namespace cooki3d

//@END_USER3

#endif
#endif
