/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MapRW.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MapRW'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "MapRW.h"

#include <map>
#include <sstream>
using namespace std;
namespace cooki3d{
//@END_USER2




/*@NOTE_121
Constructor method.
*/
MapRW::MapRW() //@INIT_121
{//@CODE_121
    ConstructorInclude();

    // Put in your own code
    

        
}//@CODE_121


/*@NOTE_117
Destructor method.
*/
MapRW::~MapRW()
{//@CODE_117
    DestructorInclude();

    // Put in your own code
}//@CODE_117


void MapRW::convertDosEOL(std::string& s)
{//@CODE_223
  //mode DOS WINDOWS end of line
  if (s.length()>0 && int(s[s.length()-1]) == 13){ 
    s=s.substr(0,s.length()-1);
  }

  //effacement des espaces inutiles et sources d'erreurs
  
  int i = s.length()-1;
  while (i>=0 && (s[i]==' ' || s[i]=='\t')) i--;
  //assertC(i);
  if (i>0) s=s.substr(0,i+1);

}//@CODE_223


int MapRW::extractFirstInt(std::string& s)
{//@CODE_200
  int value;
  
  std::string par=extractFirstStr(s);
  value =atoi(par.c_str());    
  
  return value;
}//@CODE_200


std::string MapRW::extractFirstStr(std::string& s)
{//@CODE_198
  std::string value;
  
  //cout<<"taille "<<s.length()<<"s="<<s<<endl;
  
  int num=s.find(" ");
  //cout<<"num="<<num<<endl;
  if (num>0 && num<int(s.length())) {
    value = s.substr(0,num);
    s = s.substr(num+1,s.length());
  }
  else if (s.length()>0) {
    //cout<<s[s.length()-2]<<"->"<<int(s[s.length()-2])<<endl;
    //cout<<s[s.length()-1]<<"->"<<int(s[s.length()-1])<<endl;
    
    value=s;
    s="";
  }
  else {
    CERRs( "MapRW::extractFirstStr" )<<" parameter 's'is empty!"<<endl;
    return "";
  }
  
  return value;
}//@CODE_198


std::string MapRW::getExtension(std::string nomFic)
{//@CODE_261
        
    int i= nomFic.length()-1;
    if (i<0) {
        CERR(this,"getExtension")<<"failed on nomFic ="<<nomFic<<endl;
	return "";
    }
    
    while (nomFic[i] != '.' || i>0) i--;
    
    if (i==0){
      CERR(this,"getExtension")<<"failed on nomFic ="<<nomFic<<endl;
      return "";
    }
    
    return nomFic.substr(i+1,nomFic.length());
}//@CODE_261


void MapRW::loadMapStrStr(std::string ficname, mapStrStr& m)
{//@CODE_125
  
  std::ifstream file(ficname.c_str());
  if (file.fail()){
    CERR(this,"loadMapStrStr")<<"fail to open file "<<ficname<<endl;
    return;
  }
  
  std::string buf= "";
  
  while (file >> buf) {
    if (buf[0] != '#'){ //pour lees commentaires
      getline(file, m[buf]);
      m[buf].erase(0,1); //effacement de l'espace
      convertDosEOL(m[buf]);
    }
    else getline(file, buf); // elimnation fin de commentaire
  }
  
  file.close();
}//@CODE_125


void MapRW::loadTabStrStr(std::string ficname, tabStrStr& tab, char separ)
{//@CODE_251
  std::ifstream file(ficname.c_str());
  if (file.fail()){
    CERR(this,"loadMapStrStr")<<"fail to open file "<<ficname<<endl;
    return;
  }
  
  Ligne buf;
  buf.nom= "";
  buf.champs= "";
  
  std::string poubelle;
  
  char buffer[500];

  /*CTRACE(this,"loadTabStrStr")<<" slash v = "<<int('\v')<<endl;
  CTRACE(this,"loadTabStrStr")<<" slash n = "<<int('\n')<<endl;
  CTRACE(this,"loadTabStrStr")<<" # = "<<int('#')<<endl;
  CTRACE(this,"loadTabStrStr")<<" ' ' = "<<int(' ')<<endl;
  CTRACE(this,"loadTabStrStr")<<" tabulation = "<<int('\t')<<endl;
  CTRACE(this,"loadTabStrStr")<<" slash f = "<<int('\f')<<endl;*/
  

  while (!file.eof()){
    //CTRACE(this,"loadTabStrStr")<<" file.peek() = "<<file.peek()<<endl; 

    if (file.peek() == '#' || file.peek()==' ' || file.peek() == '\n' || file.peek() == '\r') {
      getline(file,poubelle);
      //CTRACE(this,"loadTabStrStr")<<" var poubelle = "<<poubelle<<endl;
    }    
    else {
      if (file.getline(buffer,500,separ)){
	//CTRACE(this,"loadTabStrStr")<<" var buffer ->buf.nom = "<<buffer<<endl;
	buf.nom=string(buffer);
	//cout<<"buf.nom="<<buf.nom<<endl;
	getline(file,buf.champs);
	convertDosEOL(buf.champs);
	//cout<<"valeur="<<buf.champs<<endl;
	tab.push_back(buf);
      }
    }
    
    
  }

  file.close();

}//@CODE_251


void MapRW::loadTabStrStr(std::string ficname, tabStrStr& tab)
{//@CODE_175
  std::ifstream file(ficname.c_str());
  if (file.fail()){
    CERR(this,"loadMapStrStr")<<"fail to open file "<<ficname<<endl;
    return;
  }

  Ligne buf;
  buf.nom= "";
  buf.champs= "";
   
  while (file >> buf.nom) {
    if (buf.nom[0]!='#'){
      getline(file, buf.champs);
      buf.champs.erase(0,1); //effacement de l'espace
      convertDosEOL(buf.champs);
      tab.push_back(buf);
    }
    else getline(file, buf.nom); // elimnation fin de commentaire
    
  }
  
  file.close();
}//@CODE_175


void MapRW::split(std::string s, std::string& p, std::string& f,
                  std::string& ext)
{//@CODE_228
    int i=s.length()-1;
    while (i>0 && s[i] != '.') i--;
    
    if ( i==0){
      CERR(this,"split")<<"fail to split "<<s<<endl;
      return;
    }

    int j=i;
    //cout<<"j="<<j<<"f="<<f<<endl;
    while (i>0 && s[i] != '\\'  && s[i] != '/') i--;
    
    if (i>0) {
        p = s.substr(0,i+1);
        
	f = s.substr(i+1,j-(i+1));
	
	//cout<<"s.substr(i+1,j)="<<s.substr(i+1,j)<<endl;
	//cout<<"s.substr(5,10)="<<s.substr(5,10)<<endl;

        ext = s.substr(j,s.length());        
	//cout<<"s.length()="<<s.length()<<"i="<<i<<", j="<<j<<", p="<<p<<", f="<<f<<", ext="<<ext<<endl;
    }
    else {
        p="";
        f=s.substr(0,j);
        ext = s.substr(j,s.length());        
    }
}//@CODE_228


void MapRW::writeToStr(int item, std::string& s)
{//@CODE_214
    ostringstream os;
    os<<s<<item;
    s=os.str();
}//@CODE_214


void MapRW::writeToStr(double item, std::string& s)
{//@CODE_217
    ostringstream os;
    os<<s<<item;
    s=os.str();
}//@CODE_217


void MapRW::writeToStr(float item, std::string& s)
{//@CODE_220
    ostringstream os;
    os<<s<<item;
    s=os.str();
}//@CODE_220


void MapRW::writeToStr(unsigned int item, std::string& s)
{//@CODE_3313
    ostringstream os;
    os<<s<<item;
    s=os.str();
}//@CODE_3313


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_118
Method which must be called first in a constructor.
*/
void MapRW::ConstructorInclude()
{
}


/*@NOTE_119
Method which must be called first in a destructor.
*/
void MapRW::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d

/*
  Extraction d'une sous-cha?ne : string subst ( size_type pos, size_type n )
  string s1("Salut") ;
  string s2 ;
  s2 = s1.substr( 1, 3 ) ;
  La variable s2 contient "alu". Le premier indice (pos) indique le d?but de la sous-cha?ne et le deuxi?me (n) indique le nombre de caract?re ? extraire. Attention ici le premier caract?re a pour indice 0.
  Une autre mani?re de proc?der ? l'extraction est de le r?aliser ? l'initialisation de la varaible s2.
  string s1("Salut") ;
  string s2( s1, 1, 3 ) ; // s2 contient "alu"
  
  Insertion d'une cha?ne : string& insert ( size_type pos, const string& str)
  string s ("Bour");
  s.insert(1,"onj");
  La variable s contient maintenant "Bonjour". Le deuxi?me param?tre est la cha?ne ? ins?rer, elle peut ?tre constante (comme dans l'exemple) ou de type string. Le premier param

*/
