/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MapRegister.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MapRegister<Item>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MAPREGISTER_H
#define _MAPREGISTER_H

//@START_USER1
#include "Register.h"
//@END_USER1


/*@NOTE_5049
class...
*/
template< typename Item> 
class MapRegister
{

//@START_USER2
  typedef std::map<BD* ,Register<Item>,less<BD* > > mapBDRegister;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    mapBDRegister _mapBDRegister;

//
// Non-Grouped Methods
//

public:
    MapRegister();
    virtual ~MapRegister();
    Register<Item>& getRegister(BD* pBD);
    void removeRegister(BD* pBD);
};

#endif


#ifdef CB_INLINES
#ifndef _MAPREGISTER_H_INLINES
#define _MAPREGISTER_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_5051
Method which must be called first in a constructor.
*/
template< typename Item> 
void MapRegister<Item>::ConstructorInclude()
{
}



/*@NOTE_5052
Method which must be called first in a destructor.
*/
template< typename Item> 
void MapRegister<Item>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_5054
Constructor method.
*/
template< typename Item> 
MapRegister<Item>::MapRegister() //@INIT_5054
    : _mapBDRegister()
{//@CODE_5054
    ConstructorInclude();

    // Put in your own code
}//@CODE_5054



/*@NOTE_5050
Destructor method.
*/
template< typename Item> 
MapRegister<Item>::~MapRegister()
{//@CODE_5050
    DestructorInclude();

    // Put in your own code
}//@CODE_5050



template< typename Item> 
Register<Item>& MapRegister<Item>::getRegister(BD* pBD)
{//@CODE_5055
  if ( _mapBDRegister.find( pBD ) == _mapBDRegister.end() ){
    _mapBDRegister[pBD]=Register<Item>(pBD);
  }

  return _mapBDRegister[pBD];
}//@CODE_5055



template< typename Item> 
void MapRegister<Item>::removeRegister(BD* pBD)
{//@CODE_5252
  _mapBDRegister.erase( pBD );
}//@CODE_5252



//@START_USER3
//@END_USER3

#endif
#endif
