/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MapUserRegister.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MapUserRegister<Item>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
* November 14, 2006 00:37 bg
*     Updated return type of method 'getRegister'
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MAPUSERREGISTER_H
#define _MAPUSERREGISTER_H

//@START_USER1
#include "Register.h"
//@END_USER1


/*@NOTE_5258
class...
*/
template<typename Item>
class MapUserRegister
{

//@START_USER2
  typedef std::map<BD* ,Item,less<BD* > > mapBDUserType;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    mapBDUserType _mapBDUserType;

//
// Non-Grouped Methods
//

public:
    MapUserRegister();
    virtual ~MapUserRegister();
    Item& getRegister(BD* pBD);
    void removeRegister(BD* pBD);
};

#endif


#ifdef CB_INLINES
#ifndef _MAPUSERREGISTER_H_INLINES
#define _MAPUSERREGISTER_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_5260
Method which must be called first in a constructor.
*/
template<typename Item>
void MapUserRegister<Item>::ConstructorInclude()
{
}



/*@NOTE_5261
Method which must be called first in a destructor.
*/
template<typename Item>
void MapUserRegister<Item>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_5264
Constructor method.
*/
template<typename Item>
MapUserRegister<Item>::MapUserRegister() //@INIT_5264
    : _mapBDUserType()
{//@CODE_5264
    ConstructorInclude();

    // Put in your own code
}//@CODE_5264



/*@NOTE_5259
Destructor method.
*/
template<typename Item>
MapUserRegister<Item>::~MapUserRegister()
{//@CODE_5259
    DestructorInclude();

    // Put in your own code
}//@CODE_5259



template<typename Item>
Item& MapUserRegister<Item>::getRegister(BD* pBD)
{//@CODE_5265
  if ( _mapBDUserType.find( pBD ) == _mapBDUserType.end() ){
    _mapBDUserType[pBD]= Item();
  }

  return _mapBDUserType[pBD];
}//@CODE_5265



template<typename Item>
void MapUserRegister<Item>::removeRegister(BD* pBD)
{//@CODE_5267
  _mapBDUserType.erase( pBD );
}//@CODE_5267



//@START_USER3
//@END_USER3

#endif
#endif
