/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MediaEvaluable.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MediaEvaluable'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MEDIAEVALUABLE_H
#define _MEDIAEVALUABLE_H

//@START_USER1
#include "Media.h"
#include "Evaluable.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_1282
classe ...
*/

class AFX_EXT_CLASS MediaEvaluable
    : public Evaluable
    , public Media
{

//@START_USER2
  public :
    typedef map<string,MediaEvaluable*,less<string > > mapStrMediaEval;

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    bool _playOnStart;

//
// Non-Grouped Methods
//

public:
    MediaEvaluable(BD* pBD);
    virtual ~MediaEvaluable();
    virtual double eval(std::string methode, double args[10], int nbParam);
    virtual double getDuration() = 0;
    virtual double getPosition() = 0;
    virtual bool isPause() = 0;
    virtual bool isPlay() = 0;
    virtual void pause() = 0;
    virtual void play() = 0;
    static void playInstancesOnStart(BD* pBD);
    virtual void setPosition(double sec) = 0;
    virtual void stop() = 0;
    bool getPlayOnStart() const;
    void setPlayOnStart(bool playOnStart);
};

#endif


#ifdef CB_INLINES
#ifndef _MEDIAEVALUABLE_H_INLINES
#define _MEDIAEVALUABLE_H_INLINES

/*@NOTE_1369
Returns the value of member '_playOnStart'.
*/
inline bool MediaEvaluable::getPlayOnStart() const
{//@CODE_1369
    return _playOnStart;
}//@CODE_1369



/*@NOTE_1370
Set the value of member '_playOnStart' to 'playOnStart'.
*/
inline void MediaEvaluable::setPlayOnStart(bool playOnStart)
{//@CODE_1370
    _playOnStart = playOnStart;
}//@CODE_1370



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
