/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Methode_0arg.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Methode_0arg<TClass>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _METHODE_0ARG_H
#define _METHODE_0ARG_H

//@START_USER1
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_546
class ...
*/
template<class TClass>
class Methode_0arg
    : public Command
{

//@START_USER2
public:

typedef void (TClass::* PtrMethode)(void);

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    PtrMethode _methode;
    TClass* _obj;

//
// Non-Grouped Methods
//

public:
    Methode_0arg(BD* pBD, std::string name, PtrMethode methode, TClass* obj);
    virtual ~Methode_0arg();
    virtual void exec();
};

#endif


#ifdef CB_INLINES
#ifndef _METHODE_0ARG_H_INLINES
#define _METHODE_0ARG_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_548
Method which must be called first in a constructor.
*/
template<class TClass>
void Methode_0arg<TClass>::ConstructorInclude()
{
}



/*@NOTE_549
Method which must be called first in a destructor.
*/
template<class TClass>
void Methode_0arg<TClass>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_556
Constructor method.
*/
template<class TClass>
inline Methode_0arg<TClass>::Methode_0arg(BD* pBD, std::string name,
                                          PtrMethode methode,
                                          TClass* obj) //@INIT_556
    : Command(pBD)
    , _methode(methode)
    , _obj(obj)
{//@CODE_556
    ConstructorInclude();

    setName( name );
}//@CODE_556



/*@NOTE_547
Destructor method.
*/
template<class TClass>
inline Methode_0arg<TClass>::~Methode_0arg()
{//@CODE_547
    DestructorInclude();

    // Put in your own code
}//@CODE_547



template<class TClass>
void Methode_0arg<TClass>::exec()
{//@CODE_559
  (_obj->*_methode)();
}//@CODE_559



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
