/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Methode_1arg.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Methode_1arg<TClass,Arg1>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _METHODE_1ARG_H
#define _METHODE_1ARG_H

//@START_USER1
#include "Command.h"

//NOTE : Le résultat de la méthode doit impérativement
//etre void, les arguments sans références.
namespace cooki3d{
//@END_USER1


/*@NOTE_560
class ...
*/
template<class TClass,class Arg1>
class Methode_1arg
    : public Command
{

//@START_USER2
public:

typedef void (TClass::* PtrMethode)(Arg1);

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    PtrMethode _methode;
    TClass* _obj;
    Arg1 _arg1;

//
// Non-Grouped Methods
//

public:
    Methode_1arg(BD* pBD, std::string name, PtrMethode methode, TClass* obj);
    virtual ~Methode_1arg();
    virtual void exec();
    virtual void pSetArg1(void* arg1);
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
};

#endif


#ifdef CB_INLINES
#ifndef _METHODE_1ARG_H_INLINES
#define _METHODE_1ARG_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_562
Method which must be called first in a constructor.
*/
template<class TClass,class Arg1>
void Methode_1arg<TClass,Arg1>::ConstructorInclude()
{
}



/*@NOTE_563
Method which must be called first in a destructor.
*/
template<class TClass,class Arg1>
void Methode_1arg<TClass,Arg1>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_568
Constructor method.
*/
template<class TClass,class Arg1>
inline Methode_1arg<TClass,Arg1>::Methode_1arg(BD* pBD, std::string name,
                                               PtrMethode methode,
                                               TClass* obj) //@INIT_568
    : Command(pBD)
    , _methode(methode)
    , _obj(obj)
    , _arg1()
{//@CODE_568
    ConstructorInclude();

    setName( name );
}//@CODE_568



/*@NOTE_561
Destructor method.
*/
template<class TClass,class Arg1>
inline Methode_1arg<TClass,Arg1>::~Methode_1arg()
{//@CODE_561
    DestructorInclude();

    // Put in your own code
}//@CODE_561



template<class TClass,class Arg1>
void Methode_1arg<TClass,Arg1>::exec()
{//@CODE_571
  (_obj->*_methode)(_arg1);
}//@CODE_571



template<class TClass,class Arg1>
void Methode_1arg<TClass,Arg1>::pSetArg1(void* arg1)
{//@CODE_726
    setArg1( *((Arg1*)(arg1)));
}//@CODE_726



/*@NOTE_1068
Returns the value of member '_arg1'.
*/
template<class TClass,class Arg1>
inline Arg1 Methode_1arg<TClass,Arg1>::getArg1() const
{//@CODE_1068
    return _arg1;
}//@CODE_1068



/*@NOTE_1069
Set the value of member '_arg1' to 'arg1'.
*/
template<class TClass,class Arg1>
inline void Methode_1arg<TClass,Arg1>::setArg1(Arg1 arg1)
{//@CODE_1069
    _arg1 = arg1;
}//@CODE_1069



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
