/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Methode_2args.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Methode_2args<TClass,Arg1,Arg2>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _METHODE_2ARGS_H
#define _METHODE_2ARGS_H

//@START_USER1
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_573
class ...
*/
template<class TClass,class Arg1,class Arg2>
class Methode_2args
    : public Command
{

//@START_USER2
public:

typedef void (TClass::* PtrMethode)(Arg1,Arg2);

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    PtrMethode _methode;
    TClass* _obj;
    Arg1 _arg1;
    Arg2 _arg2;

//
// Non-Grouped Methods
//

public:
    Methode_2args(BD* pBD, std::string name, PtrMethode methode, TClass* obj);
    virtual ~Methode_2args();
    virtual void exec();
    virtual void pSetArg1(void* arg1);
    virtual void pSetArg2(void* arg2);
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
    Arg2 getArg2() const;
    void setArg2(Arg2 arg2);
};

#endif


#ifdef CB_INLINES
#ifndef _METHODE_2ARGS_H_INLINES
#define _METHODE_2ARGS_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_575
Method which must be called first in a constructor.
*/
template<class TClass,class Arg1,class Arg2>
void Methode_2args<TClass,Arg1,Arg2>::ConstructorInclude()
{
}



/*@NOTE_576
Method which must be called first in a destructor.
*/
template<class TClass,class Arg1,class Arg2>
void Methode_2args<TClass,Arg1,Arg2>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_582
Constructor method.
*/
template<class TClass,class Arg1,class Arg2>
inline Methode_2args<TClass,Arg1,Arg2>::Methode_2args(BD* pBD, std::string name,
                                                      PtrMethode methode,
                                                      TClass* obj) //@INIT_582
    : Command(pBD)
    , _methode(methode)
    , _obj(obj)
    , _arg1()
    , _arg2()
{//@CODE_582
    ConstructorInclude();

    setName( name );
}//@CODE_582



/*@NOTE_574
Destructor method.
*/
template<class TClass,class Arg1,class Arg2>
inline Methode_2args<TClass,Arg1,Arg2>::~Methode_2args()
{//@CODE_574
    DestructorInclude();

    // Put in your own code
}//@CODE_574



template<class TClass,class Arg1,class Arg2>
void Methode_2args<TClass,Arg1,Arg2>::exec()
{//@CODE_585
  (_obj->*_methode)(_arg1,_arg2);
}//@CODE_585



template<class TClass,class Arg1,class Arg2>
void Methode_2args<TClass,Arg1,Arg2>::pSetArg1(void* arg1)
{//@CODE_2152
    setArg1( *((Arg1*)(arg1)));
}//@CODE_2152



template<class TClass,class Arg1,class Arg2>
void Methode_2args<TClass,Arg1,Arg2>::pSetArg2(void* arg2)
{//@CODE_2154
    setArg2( *((Arg2*)(arg2)));
}//@CODE_2154



/*@NOTE_1044
Returns the value of member '_arg1'.
*/
template<class TClass,class Arg1,class Arg2>
inline Arg1 Methode_2args<TClass,Arg1,Arg2>::getArg1() const
{//@CODE_1044
    return _arg1;
}//@CODE_1044



/*@NOTE_1045
Set the value of member '_arg1' to 'arg1'.
*/
template<class TClass,class Arg1,class Arg2>
inline void Methode_2args<TClass,Arg1,Arg2>::setArg1(Arg1 arg1)
{//@CODE_1045
    _arg1 = arg1;
}//@CODE_1045



/*@NOTE_1041
Returns the value of member '_arg2'.
*/
template<class TClass,class Arg1,class Arg2>
inline Arg2 Methode_2args<TClass,Arg1,Arg2>::getArg2() const
{//@CODE_1041
    return _arg2;
}//@CODE_1041



/*@NOTE_1042
Set the value of member '_arg2' to 'arg2'.
*/
template<class TClass,class Arg1,class Arg2>
inline void Methode_2args<TClass,Arg1,Arg2>::setArg2(Arg2 arg2)
{//@CODE_1042
    _arg2 = arg2;
}//@CODE_1042



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
