/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Methode_3args.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Methode_3args<TClass,Arg1,Arg2,Arg3>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _METHODE_3ARGS_H
#define _METHODE_3ARGS_H

//@START_USER1
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_586
class ...
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
class Methode_3args
    : public Command
{

//@START_USER2
public:

typedef void (TClass::* PtrMethode)(Arg1,Arg2,Arg3);

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    PtrMethode _methode;
    TClass* _obj;
    Arg1 _arg1;
    Arg2 _arg2;
    Arg3 _arg3;

//
// Non-Grouped Methods
//

public:
    Methode_3args(BD* pBD, std::string name, PtrMethode methode, TClass* obj);
    virtual ~Methode_3args();
    virtual void exec();
    virtual void pSetArg1(void* arg1);
    virtual void pSetArg2(void* arg2);
    virtual void pSetArg3(void* arg3);
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
    Arg2 getArg2() const;
    void setArg2(Arg2 arg2);
    Arg3 getArg3() const;
    void setArg3(Arg3 arg3);
};

#endif


#ifdef CB_INLINES
#ifndef _METHODE_3ARGS_H_INLINES
#define _METHODE_3ARGS_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_588
Method which must be called first in a constructor.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
void Methode_3args<TClass,Arg1,Arg2,Arg3>::ConstructorInclude()
{
}



/*@NOTE_589
Method which must be called first in a destructor.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
void Methode_3args<TClass,Arg1,Arg2,Arg3>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_595
Constructor method.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline Methode_3args<TClass,Arg1,Arg2,Arg3>::Methode_3args(BD* pBD,
                                                           std::string name,
                                                           PtrMethode methode,
                                                           TClass* obj) //@INIT_595
    : Command(pBD)
    , _methode(methode)
    , _obj(obj)
    , _arg1()
    , _arg2()
    , _arg3()
{//@CODE_595
    ConstructorInclude();

    setName( name );
}//@CODE_595



/*@NOTE_587
Destructor method.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline Methode_3args<TClass,Arg1,Arg2,Arg3>::~Methode_3args()
{//@CODE_587
    DestructorInclude();

    // Put in your own code
}//@CODE_587



template<class TClass,class Arg1,class Arg2,class Arg3>
void Methode_3args<TClass,Arg1,Arg2,Arg3>::exec()
{//@CODE_598
  (_obj->*_methode)(_arg1,_arg2,_arg3);
}//@CODE_598



template<class TClass,class Arg1,class Arg2,class Arg3>
void Methode_3args<TClass,Arg1,Arg2,Arg3>::pSetArg1(void* arg1)
{//@CODE_2156
    setArg1( *((Arg1*)(arg1)));
}//@CODE_2156



template<class TClass,class Arg1,class Arg2,class Arg3>
void Methode_3args<TClass,Arg1,Arg2,Arg3>::pSetArg2(void* arg2)
{//@CODE_2158
    setArg2( *((Arg2*)(arg2)));
}//@CODE_2158



template<class TClass,class Arg1,class Arg2,class Arg3>
void Methode_3args<TClass,Arg1,Arg2,Arg3>::pSetArg3(void* arg3)
{//@CODE_2160
    setArg3( *((Arg3*)(arg3)));
}//@CODE_2160



/*@NOTE_1038
Returns the value of member '_arg1'.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline Arg1 Methode_3args<TClass,Arg1,Arg2,Arg3>::getArg1() const
{//@CODE_1038
    return _arg1;
}//@CODE_1038



/*@NOTE_1039
Set the value of member '_arg1' to 'arg1'.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline void Methode_3args<TClass,Arg1,Arg2,Arg3>::setArg1(Arg1 arg1)
{//@CODE_1039
    _arg1 = arg1;
}//@CODE_1039



/*@NOTE_1035
Returns the value of member '_arg2'.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline Arg2 Methode_3args<TClass,Arg1,Arg2,Arg3>::getArg2() const
{//@CODE_1035
    return _arg2;
}//@CODE_1035



/*@NOTE_1036
Set the value of member '_arg2' to 'arg2'.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline void Methode_3args<TClass,Arg1,Arg2,Arg3>::setArg2(Arg2 arg2)
{//@CODE_1036
    _arg2 = arg2;
}//@CODE_1036



/*@NOTE_1032
Returns the value of member '_arg3'.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline Arg3 Methode_3args<TClass,Arg1,Arg2,Arg3>::getArg3() const
{//@CODE_1032
    return _arg3;
}//@CODE_1032



/*@NOTE_1033
Set the value of member '_arg3' to 'arg3'.
*/
template<class TClass,class Arg1,class Arg2,class Arg3>
inline void Methode_3args<TClass,Arg1,Arg2,Arg3>::setArg3(Arg3 arg3)
{//@CODE_1033
    _arg3 = arg3;
}//@CODE_1033



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
