/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MoteurJeuC.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MoteurJeuC'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MOTEURJEUC_H
#define _MOTEURJEUC_H

//@START_USER1
#include "CookiMetier.h"

#include "Evaluable.h"
#include "LoaderGeneric.h"

namespace cooki3d{ 
//@END_USER1


/*@NOTE_930
class...
*/

class AFX_EXT_CLASS MoteurJeuC
    : public Evaluable
{

//@START_USER2
public:
  void * MoteurJeuC::loadFunction(char * foncName);
  bool load();
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    std::string _lib;
    void* _libsys;
    std::string _rep;

//
// Non-Grouped Methods
//

public:
    MoteurJeuC(BD* pBD);
    virtual ~MoteurJeuC();
    void cleanUserData(BD* pBD);
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    void postInitInstances(LoaderGeneric* loader);
    void preInitInstances(LoaderGeneric* loader);
    static Evaluable* staticCreate(BD* pBD);
    std::string getLib() const;
    void setLib(std::string lib);
    std::string getRep() const;
    void setRep(std::string rep);
};

#endif


#ifdef CB_INLINES
#ifndef _MOTEURJEUC_H_INLINES
#define _MOTEURJEUC_H_INLINES

/*@NOTE_1143
Returns the value of member '_lib'.
*/
inline std::string MoteurJeuC::getLib() const
{//@CODE_1143
    return _lib;
}//@CODE_1143



/*@NOTE_1144
Set the value of member '_lib' to 'lib'.
*/
inline void MoteurJeuC::setLib(std::string lib)
{//@CODE_1144
    _lib = lib;
}//@CODE_1144



/*@NOTE_3527
Returns the value of member '_rep'.
*/
inline std::string MoteurJeuC::getRep() const
{//@CODE_3527
    return _rep;
}//@CODE_3527



/*@NOTE_3528
Set the value of member '_rep' to 'rep'.
*/
inline void MoteurJeuC::setRep(std::string rep)
{//@CODE_3528
    _rep = rep;
}//@CODE_3528



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
