/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          NodeNameList.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'NodeNameList'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "NodeNameList.h"

namespace cooki3d{
//@END_USER2




/*@NOTE_3497
Constructor method.
*/
NodeNameList::NodeNameList() //@INIT_3497
   
    : _checkNodePathRegister()
{//@CODE_3497
    ConstructorInclude();

    // Put in your own code
}//@CODE_3497


/*@NOTE_3487
Destructor method.
*/
NodeNameList::~NodeNameList()
{//@CODE_3487
    DestructorInclude();

    // Put in your own code
}//@CODE_3487


/*@NOTE_4328
Check the integritry of the object
*/
bool NodeNameList::check()
{//@CODE_4328
  
  bool result = true;

  for ( mapStrInt::iterator it =  _checkNodePathRegister.begin();
	it != _checkNodePathRegister.end() ;
	it ++ ){
    
    if ( it->second == 0){
      CWARN(this, "check")<<"NodePath "<<it->first
			  <<" has no match"<<endl;
      result = false;
    }
    
  }
  
  return result;
}//@CODE_4328


bool NodeNameList::checkAddPotentialZone(std::string nom)
{//@CODE_4322
  
  if ( findZone( nom ) ){
    _checkNodePathRegister[_lastZoneFound]=
      _checkNodePathRegister[_lastZoneFound]+1;
  }

  return false;
}//@CODE_4322


bool NodeNameList::findZone(std::string nom)
{//@CODE_3495
  
  std::vector<std::string>::iterator it = (*this).begin();
  unsigned int len=0;
  while (it !=(*this).end()) {
    
    //Cas d'une egalite
    //Cas de l'evt vide @ => passe comme une egalite
    if (*it == nom) {
      CTRACEs("NodeNameList::findZone")<<" succes (nom="<<nom<<")"<<endl;
      _lastZoneFound = *it;
      return true;
    }
    else {  
      
      len = (*it).length();      
            
      //Cas d'une completion:
      //par exemple : test sur chaine du type select* 
      //=>donne tout ce qui commence par select
      //par exemple : test sur chaine du type * 
      //=>donne tout les evt sans exception      
      if ( (nom.length()>=len-1) && ((*it)[ len -1 ]=='*')
	   && ((*it).substr(0,len -1)==nom.substr(0,len -1))   ){
	CTRACEs("EvtMouse::findZone")<<
	  " succes evt completion (nom="<<nom<<")"<<endl;
	_lastZoneFound = *it;
	return true;                        
      }
      
    }   
    it++;
  }
  CTRACEs("NodeNameList::findZone")<<" echec (nom="<<nom<<")"<<endl;
  return false;
}//@CODE_3495


bool NodeNameList::loadXML(const xmlpp::Node* node)
{//@CODE_3499

    
  string debut,fin,mouv,nom;
  XMLUtil xmlEvt(node);
  
  
  vector<const xmlpp::Element*> osgNodes= xmlEvt.getAllElement("osgNode");

  string nod;
  for (unsigned int i=0; i<osgNodes.size();i++) {
    xmlEvt.set(osgNodes[i]);
    nod = xmlEvt.getFirstText("nom");
    pushNodeName( nod );    
    CTRACE(this,"loadXML")<<"osgNode["<<i<<"]="<<node<<endl;
  }

  return true;
}//@CODE_3499


void NodeNameList::pushNodeName(const std::string& name)
{//@CODE_4324
  this->push_back(name);
  _checkNodePathRegister[name] = 0;
}//@CODE_4324


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_3488
Method which must be called first in a constructor.
*/
void NodeNameList::ConstructorInclude()
{
}


/*@NOTE_3489
Method which must be called first in a destructor.
*/
void NodeNameList::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} // end of namespace cooki3d
