/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          NodeNameList.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'NodeNameList'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _NODENAMELIST_H
#define _NODENAMELIST_H

//@START_USER1

#include <vector>
#include <string>
#include "XMLUtil.h"

typedef std::vector<std::string> VectorString;

namespace cooki3d{
//@END_USER1


/*@NOTE_3486
class ...
*/

class AFX_EXT_CLASS NodeNameList
    : public VectorString
{

//@START_USER2
public:
    typedef std::map<std::string,int,less<std::string > > mapStrInt;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    mapStrInt _checkNodePathRegister;
    std::string _lastZoneFound;

//
// Non-Grouped Methods
//

public:
    NodeNameList();
    virtual ~NodeNameList();
    virtual bool check();
    bool checkAddPotentialZone(std::string nom);
    bool findZone(std::string nom);
    virtual bool loadXML(const xmlpp::Node* node);
    void pushNodeName(const std::string& name);
};

#endif


#ifdef CB_INLINES
#ifndef _NODENAMELIST_H_INLINES
#define _NODENAMELIST_H_INLINES

//@START_USER3
} // end of namespace cooki3d
//@END_USER3

#endif
#endif
