/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          OsgNodeReference.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'OsgNodeReference'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _OSGNODEREFERENCE_H
#define _OSGNODEREFERENCE_H

//@START_USER1

#include "XMLUtil.h"
//#include "OsgReference.h"
#include "Evaluable.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_1897
class ...
*/

class AFX_EXT_CLASS OsgNodeReference
    : public Evaluable
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    osg::Node* _osgNode;

protected:
    bool _insertTransform;
    std::string _nodeName;
    osg::Transform* _transform;
    std::string _transformType;

//
// Non-Grouped Methods
//

public:
    OsgNodeReference(BD* pBD);
    virtual ~OsgNodeReference();
    virtual bool check();
    static OsgNodeReference* getOsgNodeReference(BD* pBD, std::string nodeName);
    static bool linkOsgNodeReference(osg::Node* n, osg::Node* parent,
                                     const std::string& pickName,
                                     LoaderGeneric* loader);
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    static Evaluable* staticCreate(BD* pBD);
    bool isInsertTransform() const;
    void setInsertTransform(bool insertTransform);
    std::string getNodeName() const;
    void setNodeName(std::string nodeName);
    osg::Node* getOsgNode() const;
    void setOsgNode(osg::Node* pOsgNode);
    osg::Transform* getTransform() const;
    void setTransform(osg::Transform* pTransform);
    std::string getTransformType() const;
    void setTransformType(std::string transformType);
};

#endif


#ifdef CB_INLINES
#ifndef _OSGNODEREFERENCE_H_INLINES
#define _OSGNODEREFERENCE_H_INLINES

/*@NOTE_4607
Returns the value of member '_insertTransform'.
*/
inline bool OsgNodeReference::isInsertTransform() const
{//@CODE_4607
    return _insertTransform;
}//@CODE_4607



/*@NOTE_4608
Set the value of member '_insertTransform' to 'insertTransform'.
*/
inline void OsgNodeReference::setInsertTransform(bool insertTransform)
{//@CODE_4608
    _insertTransform = insertTransform;
}//@CODE_4608



/*@NOTE_4610
Returns the value of member '_nodeName'.
*/
inline std::string OsgNodeReference::getNodeName() const
{//@CODE_4610
    return _nodeName;
}//@CODE_4610



/*@NOTE_4611
Set the value of member '_nodeName' to 'nodeName'.
*/
inline void OsgNodeReference::setNodeName(std::string nodeName)
{//@CODE_4611
    _nodeName = nodeName;
}//@CODE_4611



/*@NOTE_1920
Returns the value of member '_osgNode'.
*/
inline osg::Node* OsgNodeReference::getOsgNode() const
{//@CODE_1920
    return _osgNode;
}//@CODE_1920



/*@NOTE_1921
Set the value of member '_osgNode' to 'pOsgNode'.
*/
inline void OsgNodeReference::setOsgNode(osg::Node* pOsgNode)
{//@CODE_1921
    _osgNode = pOsgNode;
}//@CODE_1921



/*@NOTE_4613
Returns the value of member '_transform'.
*/
inline osg::Transform* OsgNodeReference::getTransform() const
{//@CODE_4613
    return _transform;
}//@CODE_4613



/*@NOTE_4614
Set the value of member '_transform' to 'pTransform'.
*/
inline void OsgNodeReference::setTransform(osg::Transform* pTransform)
{//@CODE_4614
    _transform = pTransform;
}//@CODE_4614



/*@NOTE_4616
Returns the value of member '_transformType'.
*/
inline std::string OsgNodeReference::getTransformType() const
{//@CODE_4616
    return _transformType;
}//@CODE_4616



/*@NOTE_4617
Set the value of member '_transformType' to 'transformType'.
*/
inline void OsgNodeReference::setTransformType(std::string transformType)
{//@CODE_4617
    _transformType = transformType;
}//@CODE_4617



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
