/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          QGLWidgetOSG.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'QGLWidgetOSG'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "QGLWidgetOSG.h"
#include <osg/Group>
#include <osgUtil/UpdateVisitor>
#include "Camera.h"
#include <osg/PositionAttitudeTransform>
#include "EvtAdapterQT.h"



#include "PickIntersectVisitor.h"
#include <osgGA/GUIEventAdapter>

//#include <qglviewer/QGLViewer.h> //debian sarge 
//#include <QGLViewer/qglviewer.h> //alma

#include "EvtAdapterQT.h"

#ifdef QGL_SUPPORT

#include <qsize.h>

#include "EnvironnementQT.h"

#include "CommandThreadSdl.h"
#include "Methode_0arg.h"

namespace cooki3d{


//@END_USER2




/*@NOTE_4665
Constructor method.
*/
QGLWidgetOSG::QGLWidgetOSG(EnvironnementQT* envQt, QWidget* parent,
                           const QGLWidget* shareWidget) //@INIT_4665
  : 

#if QT_VERSION < 0x040000
QGLWidget(parent, "viewer", shareWidget)
#else
QGLWidget(parent, shareWidget)
#endif
    , _envQT(envQt)
    , _animationTimerId(-1)
{//@CODE_4665
    ConstructorInclude();
 
     // Put in your own code
    _envQT->setQGLWidget(this);

    setFocusPolicy(Qt::ClickFocus); //QT4 add
}//@CODE_4665


/*@NOTE_4656
Destructor method.
*/
QGLWidgetOSG::~QGLWidgetOSG()
{//@CODE_4656
    DestructorInclude();

    // Put in your own code
}//@CODE_4656


QString QGLWidgetOSG::helpString() const
{//@CODE_4671
  QString text("<h2>EnvironnementQT QGL pour OpenSceneGraph</h2>");
  text += "";
  return text;
}//@CODE_4671


void QGLWidgetOSG::initializeGL()
{//@CODE_4672
  
  int x,y,w,h;
  assertC2( _envQT , NULL );
  _envQT->getViewport( x, y, w, h );
  resize( w, h );
  CTRACE(this,"initializeGL")<<"..."<<endl;

  this->setAutoBufferSwap(true);
  
  startAnimation( 30 ); //milliseconde delay entre chaque image demandées

}//@CODE_4672


void QGLWidgetOSG::keyPressEvent(QKeyEvent* e)
{//@CODE_4673
  
 // Get event modifiers key
#if QT_VERSION < 0x040000
  // Bug in Qt : use 0x0f00 instead of Qt::KeyButtonMask with Qt versions < 3.1
  const Qt::ButtonState modifiers = (Qt::ButtonState)(e->state() & Qt::KeyButtonMask);
#else
  const Qt::KeyboardModifiers modifiers = e->modifiers();
#endif
  


  //cout<<"e->key()="<<e->key()<<endl;
  //cout<<"modifiers="<<modifiers<<endl;

  ///double t = __frameStamp->getReferenceTime();
    
  osg::ref_ptr<EvtAdapterQT> adapter = new EvtAdapterQT(_envQT);
  if (modifiers == 0){
    
#if QT_VERSION < 0x040000
    adapter->fireEventKey(e->ascii());
#else
    adapter->fireEventKey(e->key()/*+('a'-'A')*/);
#endif
  }
  

}//@CODE_4673


void QGLWidgetOSG::mouseDoubleClickEvent(QMouseEvent* e)
{//@CODE_4675

  cerr<<"mouseDoubleClickEvent => @TODO"<<endl;
  //osg::ref_ptr<EvtAdapterQT> adapter = new EvtAdapterQT();

}//@CODE_4675


void QGLWidgetOSG::mouseMoveEvent(QMouseEvent* e)
{//@CODE_4677

  //cerr<<"mouseMoveEvent"<<endl;

  osg::ref_ptr<EvtAdapterQT> adapter = new EvtAdapterQT(_envQT);

  adapter->fireEventMouseDragged(e);
  
}//@CODE_4677


void QGLWidgetOSG::mousePressEvent(QMouseEvent* e)
{//@CODE_4679

  //cerr<<"mousePressEvent"<<endl;
  

  osg::ref_ptr<EvtAdapterQT> adapter = new EvtAdapterQT(_envQT);

  adapter->fireEventMousePressed(e);
  
}//@CODE_4679


void QGLWidgetOSG::mouseReleaseEvent(QMouseEvent* e)
{//@CODE_4681

  //cerr<<"mouseReleaseEvent"<<endl;

  osg::ref_ptr<EvtAdapterQT> adapter = new EvtAdapterQT(_envQT);

  adapter->fireEventMouseReleased(e);
  
}//@CODE_4681


void QGLWidgetOSG::paintGL()
{//@CODE_4683
  
  _envQT->appIdle();

}//@CODE_4683


void QGLWidgetOSG::resizeGL(int w, int h)
{//@CODE_4729
  cout<<"resizeGL"<<endl;
  QGLWidget::resizeGL(w,h);
  assertC2( _envQT, NULL );
  _envQT->setViewport( 0, 0, w, h);
}//@CODE_4729


void QGLWidgetOSG::startAnimation(int animationPeriod)
{//@CODE_4758
  _animationTimerId = startTimer(animationPeriod);
  _animationStarted = true;
}//@CODE_4758


void QGLWidgetOSG::stopAnimation()
{//@CODE_4765
  if ( _animationStarted){
    _animationStarted = false;
    killTimer(_animationTimerId);
  }
}//@CODE_4765


void QGLWidgetOSG::timerEvent(QTimerEvent* )
{//@CODE_4761
  if (_animationStarted){
    updateGL();
  }
}//@CODE_4761


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_4657
Method which must be called first in a constructor.
*/
void QGLWidgetOSG::ConstructorInclude()
{
}


/*@NOTE_4658
Method which must be called first in a destructor.
*/
void QGLWidgetOSG::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
#endif
