/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          QGLWidgetOSG.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'QGLWidgetOSG'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _QGLWIDGETOSG_H
#define _QGLWIDGETOSG_H

//@START_USER1

#include <osg/Geode>
#include <osg/ref_ptr>
#include <osg/FrameStamp>
#include <osg/DisplaySettings>
#include <osg/State>
#include <osg/TexGen>
#include <osg/Texture2D>
#include <osgDB/ReadFile>
#include <osgDB/WriteFile>


#include <osgGA/TrackballManipulator>
#include <osgGA/GUIActionAdapter>
#include <osgGA/GUIEventHandler>
#include <osgGA/MatrixManipulator>


#include <osgUtil/SceneView>
#include <osgUtil/DisplayRequirementsVisitor>
#include <osg/Timer>

#include "EnvironnementGeneric.h"

#include "EvtAdapterQT.h"


#ifdef QGL_SUPPORT
#include <qgl.h>
#else
#include "specialNoSupport/QGLPseudoSupport.h"
#endif

using namespace std;


namespace cooki3d{

  class EnvironnementQT;
//@END_USER1


/*@NOTE_4655
class ...
*/

class AFX_EXT_CLASS QGLWidgetOSG
    : public QGLWidget
{

//@START_USER2
#ifdef QGL_SUPPORT
  //  Q_OBJECT
#endif  
  typedef list<osg::ref_ptr<osgGA::GUIEventHandler> > ListEH;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    EnvironnementQT* _envQT;

protected:
    bool _animationStarted;
    int _animationTimerId;

//
// Non-Grouped Methods
//

public:
    QGLWidgetOSG(EnvironnementQT* envQt, QWidget* parent = NULL,
                 const QGLWidget* shareWidget = NULL);
    virtual ~QGLWidgetOSG();
    virtual QString helpString() const;
    virtual void initializeGL();
    virtual void keyPressEvent(QKeyEvent* e);
    virtual void mouseDoubleClickEvent(QMouseEvent* e);
    virtual void mouseMoveEvent(QMouseEvent* e);
    virtual void mousePressEvent(QMouseEvent* e);
    virtual void mouseReleaseEvent(QMouseEvent* e);
    virtual void paintGL();
    virtual void resizeGL(int w, int h);
    virtual void startAnimation(int animationPeriod);
    virtual void stopAnimation();
    virtual void timerEvent(QTimerEvent* );
    EnvironnementQT* getEnvQT() const;
    void setEnvQT(EnvironnementQT* pEnvQT);
};

#endif


#ifdef CB_INLINES
#ifndef _QGLWIDGETOSG_H_INLINES
#define _QGLWIDGETOSG_H_INLINES

/*@NOTE_4662
Returns the value of member '_envQT'.
*/
inline EnvironnementQT* QGLWidgetOSG::getEnvQT() const
{//@CODE_4662
    return _envQT;
}//@CODE_4662



/*@NOTE_4663
Set the value of member '_envQT' to 'pEnvQT'.
*/
inline void QGLWidgetOSG::setEnvQT(EnvironnementQT* pEnvQT)
{//@CODE_4663
    _envQT = pEnvQT;
}//@CODE_4663



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
