/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Register.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Register<Item>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
* November 14, 2006 00:37 bg
*     Deleted inheritance 'Evaluable'
*     Update comment header
*     Updated return type of method 'getFirstCamera'
*     Updated return type of method 'getLastCamera'
*     Updated return type of method 'getNextCamera'
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _REGISTER_H
#define _REGISTER_H

//@START_USER1
#include "Evaluable.h"
#include "XMLUtil.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_3725
class...
*/
template<typename Item>
class Register
    : public Evaluable
{

//@START_USER2
public:

  /*struct strCmp {
    bool operator()( const std::string & s1, const std::string & s2 ) const {
    return strcmp( s1.c_str(), s2.c_str() ) < 0;
    }
    }; // revient à  less< str::string > */

  typedef std::map<std::string,Item,less<std::string > > mapStrItem;
  
  typedef 
  typename std::map<std::string,Item,less<std::string> >::iterator iterator;
  const iterator begin(){ return _mapRegister.begin(); }
  const iterator end(){ return _mapRegister.end(); }
  const Item operator []( std::string s) { return _mapRegister[ s ]; } 
  unsigned int size(){ return _mapRegister.size(); }
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

protected:
    mapStrItem _mapRegister;

//
// Non-Grouped Methods
//

public:
    Register(BD* pBD);
    Register();
    virtual ~Register();
    void add(const std::string& name, Item item);
    Item getFirstItem();
    Item getLastItem();
    Item getNextItem(std::string camName);
    void remove(const std::string& name);
};

#endif


#ifdef CB_INLINES
#ifndef _REGISTER_H_INLINES
#define _REGISTER_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_3727
Method which must be called first in a constructor.
*/
template<typename Item>
void Register<Item>::ConstructorInclude()
{
}



/*@NOTE_3728
Method which must be called first in a destructor.
*/
template<typename Item>
void Register<Item>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_3739
Constructor method.
*/
template<typename Item>
Register<Item>::Register(BD* pBD) //@INIT_3739
    :  Evaluable(pBD)
    , _mapRegister()
{//@CODE_3739
    ConstructorInclude();

    // Put in your own code
}//@CODE_3739



/*@NOTE_5080
Constructor method.
*/
template<typename Item>
Register<Item>::Register() //@INIT_5080
  : Evaluable( (BD*)-1 )
    , _mapRegister()
{//@CODE_5080
    ConstructorInclude();
    
    //special stl_map need default constructor

    
}//@CODE_5080



/*@NOTE_3726
Destructor method.
*/
template<typename Item>
Register<Item>::~Register()
{//@CODE_3726
    DestructorInclude();

    // Put in your own code
}//@CODE_3726



template<typename Item>
void Register<Item>::add(const std::string& name, Item item)
{//@CODE_3754
  assertC ( _mapRegister.find( name ) == _mapRegister.end() );
  _mapRegister[ name ] = item;
}//@CODE_3754



template<typename Item>
Item Register<Item>::getFirstItem()
{//@CODE_4371
  if (_mapRegister.size() == 0){
    return NULL;
  }
  return (_mapRegister.begin()->second);
}//@CODE_4371



template<typename Item>
Item Register<Item>::getLastItem()
{//@CODE_4370
  if (_mapRegister.size() == 0){
    return NULL;
  }
  return  (_mapRegister.rbegin())->second;
}//@CODE_4370



template<typename Item>
Item Register<Item>::getNextItem(std::string camName)
{//@CODE_4368
  
  if (_mapRegister.size() != 0){
    
    iterator it= _mapRegister.find(camName);
    it ++;
    if (it != _mapRegister.end()){
      return it->second;
    }
  }
  return NULL;
  
}//@CODE_4368



template<typename Item>
void Register<Item>::remove(const std::string& name)
{//@CODE_4077
  _mapRegister.erase( name );
}//@CODE_4077



//@START_USER3
//attention CB fait parfois sauter ce crochet fermant...
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
