/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          ScanSetGraph.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'ScanSetGraph'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "ScanSetGraph.h"
#include "Animation.h"
//#include "ObjReactifANs.h"
#include <osgFX/BumpMapping>
#include <osg/Texture2D>
#include "BD.h"
#include "Evaluable.h"
#include "Media.h"
#include "Command.h"
namespace cooki3d{
//@END_USER2


// Static members
std::string ScanSetGraph::_pathSeparator = "/";


/*@NOTE_185
Constructor method.
*/
ScanSetGraph::ScanSetGraph() //@INIT_185
    
{//@CODE_185
    ConstructorInclude();

    // Put in your own code
}//@CODE_185


/*@NOTE_181
Destructor method.
*/
ScanSetGraph::~ScanSetGraph()
{//@CODE_181
    DestructorInclude();

    // Put in your own code
}//@CODE_181


std::string ScanSetGraph::getBuffer()
{//@CODE_193
    return _buffer.str();
}//@CODE_193


osg::Geode* ScanSetGraph::getFirstGeode(osg::Node* n)
{//@CODE_1387

  osg::Geode * g=dynamic_cast<osg::Geode *>(n);
  
  if (g)
    return g;
    
  if (n->asGroup()) {
      int num=n->asGroup()->getNumChildren();
      //for (int i=0; i<num;i++) {
      if (num>=1){
	g = getFirstGeode(n->asGroup()->getChild(0));
	if (g)
	  return g;	  
      }
      //}
  }

  return NULL;
}//@CODE_1387


std::string ScanSetGraph::getFirstNamePath(osg::Node* n)
{//@CODE_3759
    std::string value=n->getName();
    
    if (value=="root"){
      return "";
    }
    else if (n->getNumParents() > 0 ){  
      return getFirstNamePath( n->getParent(0) )+_pathSeparator+value;
    }
    
    return _pathSeparator+value;
}//@CODE_3759


std::string ScanSetGraph::getNamePath(const osg::NodePath& np)
{//@CODE_4638

  std::string result="/";

  cerr<<"np.size()="<<np.size()<<endl;
  
  for (osg::NodePath::const_iterator it = np.begin();
       it != np.end();
       it++){

    if ( (*it)->getName() !="root" ){
      if ( it+1 != np.end() ){
	result = result + (*it)->getName() +_pathSeparator;
      } else {
	result = result + (*it)->getName();
      }	
      
    }
    
   

  }
  return result;

}//@CODE_4638


void ScanSetGraph::scanEtCommand(osg::Node* n, Command* command)
{//@CODE_709

  if (n == NULL){
    CERR(this,"scanEtCommand")<<" Node n is NULL"<<endl;
    return;
  }  
  
  //appel de la command utilisateur du type void command(osg::Node *)
  //cout<<"TRACE "<<"ScanSetGraph::scanEtCommand "<<"appel de la command utilisateur pour pick_name =="<<pick_name<<endl;
  command->pSetArg1(&n);
  command->exec();
  

  if (n->asGroup()) {
    //_buffer<<decal<<"the node is a group"<<endl;
    int num=n->asGroup()->getNumChildren();
    //_buffer<<decal<<"g->getNumChildren()="<<num<<endl;
    //decal+=" * ";
    for (int i=0; i<num;i++) {
      //_buffer<<decal<<"******************"<<endl;
      //_buffer<<decal<<"Child "<<i<<" :"<<endl;
      scanEtCommand(n->asGroup()->getChild(i),command/*,pick_name*/);//,pActivite);
    }
  }

}//@CODE_709


void ScanSetGraph::scanEtCommand2args(osg::Node* n, osg::Node * parent,
                                      Command* command)
{//@CODE_2146
  
  if (n == NULL){
    CERR(this,"scanEtCommand")<<" Node n is NULL"<<endl;
    return;
  }  
  
  
  command->pSetArg1(&n);
  command->pSetArg2(&parent);
  command->exec();
  


  if (n->asGroup()) {
    int num=n->asGroup()->getNumChildren();
    for (int i=0; i<num;i++) {
      if (n->asGroup()->getChild(i)){
      
	scanEtCommand2args(n->asGroup()->getChild(i),n,command);
      }else {
	CERR(this,"scanEtCommand2args")<<"NULL Child!!"<<endl;
      }
    }
  }

}//@CODE_2146


void ScanSetGraph::scanEtCommand3args(osg::Node* n, osg::Node * parent,
                                      std::string path, Command* command)
{//@CODE_3968

  if (n == NULL){
    CERR(this,"scanEtCommand")<<" Node n is NULL"<<endl;
    return;
  }  
  
  command->pSetArg1(&n);
  command->pSetArg2(&parent);
  command->pSetArg3(&path);
  command->exec();
  


  if (n->asGroup()) {
    int num=n->asGroup()->getNumChildren();
    for (int i=0; i<num;i++) {
      
      if (n->asGroup()->getChild(i)){

	scanEtCommand3args( n->asGroup()->getChild(i), n,
			    path+_pathSeparator
			    + n->asGroup()->getChild(i)->getName(),
			    command );
      }
      else {
	CERR(this,"scanEtCommand3args")<<"NULL Child!!"<<endl;
      }
    }
  }

}//@CODE_3968


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_182
Method which must be called first in a constructor.
*/
void ScanSetGraph::ConstructorInclude()
{
}


/*@NOTE_183
Method which must be called first in a destructor.
*/
void ScanSetGraph::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
/*void ScanSetGraph::LierEffet(osg::Node* n, LoaderXML::mapStrEvt zones,
                             osgFX::Effect* original)
{//@CODE_5148

  assertC(n);
  assertC(original);

  //assertC(zones);

  //static string pick_name="nom par default";

  osgFX::Effect * copy;
      
  string pickName;

  cout<<"LierEffet de "<<n->getName()<<endl;
  
  LoaderXML::mapStrEvt::iterator rech;
  
  bool originalUtil = false;

  if (n->asGroup()) {
    osg::Group * pere= n->asGroup();
    osg::Node * enfant;
    int num= pere->getNumChildren();
    for (int i=0; i<num;i++) {
      enfant = pere->getChild(i);
      pickName = enfant->getName();
      cout<<"pickName effet ="<<pickName<<endl;
      rech = zones.find(pickName);

      if (enfant->asGroup() && rech==zones.end()){
	
	osg::CopyOp cop;
	copy = static_cast<osgFX::Effect *>(cop(original));

	LierEffet(enfant,zones,copy);
      }
      else {	
	if (rech != zones.end()) {
	  	  
	  original->addChild(enfant);
	  pere->replaceChild(enfant,original);
	  zones.erase(pickName);
	  originalUtil = true;
	}
      }	 
    }
    if (originalUtil) {
      cout<<"setUpDemo"<<endl;
      original->setUpDemo();
    }
    //else delete original --> impropre;
  }

  
}//@CODE_5148
*/
