/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          ScanSetGraph.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'ScanSetGraph'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _SCANSETGRAPH_H
#define _SCANSETGRAPH_H
#include <osgDB/ReadFile>
#include <osgUtil/Optimizer>
#include <osgProducer/Viewer>
#include <iostream>
#include <fstream>

using namespace std;

//@START_USER1
//#include "MapRW.h"
#include <sstream>
#include "CookiMetier.h"
//#include "Activite.h"
//#include <osgFX/Registry>
#include <osgFX/Effect>
#include "Command.h"
//#include "ChargeurJeu.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_180
class ...

*/

class AFX_EXT_CLASS ScanSetGraph
{

//@START_USER2

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    ostringstream _buffer;
    static std::string _pathSeparator;

//
// Non-Grouped Methods
//

public:
    ScanSetGraph();
    virtual ~ScanSetGraph();
    std::string getBuffer();
    static osg::Geode* getFirstGeode(osg::Node* n);
    static std::string getFirstNamePath(osg::Node* n);
    static std::string getNamePath(const osg::NodePath& np);
    void scanEtCommand(osg::Node* n, Command* command);
    void scanEtCommand2args(osg::Node* n, osg::Node * parent, Command* command);
    void scanEtCommand3args(osg::Node* n, osg::Node * parent, std::string path,
                            Command* command);
    static std::string getPathSeparator();
    static void setPathSeparator(std::string pathSeparator);
};

#endif


#ifdef CB_INLINES
#ifndef _SCANSETGRAPH_H_INLINES
#define _SCANSETGRAPH_H_INLINES

/*@NOTE_3977
Returns the value of member '_pathSeparator'.
*/
inline std::string ScanSetGraph::getPathSeparator()
{//@CODE_3977
    return _pathSeparator;
}//@CODE_3977



/*@NOTE_3978
Set the value of member '_pathSeparator' to 'pathSeparator'.
*/
inline void ScanSetGraph::setPathSeparator(std::string pathSeparator)
{//@CODE_3978
    _pathSeparator = pathSeparator;
}//@CODE_3978



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
