/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          SolCollisions.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'SolCollisions'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _SOLCOLLISIONS_H
#define _SOLCOLLISIONS_H

//@START_USER1

// #ifdef CB_INLINES
// #undef CB_INLINES
// #define MODIF_BD_H
// #endif 
// class SolCollisions;


// #include "Evaluable.h"
// #include "HeightMap.h"

// #ifdef MODIF_BD_H
// #define CB_INLINES
// #undef MODIF_BD_H
// #endif
#include <vector>
using namespace std;
#include "XMLUtil.h"

#include "SolGravitation.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_2232
class ...
*/

class AFX_EXT_CLASS SolCollisions
    : public SolGravitation
{

//@START_USER2
public :
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    static MapUserRegister<std::vector<HeightMapAbstract*> > _maps2;
    static MapUserRegister<std::vector<double> > _altitude2;
    static MapUserRegister<std::vector<double> > _scale2;

//
// Non-Grouped Methods
//

public:
    SolCollisions(BD* pBD);
    virtual ~SolCollisions();
    static float getDeltaCase(BD* pBD);
    static float getHeightAbs(float x, float y, BD* pBD);
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    virtual void pushAltitude(double altitude);
    virtual void pushMap(HeightMapAbstract* pHeightMapAbstract);
    virtual void pushScale(double scale);
    static Evaluable* staticCreate(BD* pBD);
    static void setAltitude(MapUserRegister<std::vector<double> > altitude2);
    static MapUserRegister<std::vector<double> > getAltitude2();
};

#endif


#ifdef CB_INLINES
#ifndef _SOLCOLLISIONS_H_INLINES
#define _SOLCOLLISIONS_H_INLINES

/*@NOTE_2241
Set the value of member '_altitude2' to 'altitude2'.
*/
inline void SolCollisions::setAltitude(MapUserRegister<std::vector<double> > altitude2)
{//@CODE_2241
    _altitude2 = altitude2;
}//@CODE_2241



/*@NOTE_5275
Returns the value of member '_altitude2'.
*/
inline MapUserRegister<std::vector<double> > SolCollisions::getAltitude2()
{//@CODE_5275
    return _altitude2;
}//@CODE_5275



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
