/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Sound.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Sound'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "Sound.h"
#include <iostream>
#include "XMLUtil.h"
#include "Media.h"
#include "Evaluable.h"
#include "LoaderXML.h"
//pileThis = pile des objets sons à mixer

//formats de sortie
/* On demande un format par default de sortie 16 bits stéréo à 22kHz */
namespace cooki3d{
//@END_USER2


// Static members
std::vector<Sound*> Sound::_pileThis;
SDL_AudioSpec Sound::_sortie;
SDL_AudioSpec Sound::_obtenu;
bool Sound::_started = false;


/*@NOTE_1269
Constructor method.
*/
Sound::Sound(BD* pBD) //@INIT_1269
    : MediaEvaluable(pBD)
{//@CODE_1269
    ConstructorInclude();

    _wave.sound = NULL;
}//@CODE_1269


/*@NOTE_1240
Destructor method.
*/
Sound::~Sound()
{//@CODE_1240

  for (unsigned int i=0; i<_pileThis.size(); i++){
    if (_pileThis[i]==this) _pileThis.erase(_pileThis.begin() + i);
  }  
  if ( _wave.sound){ //cela est faux si c'est un son mpeg par ex.
    SDL_FreeWAV(_wave.sound);
  }
}//@CODE_1240


void Sound::C_Fillerup(void * userdata, Uint8* stream, int len)
{//@CODE_1250

  
  switch ((int)userdata){
  case 1:      
    for(unsigned int i=0; i<_pileThis.size(); i++){        
      _pileThis[i]->mixer(stream,len);
    } 
    break;
  default:
    std::cerr<<"Userdata est NULL !!!!"<<endl; 
     
  }
    
   

}//@CODE_1250


void Sound::closeAll()
{//@CODE_1268
  SDL_CloseAudio();
}//@CODE_1268


double Sound::getDuration()
{//@CODE_1274
    int value;
    assertC(0);
    return value;
}//@CODE_1274


double Sound::getPosition()
{//@CODE_1272
    double value;
    assertC(0);
    return value;
}//@CODE_1272


bool Sound::isPause()
{//@CODE_1275
    bool value;
    assertC(0);
    return value;
}//@CODE_1275


bool Sound::isPlay()
{//@CODE_1276
    bool value;
    assertC(0);
    return value;
}//@CODE_1276


void Sound::load(const char * wavfile)
{//@CODE_1261


	
	//_wave.spec.samples=512;
	
  /* load the _wave file into memory */
  if ( SDL_LoadWAV(wavfile,&_wave.spec, &_wave.sound, &_wave.soundlen) == NULL ) {
    fprintf(stderr, "Couldn't load %s: %s\n",wavfile, SDL_GetError());
    assertC(0);
  }
  //nbSound++;
  _wave.volume=(int) (getPcVolume()*SDL_MIX_MAXVOLUME);
  
  /*cout<<endl<<"_wave.spec.freq="<<_wave.spec.freq<<endl;
    cout<<"_wave.spec.format="<<_wave.spec.format<<endl;
    cout<<"_wave.spec.channels="<<_wave.spec.channels<<endl;
    cout<<"_wave.spec.samples="<<_wave.spec.samples<<endl;
    cout<<"_wave.spec.size="<<_wave.spec.size<<endl;
    cout<<"_wave.soundlen ="<<_wave.soundlen<<endl;
    cout<<"_wave.soundpos="<<_wave.soundpos<<endl;*/  
  
  
  /* Préparation du bloc de conversion audio */
  SDL_BuildAudioCVT(&_wave.cvt, _wave.spec.format, _wave.spec.channels, _wave.spec.freq,
		    _obtenu.format, _obtenu.channels, _obtenu.freq);
  
  /*cout<<"_wave.cvt.len_mult = "<<_wave.cvt.len_mult<<endl;
    cout<<"_wave.cvt.rate_incr ="<<_wave.cvt.rate_incr<<endl;*/
  
  /*len;       
    len_cvt;   
    len_mult;  
    len_ratio;*/
  
  
  
  
  /* Conversion des échantillons vers le format de _sortie */
  _wave.cvt.buf = (Uint8*)malloc(_wave.soundlen * _wave.cvt.len_mult);
  _wave.cvt.len = _wave.soundlen;
  memcpy(_wave.cvt.buf, _wave.sound, _wave.soundlen);
  
  /* We can delete to original WAV data now */
  SDL_FreeWAV(_wave.sound);
  
  /* on lance la convertion du son */
  SDL_ConvertAudio(&_wave.cvt);
  
  _wave.soundlen=_wave.cvt.len_cvt;
    //cout<<"_wave.soundlen modifié="<<_wave.soundlen<<endl;
  _wave.sound=_wave.cvt.buf;
  
  _wave.soundpos=_wave.soundlen;
  //on empile le son qu'à la fin de la convertion
  _pileThis.push_back(this); 
  
}//@CODE_1261


bool Sound::loadDataXML(const xmlpp::Node* node)
{//@CODE_1365
  CTRACE(this,"loadDataSon")<<"&&&&&&&&&&&&&&&& entrée"<<endl;

  if (!_started)
    Sound::start();

  XMLUtil xml(node);

  setName(xml.getFirstText("nom"));  

  setFic(xml.getFirstText("fic"));
  
  setPcVolume(atof(xml.getFirstText("pcVolume").c_str()));

  setPlayOnStart(xml.getFirstText("playOnStart")=="true");  

  return true;
}//@CODE_1365


bool Sound::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_1280
  CTRACE(this,"loadSon")<<"&&&&&&&&&&&&&&&& entrée"<<endl;

  loadDataXML(node);

  load(loaderXML->getPath(getFic()).c_str());

  return true;
}//@CODE_1280


void Sound::mixer(Uint8* stream, int len)
{//@CODE_1258
    Uint32 amount;

    amount = (_wave.soundlen-_wave.soundpos);
    if ( ((int)amount) > len ) {
        amount = len;
    }
    //cerr<<"amount ="<<amount<<endl;
    SDL_MixAudio(stream, &_wave.sound[_wave.soundpos], amount, _wave.volume);
    _wave.soundpos += amount;
}//@CODE_1258


void Sound::pause()
{//@CODE_1273
  assertC(0);
}//@CODE_1273


void Sound::play()
{//@CODE_1267
  _wave.soundpos=0;
}//@CODE_1267


void Sound::reprendreAll()
{//@CODE_1257
  SDL_PauseAudio(0);
}//@CODE_1257


void Sound::setDuration(double duree)
{//@CODE_1884
    assertC(0);
  
}//@CODE_1884


void Sound::setPosition(double sec)
{//@CODE_1277
}//@CODE_1277


void Sound::setVolume(float mul)
{//@CODE_1264

  if (mul >=0.0 && mul <=1.0)
    _wave.volume=int(SDL_MIX_MAXVOLUME*mul);
}//@CODE_1264


int Sound::start()
{//@CODE_1266

  if (_started) {
    CWARNs("Sound::start()")<<"Canal déjà ouvert"<<endl;
    return -1;
  }

  /* On demande un format de _sortie 16 bits stéréo à 22kHz */
  _sortie.freq = 22050;                  //Audio frequency in samples per second              
  _sortie.format = AUDIO_S16;            //Audio data format                                  
  _sortie.channels = 1;                  //Number of channels: 1 mono, 2 stereo               
  _sortie.samples = 1024;                //Audio buffer size in samples       
  _sortie.callback = Sound::C_Fillerup;  //function for filling the audio buffer                           
  _sortie.userdata = (void *)1;          //Pointer the user data : indication que start a bien été exécuté
  
  
  /* Initialize fillerup() variables */
  if ( SDL_OpenAudio(&_sortie,&_obtenu) < 0 ) {
    CERRs("Sound::start()")<<"Couldn't open audio: "<<SDL_GetError()<<endl;
    return -1;
  }
  SDL_PauseAudio(0);
  
  ///cout<<endl<<endl<<"_obtenu.freq="<<_obtenu.freq<<endl;
  ///cout<<"_obtenu.format="<<_obtenu.format<<endl;
  ///cout<<"_obtenu.channels="<<_obtenu.channels<<endl;
  ///cout<<"_obtenu.samples="<<_obtenu.samples<<endl;
  ///cout<<"_obtenu.size="<<_obtenu.size<<endl;
  
  //* Let the audio run */
  /*//printf("Using audio driver: %s\n", SDL_AudioDriverName(name, 32));
    while ( ! done && (SDL_GetAudioStatus() == SDL_AUDIO_PLAYING) )
    SDL_Delay(1000);*/

  _started=true;

  return(0);
}//@CODE_1266


Evaluable* Sound::staticCreate(BD* pBD)
{//@CODE_3030
    return new Sound(pBD);
}//@CODE_3030


void Sound::stop()
{//@CODE_1279
  assertC(0);
}//@CODE_1279


void Sound::stopAll()
{//@CODE_1256
   SDL_PauseAudio(1);
}//@CODE_1256


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1241
Method which must be called first in a constructor.
*/
void Sound::ConstructorInclude()
{
}


/*@NOTE_1242
Method which must be called first in a destructor.
*/
void Sound::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
//void Sound::LoadMusic(char * file){
/*#ifndef MIX_CHANNELS
#define MIX_CHANNELS	8
#endif
#define MIX_DEFAULT_FREQUENCY	22050
#if SDL_BYTEORDER == SDL_LIL_ENDIAN
#define MIX_DEFAULT_FORMAT	AUDIO_S16LSB
#else
#define MIX_DEFAULT_FORMAT	AUDIO_S16MSB
#endif
#define MIX_DEFAULT_CHANNELS	2
#define MIX_MAX_VOLUME		128*/

/* ouvre le périphérique audio avec les valeurs décidées */
/* tous les fichiers chargés et joués seront formatés à ce format */
/*Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, MIX_CHANNELS,512);




    Mix_Music *music;
    music=Mix_LoadMUS(file);
    if(!music) {
        printf("\nMix_LoadMUS(\"%s\"): %s\n",file, Mix_GetError());
        // this might be a critical error...
        exit(0);
    }
    Mix_PlayMusic(music,0);
}*/
