/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Sound.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Sound'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _SOUND_H
#define _SOUND_H

//@START_USER1
#include <SDL/SDL.h>
#include <SDL/SDL_audio.h>
#include <vector>
using namespace std;
#include "MediaEvaluable.h"
#include "XMLUtil.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_1239
classe ...
*/

class AFX_EXT_CLASS Sound
    : public MediaEvaluable
{

//@START_USER2
  typedef struct {
    SDL_AudioSpec spec;      //échantillon
    SDL_AudioCVT  cvt;       //échantillon converti   
    Uint8   *sound;	/* Pointer to wave data préalablement converti*/
    Uint32   soundlen;	/* Length of wave data */
    int      soundpos;	/* Current play position */
    int      volume;
  } Wave;
  
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    Wave _wave;
    static bool _started;
    std::string _fic;
    float _pcVolume;

protected:
    static std::vector<Sound*> _pileThis;
    static SDL_AudioSpec _sortie;
    static SDL_AudioSpec _obtenu;

//
// Non-Grouped Methods
//

public:
    Sound(BD* pBD);
    virtual ~Sound();
    static void C_Fillerup(void * userdata, Uint8* stream, int len);
    void closeAll();
    virtual double getDuration();
    virtual double getPosition();
    virtual bool isPause();
    virtual bool isPlay();
    void load(const char * wavfile);
    virtual bool loadDataXML(const xmlpp::Node* node);
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    virtual void mixer(Uint8* stream, int len);
    virtual void pause();
    void play();
    static void reprendreAll();
    virtual void setDuration(double duree);
    virtual void setPosition(double sec);
    void setVolume(float mul);
    static int start();
    static Evaluable* staticCreate(BD* pBD);
    virtual void stop();
    static void stopAll();
    std::string getFic() const;
    void setFic(std::string fic);
    float getPcVolume() const;
    void setPcVolume(float pcVolume);
    static bool isStarted();
    static void setStarted(bool started);
};

#endif


#ifdef CB_INLINES
#ifndef _SOUND_H_INLINES
#define _SOUND_H_INLINES

/*@NOTE_1362
Returns the value of member '_fic'.
*/
inline std::string Sound::getFic() const
{//@CODE_1362
    return _fic;
}//@CODE_1362



/*@NOTE_1363
Set the value of member '_fic' to '_fic'.
*/
inline void Sound::setFic(std::string fic)
{//@CODE_1363
    _fic = fic;
}//@CODE_1363



/*@NOTE_1373
Returns the value of member '_pcVolume'.
*/
inline float Sound::getPcVolume() const
{//@CODE_1373
    return _pcVolume;
}//@CODE_1373



/*@NOTE_1374
Set the value of member '_pcVolume' to 'pcVolume'.
*/
inline void Sound::setPcVolume(float pcVolume)
{//@CODE_1374
    _pcVolume = pcVolume;
}//@CODE_1374



/*@NOTE_1358
Returns the value of member '_started'.
*/
inline bool Sound::isStarted()
{//@CODE_1358
    return _started;
}//@CODE_1358



/*@NOTE_1359
Set the value of member '_started' to '_started'.
*/
inline void Sound::setStarted(bool started)
{//@CODE_1359
    _started = started;
}//@CODE_1359



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
