/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          SoundMpeg.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'SoundMpeg'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "SoundMpeg.h"
#include "LoaderXML.h"

#ifdef SMPEG_SUPPORT
namespace cooki3d{
//@END_USER2




/*@NOTE_1323
Constructor method.
*/
SoundMpeg::SoundMpeg(BD* pBD) //@INIT_1323
    : Sound(pBD)
    ,_mpeg(0)
{//@CODE_1323
    ConstructorInclude();

    

    // Put in your own code
}//@CODE_1323


/*@NOTE_1319
Destructor method.
*/
SoundMpeg::~SoundMpeg()
{//@CODE_1319
    DestructorInclude();

    // Put in your own code
}//@CODE_1319


double SoundMpeg::getDuration()
{//@CODE_1328
    int value;
    assertC(0);
    return value;
}//@CODE_1328


double SoundMpeg::getPosition()
{//@CODE_1331
    double value;
    assertC(0);
    return value;
}//@CODE_1331


bool SoundMpeg::isPause()
{//@CODE_1327
    bool value;
    assertC(0);
    return value;
}//@CODE_1327


bool SoundMpeg::isPlay()
{//@CODE_1326
    bool value;
    assertC(0);
    return value; 
}//@CODE_1326


bool SoundMpeg::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_1343
  CTRACE(this,"loadSonMpeg")<<"&&&&&&&&&&&&&&&& entrée"<<endl;

  this->Sound::loadDataXML(node);

  SMPEG_Info info;
  
  _mpeg = SMPEG_new( (loaderXML->getPath(getFic()).c_str()), &info,false); //on initialise pas la SDL
  
  if ( SMPEG_error(_mpeg) ) {
    CERR(this,"loadXML")<<getFic()<<":"<<SMPEG_error(_mpeg)<<endl;
    SMPEG_delete(_mpeg);
    return false;
  }  
  SMPEG_enableaudio(_mpeg,true);
  
  SMPEG_setvolume(_mpeg, (int) (getPcVolume()*SDL_MIX_MAXVOLUME));
  
  SMPEG_actualSpec( _mpeg, &_obtenu );
  
  _pileThis.push_back(this); 

  return true;
}//@CODE_1343


void SoundMpeg::mixer(Uint8* stream, int len)
{//@CODE_1354
  //CTRACE(this,"mixer")<<"passage mixer Mpeg"<<endl;
  SMPEG_playAudio( _mpeg, stream, len);   
}//@CODE_1354


void SoundMpeg::pause()
{//@CODE_1329
  SMPEG_pause(_mpeg);
}//@CODE_1329


void SoundMpeg::play()
{//@CODE_1330
  SMPEG_play(_mpeg);
}//@CODE_1330


void SoundMpeg::setPosition(double sec)
{//@CODE_1324
  SMPEG_skip(_mpeg, (float)sec );
}//@CODE_1324


Evaluable* SoundMpeg::staticCreate(BD* pBD)
{//@CODE_3028
    return new SoundMpeg(pBD);
}//@CODE_3028


void SoundMpeg::stop()
{//@CODE_1332
  SMPEG_stop(_mpeg);
}//@CODE_1332


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1320
Method which must be called first in a constructor.
*/
void SoundMpeg::ConstructorInclude()
{
}


/*@NOTE_1321
Method which must be called first in a destructor.
*/
void SoundMpeg::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
#endif
