/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          SoundMpeg.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'SoundMpeg'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _SOUNDMPEG_H
#define _SOUNDMPEG_H

//@START_USER1
#include "Sound.h"
#ifdef SMPEG_SUPPORT
   #include <smpeg/smpeg.h>
#else
   typedef void SMPEG;
#endif

namespace cooki3d{
//@END_USER1


/*@NOTE_1318
classe...
*/

class AFX_EXT_CLASS SoundMpeg
    : public Sound
{

//@START_USER2

//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    SMPEG* _mpeg;

//
// Non-Grouped Methods
//

public:
    SoundMpeg(BD* pBD);
    virtual ~SoundMpeg();
    virtual double getDuration();
    virtual double getPosition();
    virtual bool isPause();
    virtual bool isPlay();
    virtual bool loadXML(const xmlpp::Node* node, LoaderXML* loaderXML);
    virtual void mixer(Uint8* stream, int len);
    virtual void pause();
    virtual void play();
    virtual void setPosition(double sec);
    static Evaluable* staticCreate(BD* pBD);
    virtual void stop();
    SMPEG* getMpeg() const;
    void setMpeg(SMPEG* pMpeg);
};

#endif


#ifdef CB_INLINES
#ifndef _SOUNDMPEG_H_INLINES
#define _SOUNDMPEG_H_INLINES

/*@NOTE_1340
Returns the value of member '_mpeg'.
*/
inline SMPEG* SoundMpeg::getMpeg() const
{//@CODE_1340
    return _mpeg;
}//@CODE_1340



/*@NOTE_1341
Set the value of member '_mpeg' to 'pMpeg'.
*/
inline void SoundMpeg::setMpeg(SMPEG* pMpeg)
{//@CODE_1341
    _mpeg = pMpeg;
}//@CODE_1341



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
