/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Texte.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Texte'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2


#include <osg/Geode>
#include <osgText/Text>
#include <osg/Viewport>
#include <osg/StateSet>
#include <osg/BlendFunc>
#include <osg/CameraNode>


#include "Texte.h"
#include "XMLUtil.h"
#include "BD.h"
#include "LoaderXML.h"
#include "Methode_1arg.h"
#include "Evaluable.h"


//TODO


//3D TEXT
// text1->setAxisAlignment(osgText::Text::XY_PLANE);
// text1->setText("XY_PLANE");

// text2->setAxisAlignment(osgText::Text::YZ_PLANE);
// text2->setText("YZ_PLANE");

// text3->setAxisAlignment(osgText::Text::XZ_PLANE);
// text3->setText("XZ_PLANE");

// text4->setAxisAlignment(osgText::Text::SCREEN);
// text4->setText("SCREEN");

// geode->addDrawable(text4);

//     osg::ShapeDrawable* shape = new osg::ShapeDrawable(new osg::Sphere(center,characterSize*0.2f));
//     shape->getOrCreateStateSet()->setMode(GL_LIGHTING,osg::StateAttribute::ON);
//     geode->addDrawable(shape);
//     osg::Group* rootNode = new osg::Group;
//     rootNode->addChild(geode);


//ALIGNEMENT
// (osgText::Text::LEFT_TOP,"text->setAlignment(\nosgText::Text::LEFT_TOP);"));
// (osgText::Text::LEFT_CENTER,"text->setAlignment(\nosgText::Text::LEFT_CENTER);"));
// (osgText::Text::LEFT_BOTTOM,"text->setAlignment(\nosgText::Text::LEFT_BOTTOM);"));
// (osgText::Text::CENTER_TOP,"text->setAlignment(\nosgText::Text::CENTER_TOP);"));
// (osgText::Text::CENTER_CENTER,"text->setAlignment(\nosgText::Text::CENTER_CENTER);"));
// (osgText::Text::CENTER_BOTTOM,"text->setAlignment(\nosgText::Text::CENTER_BOTTOM);"));
// (osgText::Text::RIGHT_TOP,"text->setAlignment(\nosgText::Text::RIGHT_TOP);"));
// (osgText::Text::RIGHT_CENTER,"text->setAlignment(\nosgText::Text::RIGHT_CENTER);"));
// (osgText::Text::RIGHT_BOTTOM,"text->setAlignment(\nosgText::Text::RIGHT_BOTTOM);"));
// (osgText::Text::LEFT_BASE_LINE,"text->setAlignment(\nosgText::Text::LEFT_BASE_LINE);"));
// (osgText::Text::CENTER_BASE_LINE,"text->setAlignment(\nosgText::Text::CENTER_BASE_LINE);"));
// (osgText::Text::RIGHT_BASE_LINE,"text->setAlignment(\nosgText::Text::RIGHT_BASE_LINE);"));
// (osgText::Text::LEFT_BOTTOM_BASE_LINE,"text->setAlignment(\nosgText::Text::LEFT_BOTTOM_BASE_LINE);"));
// (osgText::Text::CENTER_BOTTOM_BASE_LINE,"text->setAlignment(\nosgText::Text::CENTER_BOTTOM_BASE_LINE);"));
// (osgText::Text::RIGHT_BOTTOM_BASE_LINE,"text->setAlignment(\nosgText::Text::RIGHT_BOTTOM_BASE_LINE);")

//DRAWMODE
//text->setDrawMode(osgText::Text::TEXT|osgText::Text::ALIGNMENT|osgText::Text::BOUNDINGBOX);
  
namespace cooki3d{

#ifdef OSG_CVS 
void Texte::drawImplementation(osg::RenderInfo& renderInfo,
			       const osg::Drawable* drawable) const { 
  this->osgText::Text::drawImplementation( renderInfo); 
}
#endif
//@END_USER2




/*@NOTE_1480
Constructor method.
*/
Texte::Texte(BD* pBD) //@INIT_1480
   :Evaluable(pBD)
{//@CODE_1480
    ConstructorInclude();

    //car cooki3d::Texte hérite d'un osg::Referenced
    //il ne faut pas gérer la destruction
    setNoDeleteFlag(true);
    
    /*  _stateset = new osg::StateSet;
	_viewport = new osg::Viewport(0,0,800,600);   
	
	
	_projectionMatrix = osg::Matrixd::ortho2D(0.0,1280,0,1024);
	
	_stateset->setAttribute(_viewport);
	_stateset->setAttribute(new osg::BlendFunc());
	_stateset->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
	_stateset->setMode(GL_BLEND,osg::StateAttribute::ON);*/
    
        
    //_modelview = new osg::RefMatrix();
    
}//@CODE_1480


/*@NOTE_1475
Destructor method.
*/
Texte::~Texte()
{//@CODE_1475
    DestructorInclude();

    // Put in your own code
}//@CODE_1475


void Texte::drawImplementation(osg::State& state) const
{//@CODE_1503
  //#ifndef OSG_CVS


  this->osgText::Text::drawImplementation( state );
  //#endif

  /*state.applyProjectionMatrix(new osg::RefMatrix(_projectionMatrix));
    state.applyModelViewMatrix(new osg::RefMatrix(_viewMatrix));
    
    state.pushStateSet(_stateset.get());
    state.apply();
    
    this->osgText::Text::drawImplementation(state);
    
    
    state.popStateSet();*/
 
}//@CODE_1503


std::string Texte::getText()
{//@CODE_4350
  return this->osgText::Text::getText().createUTF8EncodedString() ;
}//@CODE_4350


bool Texte::loadXML(const xmlpp::Node* node, LoaderXML* loaderXML)
{//@CODE_1481

  XMLUtil xml(node);
  
  this->Evaluable::setName(xml.getFirstText("nom"));

  std::string font=xml.getFirstText("font");
  
  float r=atof(xml.getFirstText("colorR").c_str());
  float g=atof(xml.getFirstText("colorG").c_str());
  float b=atof(xml.getFirstText("colorB").c_str());
  float a=atof(xml.getFirstText("colorA").c_str());  

  setColor(osg::Vec4(r,g,b,a));
  
  setCharacterSize(atof(xml.getFirstText("characterSize").c_str()));
   
  float x=atof(xml.getFirstText("posX").c_str());
  float y=atof(xml.getFirstText("posY").c_str());
  float z=atof(xml.getFirstText("posZ").c_str());
  
  setPosition(osg::Vec3(x,y,z));
			
  //_osgText->setAlignment(osgText::Text::BASE_LINE);
  
  setText(xml.getFirstText("texte"));
  
  
  //gestion du path -> similaire à File.cpp ...
  loaderXML->loadFilePathXML( node );
  

  //après la mise à jour du path on peut choisir la font
  setFont(font);

  osg::Geode * geo=new osg::Geode();
  geo->addDrawable(this);
 
  
  //if ( is2dText ) { //...
 
  // create the hud.
  osg::CameraNode* camera = new osg::CameraNode;
  
  // set the projection matrix
  camera->setProjectionMatrixAsOrtho2D(0,loaderXML->getWidth(),
				       0,loaderXML->getHeight());

  // set the view matrix    
  camera->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
  camera->setViewMatrix(osg::Matrix::identity());

  // only clear the depth buffer
  camera->setClearMask(GL_DEPTH_BUFFER_BIT);

  // draw subgraph after main camera view.
  camera->setRenderOrder(osg::CameraNode::POST_RENDER);
  
  camera->addChild( geo );
  camera->getOrCreateStateSet()->setMode(GL_LIGHTING,osg::StateAttribute::OFF);


  loaderXML->getRootNode()->addChild( camera );
  
  //}...

   

  return true;
}//@CODE_1481


Evaluable* Texte::staticCreate(BD* pBD)
{//@CODE_3049
    return new Texte(pBD);
}//@CODE_3049


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1476
Method which must be called first in a constructor.
*/
void Texte::ConstructorInclude()
{
}


/*@NOTE_1477
Method which must be called first in a destructor.
*/
void Texte::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d

//POUBELLE
 /*Methode_1arg<Texte,osg::State *> * com;
  com  = new Methode_1arg<Texte,osg::State *>(&Texte::postDraw,this);   
  com->setName("commandDraw->"+getName());

  EnvironnementOSG::instance()->getPostDrawCom().push_back(com);*/

//#undef THREAD_SAFE_REF_UNREF


/*osg::Matrixd _viewMatrix;
osg::Matrixd _projectionMatrix;

osg::StateSet * _state
*/
