/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          TimeMod.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'TimeMod'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "TimeMod.h"
#include "LoaderXML.h"
#include <SDL/SDL.h>
namespace cooki3d{
//@END_USER2




/*@NOTE_753
Constructor method.
*/
TimeMod::TimeMod(BD* pBD, double longu, LoaderGeneric* loader) //@INIT_753
    : ThreadSdl(pBD)
    , _taches()
    , _stop(true)
    , _tacheIT()
    , _loader(loader)
{//@CODE_753
  ConstructorInclude();

  CTRACE(this,"TimeMod")<<"construct new TimeMod  "<<this<<endl;

  ///start();

  //appel du run de ThreadSdl
  start(); 

  //assert(_taches.size());
  //_tacheIT=_taches.begin();

  // Put in your own code
}//@CODE_753


/*@NOTE_746
Destructor method.
*/
TimeMod::~TimeMod()
{//@CODE_746
  DestructorInclude();

  // Put in your own code
  CTRACE(this,"~TimeMod")<<" destruction thread TimeMod : "<<this<<" OK"<<endl;

}//@CODE_746


void TimeMod::addCommand(Command* c, double mod, int lif)
{//@CODE_755


  Tache t;
  t.c = c;
  t.mod = mod;
  t.dtick = osg::Timer::instance()->tick();
  t.life = lif; //duree de vie infinie par défaut

  _taches.push_back(t);


}//@CODE_755


void TimeMod::play()
{//@CODE_758

  if (_stop)
  {//nécessairement après?
    _stop = false;
  }


}//@CODE_758


void TimeMod::run()
{//@CODE_759

  osg::Timer_t tick;
  double deltaT;


  if ( _loader != NULL ){
    while (!_loader->isLoadFinished() 
            && _vivant) {
        SDL_Delay(100);//YieldCurrentThread();
        CTRACE(this,"run2")<<"TimeMod thread is standing"<<endl;    
    }
  }

//  while (!LoaderXML::isLoadFinished() && _vivant) {
//    CTRACE(this,"run2")<<"TimeMod thread en attende"<<endl;
//    SDL_Delay(100);////YieldCurrentThread();
//  }
  
  CTRACE(this,"run2")<<"TimeMod thread lancée (_vivant="<<_vivant<<",_stop="<<_stop<<")"<<endl;
  //SetConcurrency(1);
  //setSchedulePriority();
  //setSchedulePolicy(SCHEDULE_TIME_SHARE);

  while (_vivant && !_stop )
  {

    //cout<<"RepriseThread(); (TimeMod)"<<endl;
    _tacheIT = _taches.begin();

    while (_tacheIT != _taches.end())
    {

      //cout<<"thread getTick"<<endl;
      tick = osg::Timer::instance()->tick();
      deltaT = osg::Timer::instance()->delta_s(_tacheIT->dtick,tick);
      //cout<<"thread FingetTick"<<endl;

      if (deltaT >= _tacheIT->mod)
      {
        //cout<<"thread exec tache"<<endl;
        _tacheIT->c->exec();
        _tacheIT->dtick = tick;
        
        _tacheIT->life--;
        //cout<<"thread fINexec tache"<<endl;
        if (_tacheIT->life == 0)
        {
          _taches.erase(_tacheIT);
        }

      }
      _tacheIT++;

    }
    //cout<<"YieldCurrentThread(); (TimeMod)"<<endl;
    //YieldCurrentThread();
    SDL_Delay(30); //attente de 30 millisecond
    
  }


}//@CODE_759


void TimeMod::stop()
{//@CODE_760
  _stop =true;
  _tacheIT = _taches.begin();
}//@CODE_760


void TimeMod::Vider()
{//@CODE_761


}//@CODE_761


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_747
Method which must be called first in a constructor.
*/
void TimeMod::ConstructorInclude()
{
}


/*@NOTE_748
Method which must be called first in a destructor.
*/
void TimeMod::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
