/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          TimeMod.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'TimeMod'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _TIMEMOD_H
#define _TIMEMOD_H

//@START_USER1
#include <map>
#include <vector>
#include <osg/Timer>

#include "Threadd.h"
#include "Command.h"
#include "ThreadSdl.h"
#include "LoaderGeneric.h"

namespace cooki3d{
//@END_USER1


/*@NOTE_745
class ...
*/

class AFX_EXT_CLASS TimeMod
    : public ThreadSdl
{

//@START_USER2
public:

  struct Tache {
    Command * c;
    osg::Timer_t dtick; //dernier tick
    double mod;         //temps modulateur
    int life;		//nombre de vie (infini par défault)
  };

  typedef vector<Tache> ListeTache;
  
    
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    ListeTache _taches;
    bool _stop;
    ListeTache::iterator _tacheIT;
    LoaderGeneric* _loader;

//
// Non-Grouped Methods
//

public:
    TimeMod(BD* pBD, double longu = 0.00, LoaderGeneric* loader = NULL);
    virtual ~TimeMod();
    void addCommand(Command* c, double mod, int lif = 0);
    virtual void play();
    virtual void run();
    virtual void stop();
    void Vider();
};

#endif


#ifdef CB_INLINES
#ifndef _TIMEMOD_H_INLINES
#define _TIMEMOD_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
