/** -*-c++-*- *************************************************************\
* File:          XMLUtil.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'XMLUtil'
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#include "CookiMetier.h"
#include "XMLUtil.h"
//#include <glibmm-2.4/glibmm/ustring.h>
#include "CookiMessage.h"

namespace cooki3d{

XMLUtil::XMLUtil(const xmlpp::Node * node){
  assert(node);
  this->list = node->get_children();
  it = list.begin();
}

void XMLUtil::set(const xmlpp::Node * node){
  this->list = node->get_children();
  it = list.begin();
}


string XMLUtil::getFirstText(string name){
  const xmlpp::Element* nodeElement=0;
  
  while (it != list.end()){
    //#ifdef XML_SUPPORT 
    //nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
    //#else

    //BUG_C++_JVM sur dynamic_cast quand load fonction interne depuis Editeur
    //nodeElement = static_cast<const xmlpp::Element*>(*it);
    nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
    //assertC( nodeElement );
      //#endif      
      if (nodeElement && nodeElement->get_name()==name)
	       return nodeElement->get_child_text()->get_content();
      it++;
  } 
  
  //en cas d'erreur
  CERR(this,"getFirstText ")<<"'"<<name<<"'"<<endl;
  CERRnext<<"liste des éléments disponibles:"<<endl;
  it = list.begin();
  while (it != list.end()) {
    //BUG_C++_JVM sur dynamic_cast quand load fonction interne depuis Editeur
    //#ifdef XML_SUPPORT 
    // nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
    //#else
    nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
    //assertC( nodeElement );
    //nodeElement = static_cast<const xmlpp::Element*>(*it);
    //#endif      
    if (nodeElement) {
      CERRnext<<"dispo :"<<nodeElement->get_name()<<endl;
    }
    else {
      CERRnext<<"non dispo :"<<(*it)->get_name()
	      <<endl<<"  type="<<CERR((*it),"");
    }
    it++;
  }  
  CERRnext<<"fin liste."<<endl;
  CERRnext<<"list.size() ="<<list.size()<<endl; 
  assertC2(0, NULL);
  return string();
}

const xmlpp::Element* XMLUtil::getFirstElement(string name){
  const xmlpp::Element* nodeElement=0;
  
  while (it != list.end()){
    //BUG_C++_JVM sur dynamic_cast quand load fonction interne depuis Editeur
    //#ifdef XML_SUPPORT 
      nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
      //assertC( nodeElement );
    //#else
    //nodeElement = static_cast<const xmlpp::Element*>(*it);
      //#endif      
      if (nodeElement && nodeElement->get_name()==name)
	return nodeElement;
      it++;
  } 
  CERR(this,"getFirstElement")<<name<<endl;
  assertC2(0, NULL);
  return 0;
}


vector<const xmlpp::Element*> XMLUtil::getAllElement(string name){
  const xmlpp::Element* nodeElement=0;
  vector<const xmlpp::Element*> liste;
  
  while (it != list.end()){
    
    //BUG_C++_JVM sur dynamic_cast quand load fonction interne depuis Editeur
    //#ifdef XML_SUPPORT 
    nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
    //assertC( nodeElement );
      //#else
    

    //nodeElement = static_cast<const xmlpp::Element*>(*it);

    //#endif         
    if (nodeElement && nodeElement->get_name()==name)
      liste.push_back(nodeElement);
    
    it++;
  }
  it=list.begin();
  
  return liste;
}


vector<string> XMLUtil::getAllText(string name){
  const xmlpp::Element* nodeElement=0;
  vector<string> res;
  
  while (it != list.end()){
    //BUG_C++_JVM sur dynamic_cast quand load fonction interne depuis Editeur
    //#ifdef XML_SUPPORT 
    nodeElement = dynamic_cast<const xmlpp::Element*>(*it);
    //assertC( nodeElement );
      //#else
      //nodeElement = static_cast<const xmlpp::Element*>(*it);
      //#endif 
      if (nodeElement && nodeElement->get_name()==name)
	res.push_back(nodeElement->get_child_text()->get_content());
      it++;
  } 
  return res;
}

}
