/** -*-c++-*- *************************************************************\
* File:          XMLUtil.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'XMLUtil'
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/

#ifndef XMLUTIL_H
#define XMLUTIL_H

//#include "CookiMetier.h"


#ifdef XML_SUPPORT

//#include <libxml++-2.6/libxml++/libxml++.h> 
//#include <libxml++-1.0/libxml++/libxml++.h> 
#include <libxml++/libxml++.h>

#endif

//#include <stack>
#include <string>
#include <iostream>
#include <vector>

using namespace std;

#ifndef XML_SUPPORT 

#include "specialNoSupport/XMLPseudoSupport.h"

#endif

namespace cooki3d{

  class XMLUtil{
    
    xmlpp::Node::NodeList list;
    xmlpp::Node::NodeList::iterator it;
    
    
    
    //stack<XMLUtil> pile;
    
  public:
    
    
    XMLUtil(const xmlpp::Node * node);
    
    XMLUtil(const XMLUtil & x){
      clone(x);
    } 
    
    void operator=(const XMLUtil & x){
      clone(x);
    }
    
    void clone(const XMLUtil & x){
      list = x.list;
      it = x.it;
    }
    
    
    void set(const xmlpp::Node * node);  
    
    
    string getFirstText(string name);
    
    const xmlpp::Element* getFirstElement(string name);
    
    vector<const xmlpp::Element*> getAllElement(string name);
    
    vector<string> getAllText(string name);

    
    
    
  };

}
#endif
