#include <jni.h> 
#include "jni_canvas_CanvasProducer.h" 
#include <iostream>
#include <Producer/RenderSurface> 
#include <jawt_md.h>
#include "../CookiMessage.h"
using namespace std;

namespace cooki3d {
  class BD;
}

int initProducerRenderSurface(Producer::RenderSurface *,
			      cooki3d::BD * pBD){
  CERRs("initProducerRenderSurface")<<"TODO update"<<endl;
  return 0;
}
void drawJavaProducer(cooki3d::BD * pBD) {
  //TODO
  CERRs("drawJavaProducer")<<"TODO update"<<endl;
}

bool initSurface(JAWT_DrawingSurfaceInfo* dsi);

extern bool LMJProducerFirstDraw;


extern "C" JNIEXPORT void JNICALL Java_jni_canvas_CanvasProducer_paint (JNIEnv * pEnv, jobject pCanvas,jobject pGraphics){ 
  
  //The class for RuntimeException. Used to throw exceptions.	
  jclass runtimeException = pEnv->FindClass("java/lang/RuntimeException");	
  
#if defined(_WIN32) || defined(WIN32)
  // Get a hook to the GetAWT call dynamically
  typedef jboolean (JNICALL* PJAWT_GetAWT) (JNIEnv*, JAWT*); // Function pointer
  PJAWT_GetAWT JAWT_GetAWT;
  // This section of code is needed in order to find jawt.dll
  jclass sys = pEnv->FindClass ("java/lang/System");
  jmethodID home = pEnv->GetStaticMethodID (sys, "getProperty", "(Ljava/lang/String;)Ljava/lang/String;");
  jstring ret = (jstring)pEnv->CallStaticObjectMethod(sys, home, pEnv->NewStringUTF ("java.home"));
  
  std::string libName = (LPTSTR)pEnv->GetStringUTFChars (ret, NULL);
  libName += "\\bin\\jawt.dll";
  
  HMODULE hAWT = LoadLibrary ((LPCTSTR)libName.c_str());
  if (!hAWT) return;
  
  JAWT_GetAWT = (PJAWT_GetAWT)GetProcAddress(hAWT, "_JAWT_GetAWT@8");
#endif
  ////
  //Get the JAWT with 1.4 set as min version.	
  JAWT awt;	
  awt.version = JAWT_VERSION_1_4;
  
  if(JAWT_GetAWT(pEnv, &awt) == JNI_FALSE)	
    {		
      pEnv->ThrowNew(runtimeException, "Failed to access JAWT.");		
      return;	
    }
  
  //Fetch a drawing surface.	
  JAWT_DrawingSurface* ds = awt.GetDrawingSurface(pEnv, pCanvas);	
  if(ds == NULL)	
    {		
      pEnv->ThrowNew(runtimeException, "Failed to fetch drawing surface.");		
		return;	
    }	
  
  //I have no idea...	
  jint lock = ds->Lock(ds);	
  if((lock & JAWT_LOCK_ERROR) != 0)	
    {		
      pEnv->ThrowNew(runtimeException, "Failed to acquire lock.");		
      return;	
    }	
  
  //Fetch the DrawingSurfaceInfo	
  JAWT_DrawingSurfaceInfo* dsi = ds->GetDrawingSurfaceInfo(ds);	
  
  if ( LMJProducerFirstDraw ){
    if (!initSurface(dsi)){
      ds->FreeDrawingSurfaceInfo(dsi);	
      ds->Unlock(ds);	
      awt.FreeDrawingSurface(ds);
      pEnv->ThrowNew(runtimeException, "Could not find window handle");
      return;	
    }
    LMJProducerFirstDraw = false;
  }
  drawJavaProducer(NULL); //TODO
  
  
  // Clean up	
  ds->FreeDrawingSurfaceInfo(dsi);	
  ds->Unlock(ds);	
  awt.FreeDrawingSurface(ds);
  
  
}


bool initSurface(JAWT_DrawingSurfaceInfo* dsi){
  //Fetch the platform specific DrawingSurfaceInfo	
  /*Producer::*/
  
  
  
#if defined(_WIN32) || defined(WIN32)  
  HWND  pWindowID;
#else
  Window pWindowID;
#endif
  Producer::RenderSurface * renderSurface=new Producer::RenderSurface;
  
#if defined(_WIN32) || defined(WIN32) //Get the HWND for Windows OS
  JAWT_Win32DrawingSurfaceInfo* dsi_win = (JAWT_Win32DrawingSurfaceInfo*)dsi->platformInfo;	
  pWindowID = dsi_win->hwnd;		
#elif defined(TARGET_API_MAC_CARBON) //OSX Carbon build
  jawt_MacDrawingSurfaceInfo* dsi_mac = (jawt_MacDrawingSurfaceInfo*)dsi->platformInfo;
  pWindowID = dsi_mac->fQDWindow;
#else //X11
  JAWT_X11DrawingSurfaceInfo* dsi_x11 = (JAWT_X11DrawingSurfaceInfo*)dsi->platformInfo;	
  pWindowID = dsi_x11->drawable;	
  renderSurface->setDisplay(dsi_x11->display); //Get the X11 display too
#endif
  
  
  //Check if the handle is valid.	
  if(!pWindowID)	
    {		
      return false;	
    }
  renderSurface->setWindow(pWindowID);
  
  
  initProducerRenderSurface(renderSurface, NULL); //TODO
  
  return true;
}
