#include <jni.h> 
#include "jni_canvas_jogl_GearRenderer.h"

#include "../CookiMetier.h"
#include "../EnvironnementJava.h"

using namespace cooki3d;


//=> appel direct pour plus de performances

extern "C" JNIEXPORT void JNICALL Java_jni_canvas_jogl_GearRenderer_display
  (JNIEnv *, jobject, jobject, jlong bdId){ 

  try {
    cooki3d::BD * pBD = (cooki3d::BD*)bdId;
    assertC2( BD::checkAdrBD( pBD), NULL  );
    EnvironnementJava * ej =
      static_cast<EnvironnementJava*>( pBD->getEnv());
    
    if(ej){
      ej->appIdle();
    }
  }
  catch(AssertException e){
    CERRs("Java_jni_canvas_jogl_GearRenderer_display") 
      << "Exception AssertException caught !! "
      <<  std::endl;
    CERRnext <<e.getStackTrace()<<endl;
  }
  catch( ... ) {
    CERRs("Java_jni_canvas_jogl_GearRenderer_display")  
      << "Exception caught !! "<<  std::endl;    
  }

  
}
//TODO comparer perf.
//     jfieldID GetFieldID(jclass clazz, const char *name,
// 			const char *sig) {
//       return functions->GetFieldID(this,clazz,name,sig);
//     }
//     jint GetIntField(jobject obj, jfieldID fieldID) {
//       return functions->GetIntField(this,obj,fieldID);
//     }
